
DROP SCHEMA public CASCADE;
CREATE SCHEMA public;

DROP TABLE IF EXISTS attack_type CASCADE ;
CREATE TABLE attack_type (
id_type_attack serial PRIMARY KEY,
attack_type_name text UNIQUE NOT NULL,
attack_type_description text NOT NULL
);
INSERT INTO attack_type(attack_type_name, attack_type_description) VALUES
('fixed damage', 'Attack with fixed damage equals to its power'),
('physical attack','Attack based on the attack and defense stats'),
('special attack', 'Attack based on the spe_atk and spe_def stats'),
('status attack', 'Doesn''t deal damage but does special effect')
;
DROP SEQUENCE  IF EXISTS pokemon_id_pokemon_seq;
DROP TABLE IF EXISTS attack;
CREATE TABLE attack (
    id_attack SERIAL PRIMARY KEY,
    id_attack_type integer REFERENCES attack_type(id_type_attack),
    power integer,
    accuracy integer,
    element text,
    attack_name text UNIQUE NOT NULL,
    attack_description text
);

INSERT INTO attack(id_attack_type, power,accuracy, element, attack_name, attack_description) VALUES
(3,195, 0, 'Electric', '10,000,000 Volt Thunderbolt','Pikachu-exclusive Z-Move. High critical hit ratio.'),
(3,20, 100, 'Grass', 'Absorb','User recovers half the HP inflicted on opponent.'),
(2,40, 100, 'Rock', 'Accelerock','User attacks first.'),
(3,40, 100, 'Poison', 'Acid','May lower opponent''s Special Defense.'),
(4,0, 0, 'Poison', 'Acid Armor','Sharply raises user''s Defense.'),
(3,40, 100, 'Poison', 'Acid Spray','Sharply lowers opponent''s Special Defense.'),
(2,55, 100, 'Flying', 'Acrobatics','Stronger when the user does not have a held item.'),
(4,0, 0, 'Normal', 'Acupressure','Sharply raises a random stat.'),
(2,60, 20, 'Flying', 'Aerial Ace','Ignores Accuracy and Evasiveness.'),
(3,100, 95, 'Flying', 'Aeroblast','High critical hit ratio.'),
(4,0, 0, 'Normal', 'After You','Gives target priority in the next turn.'),
(4,0, 0, 'Psychic', 'Agility','Sharply raises user''s Speed.'),
(3,60, 95, 'Flying', 'Air Cutter','High critical hit ratio.'),
(3,75, 95, 'Flying', 'Air Slash','May cause flinching.'),
(4,0, 0, 'Psychic', 'Ally Switch','User switches with opposite teammate.'),
(4,0, 0, 'Psychic', 'Amnesia','Sharply raises user''s Special Defense.'),
(2,80, 100, 'Steel', 'Anchor Shot','The user entangles the target with its anchor chain while attacking. The target becomes unable to flee.'),
(3,60, 100, 'Rock', 'Ancient Power','May raise all user''s stats at once.'),
(3,80, 100, 'Grass', 'Apple Acid','Lowers target''s Special Defense.'),
(2,40, 100, 'Water', 'Aqua Jet','User attacks first.'),
(4,0, 0, 'Water', 'Aqua Ring','Restores a little HP each turn.'),
(2,15, 100, 'Fighting', 'Arm Thrust','Hits 2-5 times in one turn.'),
(4,0, 0, 'Grass', 'Aromatherapy','Cures all status problems in your party.'),
(4,0, 0, 'Fairy', 'Aromatic Mist','Raises Special Defense of an ally.'),
(4,0, 0, 'Normal', 'Assist','User performs a move known by its allies at random.'),
(2,60, 100, 'Dark', 'Assurance','Power doubles if opponent already took damage in the same turn.'),
(2,30, 100, 'Ghost', 'Astonish','May cause flinching.'),
(3,120, 100, 'Ghost', 'Astral Barrage','The user attacks by sending a frightful amount of small ghosts at opposing Pokémon.'),
(2,90, 100, 'Bug', 'Attack Order','High critical hit ratio.'),
(4,0, 100, 'Normal', 'Attract','If opponent is the opposite gender, it''s less likely to attack.'),
(3,80, 20, 'Fighting', 'Aura Sphere','Ignores Accuracy and Evasiveness.'),
(2,110, 100, 'Electric', 'Aura Wheel','Changes type based on Morpeko''s Mode.'),
(3,65, 100, 'Ice', 'Aurora Beam','May lower opponent''s Attack.'),
(4,0, 0, 'Ice', 'Aurora Veil','Halves damage from Physical and Special attacks for five turns.'),
(4,0, 0, 'Steel', 'Autotomize','Reduces weight and sharply raises Speed.'),
(2,60, 100, 'Ice', 'Avalanche','Power doubles if user took damage first.'),
(4,0, 100, 'Fairy', 'Baby-Doll Eyes','Always goes first. Lowers the target''s attack.'),
(3,90, 100, 'Dark', 'Baddy Bad','Reduces damage from Physical attacks.'),
(4,0, 0, 'Poison', 'Baneful Bunker','Protects the user and poisons opponent on contact.'),
(2,15, 85, 'Normal', 'Barrage','Hits 2-5 times in one turn.'),
(4,0, 0, 'Psychic', 'Barrier','Sharply raises user''s Defense.'),
(4,0, 0, 'Normal', 'Baton Pass','User switches out and gives stat changes to the incoming Pokémon.'),
(2,100, 100, 'Flying', 'Beak Blast','The user first heats up its beak, and then it attacks the target. Making direct contact with the Pokémon while it''s heating up its beak results in a burn.'),
(2,0, 100, 'Dark', 'Beat Up','Each Pokémon in user''s party attacks.'),
(2,100, 100, 'Steel', 'Behemoth Bash','Damage doubles if target is Dynamaxed.'),
(2,100, 100, 'Steel', 'Behemoth Blade','Damage doubles if target is Dynamaxed.'),
(3,120, 90, 'Poison', 'Belch','User must have consumed a Berry.'),
(4,0, 0, 'Normal', 'Belly Drum','User loses 50% of its max HP, but Attack raises to maximum.'),
(4,0, 0, 'Normal', 'Bestow','Gives the user''s held item to the target.'),
(2,0, 0, 'Normal', 'Bide','User takes damage for two turns then strikes back double.'),
(2,15, 85, 'Normal', 'Bind','Traps opponent, damaging them for 4-5 turns.'),
(2,60, 100, 'Dark', 'Bite','May cause flinching.'),
(3,150, 90, 'Fire', 'Blast Burn','User must recharge next turn.'),
(2,85, 90, 'Fire', 'Blaze Kick','High critical hit ratio. May burn opponent.'),
(3,110, 70, 'Ice', 'Blizzard','May freeze opponent.'),
(4,0, 0, 'Normal', 'Block','Opponent cannot flee or switch.'),
(3,130, 85, 'Fire', 'Blue Flare','May burn opponent.'),
(2,80, 100, 'Fighting', 'Body Press','The higher the user''s Defense, the stronger the attack.'),
(2,85, 100, 'Normal', 'Body Slam','May paralyze opponent.'),
(2,85, 100, 'Electric', 'Bolt Beak','If the user attacks before the target, the power of this move is doubled.'),
(2,130, 85, 'Electric', 'Bolt Strike','May paralyze opponent.'),
(2,65, 85, 'Ground', 'Bone Club','May cause flinching.'),
(2,25, 90, 'Ground', 'Bone Rush','Hits 2-5 times in one turn.'),
(2,50, 90, 'Ground', 'Bonemerang','Hits twice in one turn.'),
(3,140, 100, 'Normal', 'Boomburst','Hits all adjacent Pokémon.'),
(2,85, 85, 'Flying', 'Bounce','Springs up on first turn, attacks on second. May paralyze opponent.'),
(3,90, 100, 'Water', 'Bouncy Bubble','User recovers half the HP inflicted on opponent.'),
(2,120, 100, 'Flying', 'Brave Bird','User receives recoil damage.'),
(2,60, 100, 'Dragon', 'Breaking Swipe','Hits multiple opponents and lowers their attack.'),
(2,75, 100, 'Fighting', 'Brick Break','Breaks through Reflect and Light Screen barriers.'),
(3,65, 100, 'Water', 'Brine','Power doubles if opponent''s HP is less than 50%.'),
(2,60, 100, 'Dark', 'Brutal Swing','The user swings its body around violently to inflict damage on everything in its vicinity.'),
(3,40, 100, 'Water', 'Bubble','May lower opponent''s Speed.'),
(3,65, 100, 'Water', 'Bubble Beam','May lower opponent''s Speed.'),
(2,60, 100, 'Bug', 'Bug Bite','Receives the effect from the opponent''s held berry.'),
(3,90, 100, 'Bug', 'Bug Buzz','May lower opponent''s Special Defense.'),
(4,0, 0, 'Fighting', 'Bulk Up','Raises user''s Attack and Defense.'),
(2,60, 100, 'Ground', 'Bulldoze','Lowers opponent''s Speed.'),
(2,40, 100, 'Steel', 'Bullet Punch','User attacks first.'),
(2,25, 100, 'Grass', 'Bullet Seed','Hits 2-5 times in one turn.'),
(3,130, 100, 'Fire', 'Burn Up','To inflict massive damage, the user burns itself out. After using this move, the user will no longer be Fire type.'),
(3,70, 100, 'Fire', 'Burning Jealousy','Hits all opponents, and burns any that have had their stats boosted.'),
(3,90, 100, 'Electric', 'Buzzy Buzz','Paralyzes the opponent.'),
(4,0, 0, 'Psychic', 'Calm Mind','Raises user''s Special Attack and Special Defense.'),
(4,0, 0, 'Normal', 'Camouflage','Changes user''s type according to the location.'),
(4,0, 100, 'Normal', 'Captivate','Sharply lowers opponent''s Special Attack if opposite gender.'),
(2,210, 0, 'Electric', 'Catastropika','Pikachu-exclusive Z-Move.'),
(4,0, 0, 'Normal', 'Celebrate','The Pokémon congratulates you on your special day. No battle effect.'),
(4,0, 0, 'Electric', 'Charge','Raises user''s Special Defense and next Electric move''s power increases.'),
(3,50, 90, 'Electric', 'Charge Beam','May raise user''s Special Attack.'),
(4,0, 100, 'Fairy', 'Charm','Sharply lowers opponent''s Attack.'),
(3,65, 100, 'Flying', 'Chatter','Confuses opponent.'),
(2,70, 100, 'Normal', 'Chip Away','Ignores opponent''s stat changes.'),
(2,60, 90, 'Fighting', 'Circle Throw','In battles, the opponent switches. In the wild, the Pokémon runs.'),
(2,35, 85, 'Water', 'Clamp','Traps opponent, damaging them for 4-5 turns.'),
(3,110, 100, 'Dragon', 'Clanging Scales','Lowers user''s Defense.'),
(4,0, 100, 'Dragon', 'Clangorous Soul','Raises all user''s stats but loses HP.'),
(3,185, 0, 'Dragon', 'Clangorous Soulblaze','Kommo-o exclusive Z-Move.'),
(3,50, 0, 'Poison', 'Clear Smog','Removes all of the target''s stat changes.'),
(2,120, 100, 'Fighting', 'Close Combat','Lowers user''s Defense and Special Defense.'),
(4,0, 0, 'Fighting', 'Coaching','Boosts Attack and Defense of a teammate.'),
(4,0, 0, 'Poison', 'Coil','Raises user''s Attack, Defense and Accuracy.'),
(2,18, 85, 'Normal', 'Comet Punch','Hits 2-5 times in one turn.'),
(4,0, 0, 'Normal', 'Confide','Lowers opponent''s Special Attack.'),
(4,0, 100, 'Ghost', 'Confuse Ray','Confuses opponent.'),
(3,50, 100, 'Psychic', 'Confusion','May confuse opponent.'),
(2,10, 100, 'Normal', 'Constrict','May lower opponent''s Speed by one stage.'),
(4,0, 0, 'Normal', 'Conversion','Changes user''s type to that of its first move.'),
(4,0, 0, 'Normal', 'Conversion 2','User changes type to become resistant to opponent''s last move.'),
(4,0, 0, 'Normal', 'Copycat','Copies opponent''s last move.'),
(3,100, 100, 'Dragon', 'Core Enforcer','Scorches a ''Z'' pattern on the ground.'),
(4,0, 100, 'Poison', 'Corrosive Gas','Removes opponent''s items.'),
(4,0, 0, 'Psychic', 'Cosmic Power','Raises user''s Defense and Special Defense.'),
(4,0, 0, 'Grass', 'Cotton Guard','Drastically raises user''s Defense.'),
(4,0, 100, 'Grass', 'Cotton Spore','Sharply lowers opponent''s Speed.'),
(2,0, 100, 'Fighting', 'Counter','When hit by a Physical Attack, user strikes back with 2x power.'),
(4,0, 100, 'Normal', 'Court Change','Swaps the effects on either side of the field.'),
(2,60, 100, 'Normal', 'Covet','Opponent''s item is stolen by the user.'),
(2,100, 90, 'Water', 'Crabhammer','High critical hit ratio.'),
(4,0, 0, 'Fairy', 'Crafty Shield','Protects the Pokémon from status moves.'),
(2,100, 80, 'Fighting', 'Cross Chop','High critical hit ratio.'),
(2,70, 100, 'Poison', 'Cross Poison','High critical hit ratio. May poison opponent.'),
(2,80, 100, 'Dark', 'Crunch','May lower opponent''s Defense.'),
(2,75, 95, 'Normal', 'Crush Claw','May lower opponent''s Defense.'),
(2,0, 100, 'Normal', 'Crush Grip','More powerful when opponent has higher HP.'),
(4,0, 0, 'Ghost', 'Curse','Ghosts lose 50% of max HP and curse the opponent; Non-Ghosts raise Attack, Defense and lower Speed.'),
(3,80, 100, 'Dark', 'Dark Pulse','May cause flinching.'),
(4,0, 50, 'Dark', 'Dark Void','Puts all adjacent opponents to sleep.'),
(2,85, 100, 'Dark', 'Darkest Lariat','Ignores opponent''s stat changes.'),
(3,80, 100, 'Fairy', 'Dazzling Gleam','Hits all adjacent opponents.'),
(4,0, 0, 'Fairy', 'Decorate','Sharply raises target''s Attack and Special Attack.'),
(4,0, 0, 'Bug', 'Defend Order','Raises user''s Defense and Special Defense.'),
(4,0, 0, 'Normal', 'Defense Curl','Raises user''s Defense.'),
(4,0, 0, 'Flying', 'Defog','Lowers opponent''s Evasiveness and clears fog.'),
(4,0, 0, 'Ghost', 'Destiny Bond','If the user faints, the opponent also faints.'),
(4,0, 0, 'Fighting', 'Detect','Protects the user, but may fail if used consecutively.'),
(2,100, 95, 'Rock', 'Diamond Storm','May sharply raise user''s Defense.'),
(2,80, 100, 'Ground', 'Dig','Digs underground on first turn, attacks on second. Can also escape from caves.'),
(4,0, 100, 'Normal', 'Disable','Opponent can''t use its last attack for a few turns.'),
(3,40, 15, 'Fairy', 'Disarming Voice','Ignores Accuracy and Evasiveness.'),
(3,80, 100, 'Electric', 'Discharge','May paralyze opponent.'),
(2,80, 100, 'Water', 'Dive','Dives underwater on first turn, attacks on second turn.'),
(2,70, 100, 'Normal', 'Dizzy Punch','May confuse opponent.'),
(3,140, 100, 'Steel', 'Doom Desire','Damage occurs 2 turns later.'),
(2,35, 90, 'Normal', 'Double Hit','Hits twice in one turn.'),
(2,60, 100, 'Steel', 'Double Iron Bash','Hits twice in one turn; may cause flinching.'),
(2,30, 100, 'Fighting', 'Double Kick','Hits twice in one turn.'),
(2,15, 85, 'Normal', 'Double Slap','Hits 2-5 times in one turn.'),
(4,0, 0, 'Normal', 'Double Team','Raises user''s Evasiveness.'),
(2,120, 100, 'Normal', 'Double-Edge','User receives recoil damage.'),
(3,130, 90, 'Dragon', 'Draco Meteor','Sharply lowers user''s Special Attack.'),
(2,120, 100, 'Flying', 'Dragon Ascent','Lowers user''s Defense and Special Defense.'),
(3,60, 100, 'Dragon', 'Dragon Breath','May paralyze opponent.'),
(4,0, 0, 'Dragon', 'Dragon Dance','Raises user''s Attack and Speed.'),
(2,50, 100, 'Dragon', 'Dragon Darts','User attacks twice.'),
(3,150, 100, 'Dragon', 'Dragon Energy','The higher the user''s HP, the higher the power.'),
(2,90, 100, 'Dragon', 'Dragon Hammer','The user uses its body like a hammer to attack the target and inflict damage.'),
(1,0, 100, 'Dragon', 'Dragon Rage','Always inflicts 40 HP.'),
(2,100, 75, 'Dragon', 'Dragon Rush','May cause flinching.'),
(2,60, 90, 'Dragon', 'Dragon Tail','In battles, the opponent switches. In the wild, the Pokémon runs.'),
(2,75, 100, 'Fighting', 'Drain Punch','User recovers half the HP inflicted on opponent.'),
(3,50, 100, 'Fairy', 'Draining Kiss','User recovers most the HP inflicted on opponent.'),
(3,100, 100, 'Psychic', 'Dream Eater','User recovers half the HP inflicted on a sleeping opponent.'),
(2,80, 95, 'Ground', 'Drill Run','High critical hit ratio.'),
(2,80, 100, 'Grass', 'Drum Beating','Lowers opponent''s Speed.'),
(2,40, 90, 'Dragon', 'Dual Chop','Hits twice in one turn.'),
(2,40, 90, 'Flying', 'Dual Wingbeat','The user slams the target with its wings. The target is hit twice in a row.'),
(3,100, 100, 'Dragon', 'Dynamax Cannon','Damage doubles if opponent is Dynamaxed.'),
(2,100, 50, 'Fighting', 'Dynamic Punch','Confuses opponent.'),
(3,90, 100, 'Ground', 'Earth Power','May lower opponent''s Special Defense.'),
(2,100, 100, 'Ground', 'Earthquake','Power is doubled if opponent is underground from using Dig.'),
(3,40, 100, 'Normal', 'Echoed Voice','Power increases each turn.'),
(4,0, 100, 'Electric', 'Eerie Impulse','Sharply lowers opponent''s Special Attack.'),
(3,80, 100, 'Psychic', 'Eerie Spell','Deals damage and reduces opponent''s PP.'),
(4,0, 0, 'Electric', 'Electric Terrain','Prevents all Pokémon from falling asleep for 5 turns.'),
(4,0, 0, 'Electric', 'Electrify','Changes the target''s move to Electric type.'),
(3,0, 100, 'Electric', 'Electro Ball','The faster the user, the stronger the attack.'),
(3,55, 95, 'Electric', 'Electroweb','Lowers opponent''s Speed.'),
(4,0, 100, 'Dark', 'Embargo','Opponent cannot use items.'),
(3,40, 100, 'Fire', 'Ember','May burn opponent.'),
(4,0, 100, 'Normal', 'Encore','Forces opponent to keep using its last move for 3 turns.'),
(2,0, 100, 'Normal', 'Endeavor','Reduces opponent''s HP to same as user''s.'),
(4,0, 0, 'Normal', 'Endure','Always left with at least 1 HP, but may fail if used consecutively.'),
(3,90, 100, 'Grass', 'Energy Ball','May lower opponent''s Special Defense.'),
(4,0, 100, 'Normal', 'Entrainment','Makes target''s ability same as user''s.'),
(3,150, 100, 'Fire', 'Eruption','Stronger when the user''s HP is higher.'),
(3,160, 90, 'Dragon', 'Eternabeam','User can''t move on the next turn.'),
(3,80, 100, 'Psychic', 'Expanding Force','Increases power and hits all opponents on Psychic Terrain.'),
(2,250, 100, 'Normal', 'Explosion','User faints.'),
(3,80, 100, 'Psychic', 'Extrasensory','May cause flinching.'),
(4,0, 0, 'Normal', 'Extreme Evoboost','Eevee-exclusive Z-Move. Sharply raises all stats.'),
(2,80, 100, 'Normal', 'Extreme Speed','User attacks first.'),
(2,70, 100, 'Normal', 'Facade','Power doubles if user is burned, poisoned, or paralyzed.'),
(4,0, 0, 'Fairy', 'Fairy Lock','Prevents fleeing in the next turn.'),
(2,40, 100, 'Normal', 'Fake Out','User attacks first, foe flinches. Only usable on first turn.'),
(4,0, 100, 'Dark', 'Fake Tears','Sharply lowers opponent''s Special Defense.'),
(2,80, 10, 'Dark', 'False Surrender','Ignores Accuracy and Evasiveness.'),
(2,40, 100, 'Normal', 'False Swipe','Always leaves opponent with at least 1 HP.'),
(4,0, 100, 'Flying', 'Feather Dance','Sharply lowers opponent''s Attack.'),
(2,30, 100, 'Normal', 'Feint','Only hits if opponent uses Protect or Detect in the same turn.'),
(2,60, 20, 'Dark', 'Feint Attack','Ignores Accuracy and Evasiveness.'),
(2,50, 100, 'Bug', 'Fell Stinger','Drastically raises user''s Attack if target is KO''d.'),
(3,80, 100, 'Fire', 'Fiery Dance','May raise user''s Special Attack.'),
(3,90, 100, 'Dark', 'Fiery Wrath','May cause flinching.'),
(3,0, 100, 'Fighting', 'Final Gambit','Inflicts damage equal to the user''s remaining HP. User faints.'),
(3,110, 85, 'Fire', 'Fire Blast','May burn opponent.'),
(2,65, 95, 'Fire', 'Fire Fang','May cause flinching and/or burn opponent.'),
(2,80, 100, 'Fire', 'Fire Lash','The user strikes the target with a burning lash. This also lowers the target''s Defense stat.'),
(3,80, 100, 'Fire', 'Fire Pledge','Added effects appear if combined with Grass Pledge or Water Pledge.'),
(2,75, 100, 'Fire', 'Fire Punch','May burn opponent.'),
(3,35, 85, 'Fire', 'Fire Spin','Traps opponent, damaging them for 4-5 turns.'),
(2,90, 100, 'Bug', 'First Impression','Although this move has great power, it only works the first turn the user is in battle.'),
(2,85, 100, 'Water', 'Fishious Rend','If the user attacks before the target, the power of this move is doubled.'),
(2,0, 30, 'Ground', 'Fissure','One-Hit-KO, if it hits.'),
(2,0, 100, 'Normal', 'Flail','The lower the user''s HP, the higher the power.'),
(3,70, 100, 'Fire', 'Flame Burst','May also injure nearby Pokémon.'),
(2,50, 100, 'Fire', 'Flame Charge','Raises user''s Speed.'),
(2,60, 100, 'Fire', 'Flame Wheel','May burn opponent.'),
(3,90, 100, 'Fire', 'Flamethrower','May burn opponent.'),
(2,120, 100, 'Fire', 'Flare Blitz','User receives recoil damage. May burn opponent.'),
(4,0, 100, 'Normal', 'Flash','Lowers opponent''s Accuracy.'),
(3,80, 100, 'Steel', 'Flash Cannon','May lower opponent''s Special Defense.'),
(4,0, 100, 'Dark', 'Flatter','Confuses opponent, but raises its Special Attack by two stages.'),
(3,130, 90, 'Fairy', 'Fleur Cannon','Sharply lowers user''s Special Attack.'),
(2,0, 100, 'Dark', 'Fling','Power depends on held item.'),
(2,60, 100, 'Water', 'Flip Turn','After making its attack, the user rushes back to switch places with a party Pokémon in waiting.'),
(2,90, 95, 'Flying', 'Floaty Fall','May cause flinching.'),
(4,0, 0, 'Fairy', 'Floral Healing','The user restores the target''s HP by up to half of its max HP. It restores more HP when the terrain is grass.'),
(4,0, 0, 'Fairy', 'Flower Shield','Sharply raises Defense of all Grass-type Pokémon on the field.'),
(2,90, 95, 'Flying', 'Fly','Flies up on first turn, attacks on second turn.'),
(2,100, 95, 'Fighting', 'Flying Press','Deals Fighting and Flying type damage.'),
(3,120, 70, 'Fighting', 'Focus Blast','May lower opponent''s Special Defense.'),
(4,0, 0, 'Normal', 'Focus Energy','Increases critical hit ratio.'),
(2,150, 100, 'Fighting', 'Focus Punch','If the user is hit before attacking, it flinches instead.'),
(4,0, 0, 'Normal', 'Follow Me','In Double Battle, the user takes all the attacks.'),
(2,60, 100, 'Fighting', 'Force Palm','May paralyze opponent.'),
(4,0, 0, 'Normal', 'Foresight','Resets opponent''s Evasiveness, Normal-type and Fighting-type attacks can now hit Ghosts, and Ghost-type attacks hit Normal.'),
(4,0, 100, 'Grass', 'Forest''s Curse','Adds Grass type to opponent.'),
(2,95, 100, 'Dark', 'Foul Play','Uses the opponent''s Attack stat.'),
(2,140, 90, 'Ice', 'Freeze Shock','Charges on first turn, attacks on second. May paralyze opponent.'),
(3,70, 100, 'Ice', 'Freeze-Dry','May freeze opponent. Super-effective against Water types.'),
(3,90, 100, 'Psychic', 'Freezing Glare','May freeze opponent.'),
(3,90, 100, 'Ice', 'Freezy Frost','Resets all stat changes.'),
(3,150, 90, 'Grass', 'Frenzy Plant','User must recharge next turn.'),
(3,60, 90, 'Ice', 'Frost Breath','Always results in a critical hit.'),
(2,0, 100, 'Normal', 'Frustration','Power decreases with higher Friendship.'),
(2,15, 85, 'Normal', 'Fury Attack','Hits 2-5 times in one turn.'),
(2,40, 95, 'Bug', 'Fury Cutter','Power increases each turn.'),
(2,18, 80, 'Normal', 'Fury Swipes','Hits 2-5 times in one turn.'),
(2,100, 100, 'Electric', 'Fusion Bolt','Power increases if Fusion Flare is used in the same turn.'),
(3,100, 100, 'Fire', 'Fusion Flare','Power increases if Fusion Bolt is used in the same turn.'),
(3,120, 100, 'Psychic', 'Future Sight','Damage occurs 2 turns later.'),
(4,0, 100, 'Poison', 'Gastro Acid','Cancels out the effect of the opponent''s Ability.'),
(2,50, 85, 'Steel', 'Gear Grind','Hits twice in one turn.'),
(4,0, 0, 'Steel', 'Gear Up','The user engages its gears to raise the Attack and Sp. Atk stats of ally Pokémon with the Plus or Minus Ability.'),
(3,185, 0, 'Psychic', 'Genesis Supernova','Mew-exclusive Z-Move.'),
(4,0, 0, 'Fairy', 'Geomancy','Charges on first turn, sharply raises user''s Sp. Attack, Sp. Defense and Speed on the second.'),
(3,75, 100, 'Grass', 'Giga Drain','User recovers half the HP inflicted on opponent.'),
(2,150, 90, 'Normal', 'Giga Impact','User must recharge next turn.'),
(2,130, 100, 'Ice', 'Glacial Lance','The user attacks by hurling a blizzard-cloaked icicle lance at opposing Pokémon.'),
(3,65, 95, 'Ice', 'Glaciate','Lowers opponent''s Speed.'),
(4,0, 100, 'Normal', 'Glare','Paralyzes opponent.'),
(3,90, 100, 'Psychic', 'Glitzy Glow','Reduces damage from Special attacks.'),
(3,0, 100, 'Grass', 'Grass Knot','The heavier the opponent, the stronger the attack.'),
(3,80, 100, 'Grass', 'Grass Pledge','Added effects appear if preceded by Water Pledge or succeeded by Fire Pledge.'),
(4,0, 55, 'Grass', 'Grass Whistle','Puts opponent to sleep.'),
(2,70, 100, 'Grass', 'Grassy Glide','High priority during Grassy Terrain.'),
(4,0, 0, 'Grass', 'Grassy Terrain','Restores a little HP of all Pokémon for 5 turns. '),
(2,80, 100, 'Grass', 'Grav Apple','Lowers the opponent''s Defense stat.'),
(4,0, 0, 'Psychic', 'Gravity','Prevents moves like Fly and Bounce and the Ability Levitate for 5 turns.'),
(4,0, 100, 'Normal', 'Growl','Lowers opponent''s Attack.'),
(4,0, 0, 'Normal', 'Growth','Raises user''s Attack and Special Attack.'),
(4,0, 0, 'Ghost', 'Grudge','If the users faints after using this move, the PP for the opponent''s last move is depleted.'),
(4,0, 0, 'Psychic', 'Guard Split','Averages Defense and Special Defense with the target.'),
(4,0, 0, 'Psychic', 'Guard Swap','User and opponent swap Defense and Special Defense.'),
(3,0, 0, 'Fairy', 'Guardian of Alola','Tapu-exclusive Z-move. Cuts opponent''s HP by 75%.'),
(2,0, 30, 'Normal', 'Guillotine','One-Hit-KO, if it hits.'),
(2,120, 80, 'Poison', 'Gunk Shot','May poison opponent.'),
(3,40, 100, 'Flying', 'Gust','Hits Pokémon using Fly/Bounce with double power.'),
(2,0, 100, 'Steel', 'Gyro Ball','The slower the user, the stronger the attack.'),
(4,0, 0, 'Ice', 'Hail','Non-Ice types are damaged for 5 turns.'),
(2,100, 90, 'Fighting', 'Hammer Arm','Lowers user''s Speed.'),
(4,0, 0, 'Normal', 'Happy Hour','Doubles prize money from trainer battles.'),
(4,0, 0, 'Normal', 'Harden','Raises user''s Defense.'),
(4,0, 0, 'Ice', 'Haze','Resets all stat changes.'),
(2,120, 100, 'Normal', 'Head Charge','User receives recoil damage.'),
(2,150, 80, 'Rock', 'Head Smash','User receives recoil damage.'),
(2,70, 100, 'Normal', 'Headbutt','May cause flinching.'),
(4,0, 0, 'Normal', 'Heal Bell','Heals the user''s party''s status conditions.'),
(4,0, 100, 'Psychic', 'Heal Block','Prevents the opponent from restoring HP for 5 turns.'),
(4,0, 0, 'Bug', 'Heal Order','User recovers half its max HP.'),
(4,0, 0, 'Psychic', 'Heal Pulse','Restores half the target''s max HP.'),
(4,0, 0, 'Psychic', 'Healing Wish','The user faints and the next Pokémon released is fully healed.'),
(2,60, 100, 'Psychic', 'Heart Stamp','May cause flinching.'),
(4,0, 0, 'Psychic', 'Heart Swap','Stat changes are swapped with the opponent.'),
(2,0, 100, 'Fire', 'Heat Crash','The heavier the user, the stronger the attack.'),
(3,95, 90, 'Fire', 'Heat Wave','May burn opponent.'),
(2,0, 100, 'Steel', 'Heavy Slam','The heavier the user, the stronger the attack.'),
(4,0, 0, 'Normal', 'Helping Hand','In Double Battles, boosts the power of the partner''s move.'),
(3,65, 100, 'Ghost', 'Hex','Inflicts more damage if the target has a status condition.'),
(3,60, 100, 'Normal', 'Hidden Power','Type and power depends on user''s IVs.'),
(2,95, 95, 'Ground', 'High Horsepower','The user fiercely attacks the target using its entire body.'),
(2,130, 90, 'Fighting', 'High Jump Kick','If it misses, the user loses half their HP.'),
(2,40, 100, 'Normal', 'Hold Back','Always leaves opponent with at least 1 HP.'),
(4,0, 0, 'Normal', 'Hold Hands','Makes the user and an ally very happy.'),
(4,0, 0, 'Dark', 'Hone Claws','Raises user''s Attack and Accuracy.'),
(2,0, 30, 'Normal', 'Horn Drill','One-Hit-KO, if it hits.'),
(2,75, 100, 'Grass', 'Horn Leech','User recovers half the HP inflicted on opponent.'),
(4,0, 0, 'Normal', 'Howl','Raises Attack of allies.'),
(3,110, 70, 'Flying', 'Hurricane','May confuse opponent.'),
(3,150, 90, 'Water', 'Hydro Cannon','User must recharge next turn.'),
(3,150, 90, 'Normal', 'Hyper Beam','User must recharge next turn.'),
(2,80, 90, 'Normal', 'Hyper Fang','May cause flinching.'),
(2,100, 5, 'Dark', 'Hyperspace Fury','Lowers user''s Defense. Can strike through Protect/Detect.'),
(3,80, 5, 'Psychic', 'Hyperspace Hole','Can strike through Protect/Detect.'),
(4,0, 60, 'Psychic', 'Hypnosis','Puts opponent to sleep.'),
(2,30, 90, 'Ice', 'Ice Ball','Doubles in power each turn for 5 turns.'),
(3,90, 100, 'Ice', 'Ice Beam','May freeze opponent.'),
(3,140, 90, 'Ice', 'Ice Burn','Charges on first turn, attacks on second. May burn opponent.'),
(2,65, 95, 'Ice', 'Ice Fang','May cause flinching and/or freeze opponent.'),
(2,100, 90, 'Ice', 'Ice Hammer','The user swings and hits with its strong, heavy fist. It lowers the user''s Speed, however.'),
(2,75, 100, 'Ice', 'Ice Punch','May freeze opponent.'),
(2,40, 100, 'Ice', 'Ice Shard','User attacks first.'),
(2,85, 90, 'Ice', 'Icicle Crash','May cause flinching.'),
(2,25, 100, 'Ice', 'Icicle Spear','Hits 2-5 times in one turn.'),
(3,55, 95, 'Ice', 'Icy Wind','Lowers opponent''s Speed.'),
(4,0, 0, 'Psychic', 'Imprison','Opponent is unable to use moves that the user also knows.'),
(3,60, 100, 'Fire', 'Incinerate','Destroys the target''s held berry.'),
(3,100, 50, 'Fire', 'Inferno','Burns opponent.'),
(3,20, 100, 'Bug', 'Infestation','Traps opponent, damaging them for 4-5 turns.'),
(4,0, 0, 'Grass', 'Ingrain','User restores HP each turn. User cannot escape/switch.'),
(4,0, 0, 'Psychic', 'Instruct','Allows an ally to use a move instead.'),
(4,0, 0, 'Electric', 'Ion Deluge','Changes Normal-type moves to Electric-type.'),
(4,0, 0, 'Steel', 'Iron Defense','Sharply raises user''s Defense.'),
(2,80, 100, 'Steel', 'Iron Head','May cause flinching.'),
(2,100, 75, 'Steel', 'Iron Tail','May lower opponent''s Defense.'),
(2,80, 100, 'Dark', 'Jaw Lock','Prevents user and opponent from switching out.'),
(3,100, 100, 'Normal', 'Judgment','Type depends on the Arceus Plate being held.'),
(2,100, 95, 'Fighting', 'Jump Kick','If it misses, the user loses half their HP.'),
(4,0, 0, 'Grass', 'Jungle Healing','Restores team''s HP and cures status conditions.'),
(2,50, 100, 'Fighting', 'Karate Chop','High critical hit ratio.'),
(4,0, 80, 'Psychic', 'Kinesis','Lowers opponent''s Accuracy.'),
(4,0, 0, 'Steel', 'King''s Shield','Protects the user and lowers opponent''s Attack on contact.'),
(2,65, 100, 'Dark', 'Knock Off','Removes opponent''s held item for the rest of the battle.'),
(4,0, 0, 'Normal', 'Laser Focus','User''s next attack is guaranteed to result in a critical hit.'),
(2,75, 100, 'Dark', 'Lash Out','Double power if stats were lowered during the turn.'),
(2,140, 100, 'Normal', 'Last Resort','Can only be used after all other moves are used.'),
(3,80, 100, 'Fire', 'Lava Plume','May burn opponent.'),
(2,90, 100, 'Grass', 'Leaf Blade','High critical hit ratio.'),
(3,130, 90, 'Grass', 'Leaf Storm','Sharply lowers user''s Special Attack.'),
(3,65, 90, 'Grass', 'Leaf Tornado','May lower opponent''s Accuracy.'),
(2,40, 100, 'Grass', 'Leafage','Strikes opponent with leaves.'),
(2,80, 100, 'Bug', 'Leech Life','User recovers half the HP inflicted on opponent.'),
(4,0, 90, 'Grass', 'Leech Seed','Drains HP from opponent each turn.'),
(4,0, 100, 'Normal', 'Leer','Lowers opponent''s Defense.'),
(2,190, 0, 'Fairy', 'Let''s Snuggle Forever','Mimikyu-exclusive Z-Move.'),
(2,30, 100, 'Ghost', 'Lick','May paralyze opponent.'),
(4,0, 0, 'Water', 'Life Dew','User and teammates recover HP.'),
(3,140, 90, 'Fairy', 'Light of Ruin','User receives recoil damage.'),
(4,0, 0, 'Psychic', 'Light Screen','Halves damage from Special attacks for 5 turns.'),
(3,200, 0, 'Psychic', 'Light That Burns the Sky','Ultra Necrozma-exclusive Z-Move. Ignores target''s ability; uses highest Attack stat.'),
(2,85, 100, 'Water', 'Liquidation','May lower opponent''s Defense.'),
(4,0, 0, 'Normal', 'Lock-On','User''s next attack is guaranteed to hit.'),
(4,0, 75, 'Normal', 'Lovely Kiss','Puts opponent to sleep.'),
(2,0, 100, 'Fighting', 'Low Kick','The heavier the opponent, the stronger the attack.'),
(2,65, 100, 'Fighting', 'Low Sweep','Lowers opponent''s Speed.'),
(4,0, 0, 'Normal', 'Lucky Chant','Opponent cannot land critical hits for 5 turns.'),
(4,0, 0, 'Psychic', 'Lunar Dance','The user faints but the next Pokémon released is fully healed.'),
(2,80, 100, 'Bug', 'Lunge','The user makes a lunge at the target, attacking with full force. This also lowers the target''s Attack stat.'),
(3,70, 100, 'Psychic', 'Luster Purge','May lower opponent''s Special Defense.'),
(2,40, 100, 'Fighting', 'Mach Punch','User attacks first.'),
(4,0, 0, 'Psychic', 'Magic Coat','Reflects moves that cause status conditions back to the attacker.'),
(4,0, 100, 'Psychic', 'Magic Powder','Changes target''s type to Psychic.'),
(4,0, 0, 'Psychic', 'Magic Room','Suppresses the effects of held items for five turns.'),
(3,60, 20, 'Grass', 'Magical Leaf','Ignores Accuracy and Evasiveness.'),
(3,100, 75, 'Fire', 'Magma Storm','Traps opponent, damaging them for 4-5 turns.'),
(2,60, 20, 'Steel', 'Magnet Bomb','Ignores Accuracy and Evasiveness.'),
(4,0, 0, 'Electric', 'Magnet Rise','User becomes immune to Ground-type moves for 5 turns.'),
(4,0, 0, 'Electric', 'Magnetic Flux','Raises Defense and Sp. Defense of Plus/Minus Pokémon.'),
(2,0, 100, 'Ground', 'Magnitude','Hits with random power.'),
(2,180, 0, 'Dark', 'Malicious Moonsault','Incineroar-exclusive Z-Move.'),
(4,0, 0, 'Fighting', 'Mat Block','Protects teammates from damaging moves.'),
(4,0, 0, 'Normal', 'Me First','User copies the opponent''s attack with 1.5× power.'),
(4,0, 0, 'Normal', 'Mean Look','Opponent cannot flee or switch.'),
(4,0, 0, 'Psychic', 'Meditate','Raises user''s Attack.'),
(3,40, 100, 'Grass', 'Mega Drain','User recovers half the HP inflicted on opponent.'),
(4,0, 100, 'Dark', 'Memento','User faints, sharply lowers opponent''s Attack and Special Attack.'),
(3,200, 0, 'Ghost', 'Menacing Moonraze Maelstrom','Lunala-exclusive Z-Move.'),
(2,0, 100, 'Steel', 'Metal Burst','Deals damage equal to 1.5x opponent''s attack.'),
(2,50, 95, 'Steel', 'Metal Claw','May raise user''s Attack.'),
(4,0, 85, 'Steel', 'Metal Sound','Sharply lowers opponent''s Special Defense.'),
(2,150, 100, 'Fighting', 'Meteor Assault','User must recharge next turn.'),
(3,120, 90, 'Rock', 'Meteor Beam','User gathers space power and boosts its Sp. Atk stat, then attacks the target on the next turn.'),
(2,90, 90, 'Steel', 'Meteor Mash','May raise user''s Attack.'),
(4,0, 0, 'Normal', 'Metronome','User performs almost any move in the game at random.'),
(4,0, 0, 'Normal', 'Milk Drink','User recovers half its max HP.'),
(4,0, 0, 'Normal', 'Mimic','Copies the opponent''s last move.'),
(3,150, 100, 'Fire', 'Mind Blown','User receives recoil damage.'),
(4,0, 0, 'Normal', 'Mind Reader','User''s next attack is guaranteed to hit.'),
(4,0, 0, 'Normal', 'Minimize','Sharply raises user''s Evasiveness.'),
(4,0, 0, 'Psychic', 'Miracle Eye','Resets opponent''s Evasiveness, removes Dark''s Psychic immunity.'),
(3,0, 100, 'Psychic', 'Mirror Coat','When hit by a Special Attack, user strikes back with 2x power.'),
(4,0, 0, 'Flying', 'Mirror Move','User performs the opponent''s last move.'),
(3,65, 85, 'Steel', 'Mirror Shot','May lower opponent''s Accuracy.'),
(4,0, 0, 'Ice', 'Mist','User''s stats cannot be changed for a period of time.'),
(3,70, 100, 'Psychic', 'Mist Ball','May lower opponent''s Special Attack.'),
(3,100, 100, 'Fairy', 'Misty Explosion','Power increases on Misty Terrain.'),
(4,0, 0, 'Fairy', 'Misty Terrain','Protects the field from status conditions for 5 turns.'),
(3,95, 100, 'Fairy', 'Moonblast','May lower opponent''s Special Attack.'),
(3,100, 100, 'Ghost', 'Moongeist Beam','Ignores the target''s ability.'),
(4,0, 0, 'Fairy', 'Moonlight','User recovers HP. Amount varies with the weather.'),
(4,0, 0, 'Normal', 'Morning Sun','User recovers HP. Amount varies with the weather.'),
(3,65, 85, 'Ground', 'Mud Bomb','May lower opponent''s Accuracy.'),
(3,55, 95, 'Ground', 'Mud Shot','Lowers opponent''s Speed.'),
(4,0, 0, 'Ground', 'Mud Sport','Weakens the power of Electric-type moves.'),
(3,20, 100, 'Ground', 'Mud-Slap','Lowers opponent''s Accuracy.'),
(3,90, 85, 'Water', 'Muddy Water','May lower opponent''s Accuracy.'),
(2,120, 100, 'Normal', 'Multi-Attack','Type matches Memory item held.'),
(3,75, 100, 'Fire', 'Mystical Fire','Lowers opponent''s Special Attack.'),
(4,0, 0, 'Dark', 'Nasty Plot','Sharply raises user''s Special Attack.'),
(2,0, 100, 'Normal', 'Natural Gift','Power and type depend on the user''s held berry.'),
(4,0, 0, 'Normal', 'Nature Power','Uses a certain move based on the current terrain.'),
(3,0, 90, 'Fairy', 'Nature''s Madness','Halves the foe''s HP.'),
(2,60, 100, 'Grass', 'Needle Arm','May cause flinching.'),
(3,85, 95, 'Dark', 'Night Daze','May lower opponent''s Accuracy.'),
(3,0, 100, 'Ghost', 'Night Shade','Inflicts damage equal to user''s level.'),
(2,70, 100, 'Dark', 'Night Slash','High critical hit ratio.'),
(4,0, 100, 'Ghost', 'Nightmare','The sleeping opponent loses 25% of its max HP each turn.'),
(4,0, 0, 'Fighting', 'No Retreat','Raises all stats but user cannot switch out.'),
(4,0, 100, 'Normal', 'Noble Roar','Lowers opponent''s Attack and Special Attack.'),
(2,20, 100, 'Electric', 'Nuzzle','Paralyzes opponent.'),
(3,80, 100, 'Flying', 'Oblivion Wing','User recovers most of the HP inflicted on opponent.'),
(4,0, 100, 'Dark', 'Obstruct','Protects the user and sharply lowers Defence on contact.'),
(3,195, 0, 'Water', 'Oceanic Operetta','Primarina-exclusive Z-Move.'),
(3,65, 85, 'Water', 'Octazooka','May lower opponent''s Accuracy.'),
(4,0, 100, 'Fighting', 'Octolock','Lowers opponent''s Defense and Special Defense every turn, and they cannot flee or switch out.'),
(4,0, 0, 'Normal', 'Odor Sleuth','Resets opponent''s Evasiveness, Normal-type and Fighting-type attacks can now hit Ghosts, and Ghost-type attacks hit Normal.'),
(3,60, 100, 'Ghost', 'Ominous Wind','May raise all user''s stats at once.'),
(3,110, 85, 'Water', 'Origin Pulse','Hits all adjacent opponents.'),
(2,120, 100, 'Dragon', 'Outrage','User attacks for 2-3 turns but then becomes confused.'),
(3,130, 90, 'Fire', 'Overheat','Sharply lowers user''s Special Attack.'),
(4,0, 0, 'Normal', 'Pain Split','The user''s and opponent''s HP becomes the average of both.'),
(3,65, 100, 'Electric', 'Parabolic Charge','User recovers half the HP inflicted on opponent.'),
(4,0, 100, 'Dark', 'Parting Shot','Lowers opponent''s Attack and Special Attack then switches out. '),
(2,40, 100, 'Normal', 'Pay Day','A small amount of money is gained after the battle resolves.'),
(2,50, 100, 'Dark', 'Payback','Power doubles if the user was attacked first.'),
(4,0, 0, 'Normal', 'Perish Song','Any Pokémon in play when this attack is used faints in 3 turns.'),
(2,90, 100, 'Grass', 'Petal Blizzard','Hits all adjacent Pokémon.'),
(3,120, 100, 'Grass', 'Petal Dance','User attacks for 2-3 turns but then becomes confused.'),
(2,90, 100, 'Ghost', 'Phantom Force','Disappears on first turn, attacks on second. Can strike through Protect/Detect.'),
(3,100, 100, 'Psychic', 'Photon Geyser','Uses Attack or Special Attack stat, whichever is higher.'),
(3,0, 20, 'Electric', 'Pika Papow','Power increases when player''s bond is stronger.'),
(2,25, 95, 'Bug', 'Pin Missile','Hits 2-5 times in one turn.'),
(2,100, 100, 'Electric', 'Plasma Fists','Changes Normal-type moves to Electric-type moves.'),
(4,0, 0, 'Normal', 'Play Nice','Lowers opponent''s Attack. Always hits.'),
(2,90, 90, 'Fairy', 'Play Rough','May lower opponent''s Attack.'),
(2,60, 100, 'Flying', 'Pluck','If the opponent is holding a berry, its effect is stolen by user.'),
(2,50, 100, 'Poison', 'Poison Fang','May badly poison opponent.'),
(4,0, 90, 'Poison', 'Poison Gas','Poisons opponent.'),
(2,80, 100, 'Poison', 'Poison Jab','May poison the opponent.'),
(4,0, 75, 'Poison', 'Poison Powder','Poisons opponent.'),
(2,15, 100, 'Poison', 'Poison Sting','May poison the opponent.'),
(2,50, 100, 'Poison', 'Poison Tail','High critical hit ratio. May poison opponent.'),
(3,90, 100, 'Bug', 'Pollen Puff','Deals damage to opponent or restores HP of teammate.'),
(2,110, 90, 'Ghost', 'Poltergeist','Fails if the target doesn’t have an item.'),
(4,0, 100, 'Bug', 'Powder','Damages Pokémon using Fire type moves.'),
(3,40, 100, 'Ice', 'Powder Snow','May freeze opponent.'),
(4,0, 0, 'Psychic', 'Power Split','Averages Attack and Special Attack with the target.'),
(4,0, 0, 'Psychic', 'Power Swap','User and opponent swap Attack and Special Attack.'),
(4,0, 0, 'Psychic', 'Power Trick','User''s own Attack and Defense switch.'),
(2,20, 100, 'Dark', 'Power Trip','The user boasts its strength and attacks the target. The more the user''s stats are raised, the greater the move''s power.'),
(2,40, 100, 'Fighting', 'Power-Up Punch','Raises Attack.'),
(2,120, 85, 'Ground', 'Precipice Blades','Hits all adjacent opponents.'),
(2,0, 90, 'Normal', 'Present','Either deals damage or heals.'),
(3,160, 100, 'Psychic', 'Prismatic Laser','The user shoots powerful lasers using the power of a prism. The user can''t move on the next turn.'),
(4,0, 0, 'Normal', 'Protect','Protects the user, but may fail if used consecutively.'),
(3,65, 100, 'Psychic', 'Psybeam','May confuse opponent.'),
(4,0, 0, 'Normal', 'Psych Up','Copies the opponent''s stat changes.'),
(3,90, 100, 'Psychic', 'Psychic','May lower opponent''s Special Defense.'),
(2,85, 100, 'Psychic', 'Psychic Fangs','The user bites the target with its psychic capabilities. This can also destroy Light Screen and Reflect.'),
(4,0, 0, 'Psychic', 'Psychic Terrain','Prevents priority moves from being used for 5 turns.'),
(3,140, 90, 'Psychic', 'Psycho Boost','Sharply lowers user''s Special Attack.'),
(2,70, 100, 'Psychic', 'Psycho Cut','High critical hit ratio.'),
(4,0, 100, 'Psychic', 'Psycho Shift','Transfers user''s status condition to the opponent.'),
(3,80, 100, 'Psychic', 'Psyshock','Inflicts damage based on the target''s Defense, not Special Defense.'),
(3,100, 100, 'Psychic', 'Psystrike','Inflicts damage based on the target''s Defense, not Special Defense.'),
(3,0, 100, 'Psychic', 'Psywave','Inflicts damage 50-150% of user''s level.'),
(2,210, 0, 'Normal', 'Pulverizing Pancake','Snorlax-exclusive Normal type Z-Move.'),
(2,0, 100, 'Dark', 'Punishment','Power increases when opponent''s stats have been raised.'),
(4,0, 0, 'Poison', 'Purify','The user heals the target''s status condition. If the move succeeds, it also restores the user''s own HP.'),
(2,40, 100, 'Dark', 'Pursuit','Double power if the opponent is switching out.'),
(2,120, 90, 'Fire', 'Pyro Ball','May burn opponent.'),
(4,0, 100, 'Dark', 'Quash','Makes the target act last this turn.'),
(2,40, 100, 'Normal', 'Quick Attack','User attacks first.'),
(4,0, 0, 'Fighting', 'Quick Guard','Protects the user''s team from high-priority moves.'),
(4,0, 0, 'Bug', 'Quiver Dance','Raises user''s Special Attack, Special Defense and Speed.'),
(2,20, 100, 'Normal', 'Rage','Raises user''s Attack when hit.'),
(4,0, 0, 'Bug', 'Rage Powder','Forces attacks to hit user, not team-mates.'),
(4,0, 0, 'Water', 'Rain Dance','Makes it rain for 5 turns.'),
(2,50, 100, 'Normal', 'Rapid Spin','Raises user''s Speed and removes entry hazards and trap move effects.'),
(2,55, 95, 'Grass', 'Razor Leaf','High critical hit ratio.'),
(2,75, 95, 'Water', 'Razor Shell','May lower opponent''s Defense.'),
(3,80, 100, 'Normal', 'Razor Wind','Charges on first turn, attacks on second. High critical hit ratio.'),
(4,0, 0, 'Normal', 'Recover','User recovers half its max HP.'),
(4,0, 0, 'Normal', 'Recycle','User''s used hold item is restored.'),
(4,0, 0, 'Psychic', 'Reflect','Halves damage from Physical attacks for 5 turns.'),
(4,0, 0, 'Normal', 'Reflect Type','User becomes the target''s type.'),
(4,0, 0, 'Normal', 'Refresh','Cures paralysis, poison, and burns.'),
(3,75, 100, 'Normal', 'Relic Song','May put the target to sleep.'),
(4,0, 0, 'Psychic', 'Rest','User sleeps for 2 turns, but user is fully healed.'),
(2,70, 100, 'Normal', 'Retaliate','Inflicts double damage if a teammate fainted on the last turn.'),
(2,0, 100, 'Normal', 'Return','Power increases with higher Friendship.'),
(3,90, 100, 'Normal', 'Revelation Dance','Type changes based on Oricorio''s form.'),
(2,60, 100, 'Fighting', 'Revenge','Power increases if user was hit first.'),
(2,0, 100, 'Fighting', 'Reversal','The lower the user''s HP, the higher the power.'),
(3,70, 100, 'Electric', 'Rising Voltage','Power doubles on Electric Terrain.'),
(4,0, 0, 'Normal', 'Roar','In battles, the opponent switches. In the wild, the Pokémon runs.'),
(3,150, 90, 'Dragon', 'Roar of Time','User must recharge next turn.'),
(2,25, 90, 'Rock', 'Rock Blast','Hits 2-5 times in one turn.'),
(2,90, 85, 'Normal', 'Rock Climb','May confuse opponent.'),
(4,0, 0, 'Rock', 'Rock Polish','Sharply raises user''s Speed.'),
(2,75, 90, 'Rock', 'Rock Slide','May cause flinching.'),
(2,40, 100, 'Fighting', 'Rock Smash','May lower opponent''s Defense.'),
(2,60, 95, 'Rock', 'Rock Tomb','Lowers opponent''s Speed.'),
(2,150, 90, 'Rock', 'Rock Wrecker','User must recharge next turn.'),
(4,0, 0, 'Psychic', 'Role Play','User copies the opponent''s Ability.'),
(2,60, 85, 'Fighting', 'Rolling Kick','May cause flinching.'),
(2,30, 90, 'Rock', 'Rollout','Doubles in power each turn for 5 turns.'),
(4,0, 0, 'Flying', 'Roost','User recovers half of its max HP and loses the Flying type temporarily.'),
(4,0, 0, 'Ground', 'Rototiller','Raises Attack and Special Attack of Grass-types.'),
(3,60, 100, 'Normal', 'Round','Power increases if teammates use it in the same turn.'),
(2,100, 95, 'Fire', 'Sacred Fire','May burn opponent.'),
(2,90, 100, 'Fighting', 'Sacred Sword','Ignores opponent''s stat changes.'),
(4,0, 0, 'Normal', 'Safeguard','The user''s party is protected from status conditions.'),
(4,0, 100, 'Ground', 'Sand Attack','Lowers opponent''s Accuracy.'),
(2,35, 85, 'Ground', 'Sand Tomb','Traps opponent, damaging them for 4-5 turns.'),
(4,0, 0, 'Rock', 'Sandstorm','Creates a sandstorm for 5 turns.'),
(2,90, 100, 'Grass', 'Sappy Seed','Drains HP from opponent each turn.'),
(3,80, 100, 'Water', 'Scald','May burn opponent.'),
(2,25, 90, 'Dragon', 'Scale Shot','Hits 2-5 times in one turn. Boosts user''s Speed but lowers its Defense.'),
(4,0, 100, 'Normal', 'Scary Face','Sharply lowers opponent''s Speed.'),
(3,70, 100, 'Ground', 'Scorching Sands','May burn the target.'),
(4,0, 85, 'Normal', 'Screech','Sharply lowers opponent''s Defense.'),
(3,100, 100, 'Fire', 'Searing Shot','May burn opponent.'),
(2,200, 0, 'Steel', 'Searing Sunraze Smash','Solgaleo-exclusive Z-Move.'),
(2,70, 100, 'Normal', 'Secret Power','Effects of the attack vary with the location.'),
(3,85, 100, 'Fighting', 'Secret Sword','Inflicts damage based on the target''s Defense, not Special Defense.'),
(3,120, 85, 'Grass', 'Seed Flare','May lower opponent''s Special Defense.'),
(2,0, 100, 'Fighting', 'Seismic Toss','Inflicts damage equal to user''s level.'),
(2,200, 100, 'Normal', 'Self-Destruct','User faints.'),
(3,80, 100, 'Ghost', 'Shadow Ball','May lower opponent''s Special Defense.'),
(2,85, 100, 'Ghost', 'Shadow Bone','May lower opponent''s Defense.'),
(2,70, 100, 'Ghost', 'Shadow Claw','High critical hit ratio.'),
(2,120, 100, 'Ghost', 'Shadow Force','Disappears on first turn, attacks on second. Can strike through Protect/Detect.'),
(2,60, 20, 'Ghost', 'Shadow Punch','Ignores Accuracy and Evasiveness.'),
(2,40, 100, 'Ghost', 'Shadow Sneak','User attacks first.'),
(4,0, 0, 'Normal', 'Sharpen','Raises user''s Attack.'),
(3,0, 30, 'Ice', 'Sheer Cold','One-Hit-KO, if it hits.'),
(3,90, 100, 'Poison', 'Shell Side Arm','May poison opponent. Inflicts either Special or Physical damage, whichever is better.'),
(4,0, 0, 'Normal', 'Shell Smash','Sharply raises user''s Attack, Special Attack and Speed but lowers Defense and Special Defense.'),
(3,150, 100, 'Fire', 'Shell Trap','Deals more damage to opponent if hit by a Physical move.'),
(4,0, 0, 'Steel', 'Shift Gear','Raises user''s Attack and sharply raises Speed.'),
(3,60, 20, 'Electric', 'Shock Wave','Ignores Accuracy and Evasiveness.'),
(4,0, 0, 'Ground', 'Shore Up','The user regains up to half of its max HP. It restores more HP in a sandstorm.'),
(3,75, 100, 'Bug', 'Signal Beam','May confuse opponent.'),
(3,60, 100, 'Bug', 'Silver Wind','May raise all stats of user at once.'),
(4,0, 100, 'Normal', 'Simple Beam','Changes target''s ability to Simple.'),
(4,0, 55, 'Normal', 'Sing','Puts opponent to sleep.'),
(2,180, 0, 'Ghost', 'Sinister Arrow Raid','Decidueye-exclusive Z-Move.'),
(2,90, 100, 'Fire', 'Sizzly Slide','Burns the opponent.'),
(4,0, 0, 'Normal', 'Sketch','Permanently copies the opponent''s last move.'),
(4,0, 0, 'Psychic', 'Skill Swap','The user swaps Abilities with the opponent.'),
(2,70, 90, 'Bug', 'Skitter Smack','Lowers opponent''s Sp. Attack.'),
(2,130, 100, 'Normal', 'Skull Bash','Raises Defense on first turn, attacks on second.'),
(2,140, 90, 'Flying', 'Sky Attack','Charges on first turn, attacks on second. May cause flinching. High critical hit ratio.'),
(2,60, 100, 'Flying', 'Sky Drop','Takes opponent into the air on first turn, drops them on second turn.'),
(2,85, 90, 'Fighting', 'Sky Uppercut','Hits the opponent, even during Fly.'),
(4,0, 0, 'Normal', 'Slack Off','User recovers half its max HP.'),
(2,70, 100, 'Normal', 'Slash','High critical hit ratio.'),
(4,0, 75, 'Grass', 'Sleep Powder','Puts opponent to sleep.'),
(4,0, 0, 'Normal', 'Sleep Talk','User performs one of its own moves while sleeping.'),
(3,65, 100, 'Poison', 'Sludge','May poison opponent.'),
(3,90, 100, 'Poison', 'Sludge Bomb','May poison opponent.'),
(3,95, 100, 'Poison', 'Sludge Wave','May poison opponent.'),
(2,50, 100, 'Rock', 'Smack Down','Makes Flying-type Pokémon vulnerable to Ground moves.'),
(2,70, 0, 'Steel', 'Smart Strike','The user stabs the target with a sharp horn. This attack never misses.'),
(2,70, 100, 'Normal', 'Smelling Salts','Power doubles if opponent is paralyzed, but cures it.'),
(3,30, 70, 'Poison', 'Smog','May poison opponent.'),
(4,0, 100, 'Normal', 'Smokescreen','Lowers opponent''s Accuracy.'),
(2,35, 100, 'Grass', 'Snap Trap','Traps opponent, damaging them for 4-5 turns.'),
(3,55, 95, 'Dark', 'Snarl','Lowers opponent''s Special Attack.'),
(4,0, 0, 'Dark', 'Snatch','Steals the effects of the opponent''s next move.'),
(3,80, 100, 'Water', 'Snipe Shot','Ignores moves and abilities that draw in moves. High critical hit ratio.'),
(3,50, 100, 'Normal', 'Snore','Can only be used if asleep. May cause flinching.'),
(4,0, 100, 'Water', 'Soak','Changes the target''s type to water.'),
(4,0, 0, 'Normal', 'Soft-Boiled','User recovers half its max HP.'),
(3,120, 100, 'Grass', 'Solar Beam','Charges on first turn, attacks on second.'),
(2,125, 100, 'Grass', 'Solar Blade','Charges on first turn, attacks on second.'),
(1,0, 90, 'Normal', 'Sonic Boom','Always inflicts 20 HP.'),
(2,195, 0, 'Ghost', 'Soul-Stealing 7-Star Strike','Marshadow-exclusive Z-Move.'),
(3,100, 95, 'Dragon', 'Spacial Rend','High critical hit ratio.'),
(2,65, 100, 'Electric', 'Spark','May paralyze opponent.'),
(3,90, 100, 'Water', 'Sparkling Aria','Heals the burns of its target.'),
(3,90, 100, 'Fairy', 'Sparkly Swirl','Cures all status problems in the party Pokémon.'),
(2,90, 100, 'Ghost', 'Spectral Thief','The user hides in the target''s shadow, steals the target''s stat boosts, and then attacks.'),
(4,0, 0, 'Psychic', 'Speed Swap','The user exchanges Speed stats with the target.'),
(4,0, 0, 'Bug', 'Spider Web','Opponent cannot escape/switch.'),
(2,20, 100, 'Normal', 'Spike Cannon','Hits 2-5 times in one turn.'),
(4,0, 0, 'Ground', 'Spikes','Hurts opponents when they switch into battle.'),
(4,0, 0, 'Grass', 'Spiky Shield','Protects the user and inflicts damage on contact.'),
(2,75, 100, 'Fairy', 'Spirit Break','Lowers opponent''s Special Attack.'),
(2,80, 100, 'Ghost', 'Spirit Shackle','Prevents the opponent from switching out.'),
(3,0, 100, 'Normal', 'Spit Up','Power depends on how many times the user performed Stockpile.'),
(4,0, 100, 'Ghost', 'Spite','The opponent''s last move loses 2-5 PP.'),
(4,0, 0, 'Normal', 'Splash','Doesn''t do ANYTHING.'),
(2,190, 0, 'Rock', 'Splintered Stormshards','Lycanroc-exclusive Z-Move.'),
(3,90, 100, 'Water', 'Splishy Splash','May paralyze opponent.'),
(4,0, 100, 'Grass', 'Spore','Puts opponent to sleep.'),
(4,0, 0, 'Normal', 'Spotlight','The user shines a spotlight on the target so that only the target will be attacked during the turn.'),
(4,0, 0, 'Rock', 'Stealth Rock','Damages opponent switching into battle.'),
(3,110, 95, 'Water', 'Steam Eruption','May burn opponent.'),
(2,65, 100, 'Bug', 'Steamroller','May cause flinching.'),
(3,140, 95, 'Steel', 'Steel Beam','User loses 50% of its HP.'),
(2,130, 100, 'Steel', 'Steel Roller','Fails if no Terrain in effect.'),
(2,70, 90, 'Steel', 'Steel Wing','May raise user''s Defense.'),
(4,0, 0, 'Bug', 'Sticky Web','Lowers opponent''s Speed when switching into battle.'),
(4,0, 0, 'Normal', 'Stockpile','Stores energy for use with Spit Up and Swallow.'),
(3,175, 0, 'Electric', 'Stoked Sparksurfer','Alolan Raichu-exclusive Electric type Z-Move.'),
(2,65, 100, 'Normal', 'Stomp','May cause flinching.'),
(2,75, 100, 'Ground', 'Stomping Tantrum','Driven by frustration, the user attacks the target. If the user''s previous move has failed, the power of this move doubles.'),
(2,100, 80, 'Rock', 'Stone Edge','High critical hit ratio.'),
(3,20, 100, 'Psychic', 'Stored Power','Power increases when user''s stats have been raised.'),
(2,60, 100, 'Fighting', 'Storm Throw','Always results in a critical hit.'),
(3,90, 95, 'Fairy', 'Strange Steam','May confuse opponent.'),
(4,0, 100, 'Grass', 'Strength Sap','The user restores its HP by the same amount as the target''s Attack stat. It also lowers the target''s Attack stat.'),
(4,0, 95, 'Bug', 'String Shot','Sharply lowers opponent''s Speed.'),
(2,50, 0, 'Normal', 'Struggle','Only usable when all PP are gone. Hurts the user.'),
(3,50, 100, 'Bug', 'Struggle Bug','Lowers opponent''s Special Attack.'),
(4,0, 0, 'Normal', 'Stuff Cheeks','The user eats its held Berry, then sharply raises its Defense stat.'),
(4,0, 75, 'Grass', 'Stun Spore','Paralyzes opponent.'),
(2,80, 80, 'Fighting', 'Submission','User receives recoil damage.'),
(4,0, 0, 'Normal', 'Substitute','Uses HP to creates a decoy that takes hits.'),
(2,70, 100, 'Dark', 'Sucker Punch','User attacks first, but only works if opponent is readying an attack.'),
(4,0, 0, 'Fire', 'Sunny Day','Makes it sunny for 5 turns.'),
(2,100, 100, 'Steel', 'Sunsteel Strike','Ignores the target''s ability.'),
(1,0, 90, 'Normal', 'Super Fang','Always takes off half of the opponent''s HP.'),
(2,120, 100, 'Fighting', 'Superpower','Lowers user''s Attack and Defense.'),
(4,0, 55, 'Normal', 'Supersonic','Confuses opponent.'),
(3,90, 100, 'Water', 'Surf','Hits all adjacent Pokémon.'),
(2,25, 100, 'Water', 'Surging Strikes','Always results in a critical hit and ignores stat changes.'),
(4,0, 85, 'Normal', 'Swagger','Opponent becomes confused, but its Attack is sharply raised.'),
(4,0, 0, 'Normal', 'Swallow','The more times the user has performed Stockpile, the more HP is recovered.'),
(4,0, 75, 'Fairy', 'Sweet Kiss','Confuses opponent.'),
(4,0, 100, 'Normal', 'Sweet Scent','Lowers opponent''s Evasiveness.'),
(3,60, 20, 'Normal', 'Swift','Ignores Accuracy and Evasiveness.'),
(4,0, 100, 'Dark', 'Switcheroo','Swaps held items with the opponent.'),
(4,0, 0, 'Normal', 'Swords Dance','Sharply raises user''s Attack.'),
(3,120, 100, 'Psychic', 'Synchronoise','Hits any Pokémon that shares a type with the user.'),
(4,0, 0, 'Grass', 'Synthesis','User recovers HP. Amount varies with the weather.'),
(4,0, 0, 'Bug', 'Tail Glow','Drastically raises user''s Special Attack.'),
(2,25, 85, 'Normal', 'Tail Slap','Hits 2-5 times in one turn.'),
(4,0, 100, 'Normal', 'Tail Whip','Lowers opponent''s Defense.'),
(4,0, 0, 'Flying', 'Tailwind','Doubles Speed for 4 turns.'),
(2,90, 85, 'Normal', 'Take Down','User receives recoil damage.'),
(4,0, 100, 'Rock', 'Tar Shot','Lowers the opponent''s Speed and makes them weaker to Fire-type moves.'),
(4,0, 100, 'Dark', 'Taunt','Opponent can only use moves that attack.'),
(4,0, 0, 'Normal', 'Tearful Look','The user gets teary eyed to make the target lose its combative spirit. This lowers the target''s Attack and Sp. Atk stats.'),
(4,0, 0, 'Normal', 'Teatime','Forces all Pokémon on the field to eat their berries.'),
(3,120, 100, 'Normal', 'Techno Blast','Type depends on the Drive being held.'),
(4,0, 100, 'Normal', 'Teeter Dance','Confuses all Pokémon.'),
(4,0, 0, 'Psychic', 'Telekinesis','Ignores opponent''s Evasiveness for three turns, add Ground immunity.'),
(4,0, 0, 'Psychic', 'Teleport','Allows user to flee wild battles; also warps player to last PokéCenter.'),
(3,50, 100, 'Normal', 'Terrain Pulse','Type and power change depending on the Terrain in effect.'),
(2,60, 100, 'Dark', 'Thief','Also steals opponent''s held item.'),
(2,90, 100, 'Ground', 'Thousand Arrows','Makes Flying-type Pokémon vulnerable to Ground moves.'),
(2,90, 100, 'Ground', 'Thousand Waves','Opponent cannot flee or switch.'),
(2,120, 100, 'Normal', 'Thrash','User attacks for 2-3 turns but then becomes confused.'),
(2,80, 100, 'Dark', 'Throat Chop','Prevents use of sound moves for two turns.'),
(3,110, 70, 'Electric', 'Thunder','May paralyze opponent.'),
(3,80, 90, 'Electric', 'Thunder Cage','Deals damage and traps opponent, damaging them for 4-5 turns.'),
(2,65, 95, 'Electric', 'Thunder Fang','May cause flinching and/or paralyze opponent.'),
(2,75, 100, 'Electric', 'Thunder Punch','May paralyze opponent.'),
(3,40, 100, 'Electric', 'Thunder Shock','May paralyze opponent.'),
(4,0, 90, 'Electric', 'Thunder Wave','Paralyzes opponent.'),
(3,90, 100, 'Electric', 'Thunderbolt','May paralyze opponent.'),
(2,90, 100, 'Fighting', 'Thunderous Kick','Lowers opponent''s Defense.'),
(4,0, 100, 'Normal', 'Tickle','Lowers opponent''s Attack and Defense.'),
(4,0, 0, 'Dark', 'Topsy-Turvy','Reverses stat changes of opponent.'),
(4,0, 100, 'Dark', 'Torment','Opponent cannot use the same move in a row.'),
(4,0, 90, 'Poison', 'Toxic','Badly poisons opponent.'),
(4,0, 0, 'Poison', 'Toxic Spikes','Poisons opponents when they switch into battle.'),
(4,0, 100, 'Poison', 'Toxic Thread','Lowers target''s Speed.'),
(4,0, 0, 'Normal', 'Transform','User takes on the form and attacks of the opponent.'),
(3,80, 100, 'Normal', 'Tri Attack','May paralyze, burn or freeze opponent.'),
(4,0, 100, 'Psychic', 'Trick','Swaps held items with the opponent.'),
(4,0, 0, 'Psychic', 'Trick Room','Slower Pokémon move first in the turn for 5 turns.'),
(4,0, 100, 'Ghost', 'Trick-or-Treat','Adds Ghost type to opponent.'),
(2,20, 90, 'Ice', 'Triple Axel','Attacks thrice with more power each time.'),
(2,10, 90, 'Fighting', 'Triple Kick','Hits thrice in one turn at increasing power.'),
(2,70, 100, 'Grass', 'Trop Kick','Lowers opponent''s Attack.'),
(3,0, 5, 'Normal', 'Trump Card','The lower the PP, the higher the power.'),
(2,25, 100, 'Bug', 'Twineedle','Hits twice in one turn. May poison opponent.'),
(3,40, 100, 'Dragon', 'Twister','May cause flinching. Hits Pokémon using Fly/Bounce with double power.'),
(2,70, 100, 'Bug', 'U-turn','User switches out immediately after attacking.'),
(3,90, 100, 'Normal', 'Uproar','User attacks for 3 turns and prevents sleep.'),
(2,180, 95, 'Fire', 'V-create','Lowers user''s Defense, Special Defense and Speed.'),
(3,40, 100, 'Fighting', 'Vacuum Wave','User attacks first.'),
(2,0, 20, 'Normal', 'Veevee Volley','Power increases when player''s bond is stronger.'),
(4,0, 100, 'Poison', 'Venom Drench','Lowers poisoned opponent''s Special Attack and Speed.'),
(3,65, 100, 'Poison', 'Venoshock','Inflicts double damage if the target is poisoned.'),
(2,70, 10, 'Fighting', 'Vital Throw','User attacks last, but ignores Accuracy and Evasiveness.'),
(3,70, 100, 'Electric', 'Volt Switch','User must switch out after attacking.'),
(2,120, 100, 'Electric', 'Volt Tackle','User receives recoil damage. May paralyze opponent.'),
(2,70, 100, 'Fighting', 'Wake-Up Slap','Power doubles if opponent is asleep, but wakes it up.'),
(3,80, 100, 'Water', 'Water Pledge','Added effects appear if preceded by Fire Pledge or succeeded by Grass Pledge.'),
(3,60, 100, 'Water', 'Water Pulse','May confuse opponent.'),
(3,15, 100, 'Water', 'Water Shuriken','Hits 2-5 times in one turn.'),
(4,0, 0, 'Water', 'Water Sport','Weakens the power of Fire-type moves.'),
(3,150, 100, 'Water', 'Water Spout','The higher the user''s HP, the higher the damage caused.'),
(2,80, 100, 'Water', 'Waterfall','May cause flinching.'),
(3,50, 100, 'Normal', 'Weather Ball','Move''s power and type changes with the weather.'),
(3,35, 85, 'Water', 'Whirlpool','Traps opponent, damaging them for 4-5 turns.'),
(4,0, 0, 'Normal', 'Whirlwind','In battles, the opponent switches. In the wild, the Pokémon runs.'),
(2,80, 100, 'Dark', 'Wicked Blow','Always results in a critical hit and ignores stat changes.'),
(4,0, 0, 'Rock', 'Wide Guard','Protects the user''s team from multi-target attacks.'),
(2,90, 100, 'Electric', 'Wild Charge','User receives recoil damage.'),
(4,0, 85, 'Fire', 'Will-O-Wisp','Burns opponent.'),
(4,0, 0, 'Normal', 'Wish','The user recovers HP in the following turn.'),
(4,0, 0, 'Water', 'Withdraw','Raises user''s Defense.'),
(4,0, 0, 'Psychic', 'Wonder Room','Swaps every Pokémon''s Defense and Special Defense for 5 turns.'),
(2,120, 100, 'Grass', 'Wood Hammer','User receives recoil damage.'),
(4,0, 0, 'Normal', 'Work Up','Raises user''s Attack and Special Attack.'),
(4,0, 100, 'Grass', 'Worry Seed','Changes the opponent''s Ability to Insomnia.'),
(2,15, 90, 'Normal', 'Wrap','Traps opponent, damaging them for 4-5 turns.'),
(3,0, 100, 'Normal', 'Wring Out','The higher the opponent''s HP, the higher the damage.'),
(4,0, 0, 'Normal', 'Yawn','Puts opponent to sleep in the next turn.'),
(3,120, 50, 'Electric', 'Zap Cannon','Paralyzes opponent.'),
(2,80, 90, 'Psychic', 'Zen Headbutt','May cause flinching.'),
(2,80, 100, 'Electric', 'Zing Zap','May cause flinching.'),
(2,50, 100, 'Electric', 'Zippy Zap','Always results in a critical hit.');



DROP TABLE IF EXISTS pokemon_type CASCADE ;
CREATE TABLE pokemon_type (
id_type_pokemon serial PRIMARY KEY,
pokemon_type_name text UNIQUE NOT NULL,
pokemon_type_description text
);
INSERT INTO pokemon_type(pokemon_type_name, pokemon_type_description) VALUES
('Speedster', 'Speedsters utilize their high mobility to deal quick attacks and score easy points. Take advantage of
their fast movement speed to go in and out of goals and outmaneuver your enemies.'),
('Defender','Defenders offer their high Endurance to protect their teammates from harm. Take advantage of their huge
physique to hinder your opponents by stunning or knocking them away during teamfights.'),
('Attacker', 'Attackers focus on dealing massive damage from long range. They may be glass cannons, but good
positioning and well-timed attacks will make them a deadly force.'),
('Supporter', 'Supporters enable their teammates to do their job effectively throughout all stages of the game. They
come with a variety of utility such as heals, shields, and debuffs that can keep your teammates alive and give them the upper hand in battle.'),
('All-Rounder', 'All-Rounders are dependable Pokemon that can operate on their own. Because of their balanced stats,
you can easily adapt into offensive and defensive roles when the situation demands it.')
;


DROP TABLE IF EXISTS pokemon CASCADE;
CREATE TABLE pokemon (
    id_pokemon_type integer REFERENCES pokemon_type(id_type_pokemon),
    name text UNIQUE NOT NULL,
    id_pokemon serial PRIMARY KEY,
    level integer,
    hp integer,
    attack integer,
    defense integer,
    spe_atk integer,
    spe_def integer,
    speed integer,
    url_image text
);
INSERT INTO pokemon (name ,id_pokemon,hp, attack, defense, spe_atk, spe_def, speed, id_pokemon_type, level, url_image) VALUES 
('Bulbasaur',1 ,45, 49, 49, 65, 65, 45, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bulbasaur.png'),
('Ivysaur',2 ,60, 62, 63, 80, 80, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ivysaur.png'),
('Venusaur',3 ,80, 82, 83, 100, 100, 80, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/venusaur.png'),
('Charmander',4 ,39, 52, 43, 60, 50, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/charmander.png'),
('Charmeleon',5 ,58, 64, 58, 80, 65, 80, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/charmeleon.png'),
('Charizard',6 ,78, 84, 78, 109, 85, 100, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/charizard.png'),
('Squirtle',7 ,44, 48, 65, 50, 64, 43, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/squirtle.png'),
('Wartortle',8 ,59, 63, 80, 65, 80, 58, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wartortle.png'),
('Blastoise',9 ,79, 83, 100, 85, 105, 78, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/blastoise.png'),
('Caterpie',10 ,45, 30, 35, 20, 20, 45, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/caterpie.png'),
('Metapod',11 ,50, 20, 55, 25, 25, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/metapod.png'),
('Butterfree',12 ,60, 45, 50, 90, 80, 70, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/butterfree.png'),
('Weedle',13 ,40, 35, 30, 20, 20, 50, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/weedle.png'),
('Kakuna',14 ,45, 25, 50, 25, 25, 35, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kakuna.png'),
('Beedrill',15 ,65, 90, 40, 45, 80, 75, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/beedrill.png'),
('Pidgey',16 ,40, 45, 40, 35, 35, 56, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pidgey.png'),
('Pidgeotto',17 ,63, 60, 55, 50, 50, 71, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pidgeotto.png'),
('Pidgeot',18 ,83, 80, 75, 70, 70, 101, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pidgeot.png'),
('Rattata',19 ,30, 56, 35, 25, 35, 72, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rattata.png'),
('Raticate',20 ,55, 81, 60, 50, 70, 97, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/raticate.png'),
('Spearow',21 ,40, 60, 30, 31, 31, 70, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/spearow.png'),
('Fearow',22 ,65, 90, 65, 61, 61, 100, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/fearow.png'),
('Ekans',23 ,35, 60, 44, 40, 54, 55, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ekans.png'),
('Arbok',24 ,60, 95, 69, 65, 79, 80, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/arbok.png'),
('Pikachu',25 ,35, 55, 40, 50, 50, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pikachu.png'),
('Raichu',26 ,60, 90, 55, 90, 80, 110, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/raichu.png'),
('Sandshrew',27 ,50, 75, 85, 20, 30, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sandshrew.png'),
('Sandslash',28 ,75, 100, 110, 45, 55, 65, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sandslash.png'),
('Nidoran F',29 ,55, 47, 52, 40, 40, 41, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/nidoran-f.png'),
('Nidorina',30 ,70, 62, 67, 55, 55, 56, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/nidorina.png'),
('Nidoqueen',31 ,90, 92, 87, 75, 85, 76, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/nidoqueen.png'),
('Nidoran M',32 ,46, 57, 40, 40, 40, 50, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/nidoran-m.png'),
('Nidorino',33 ,61, 72, 57, 55, 55, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/nidorino.png'),
('Nidoking',34 ,81, 102, 77, 85, 75, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/nidoking.png'),
('Clefairy',35 ,70, 45, 48, 60, 65, 35, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/clefairy.png'),
('Clefable',36 ,95, 70, 73, 95, 90, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/clefable.png'),
('Vulpix',37 ,38, 41, 40, 50, 65, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vulpix.png'),
('Ninetales',38 ,73, 76, 75, 81, 100, 100, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ninetales.png'),
('Jigglypuff',39 ,115, 45, 20, 45, 25, 20, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/jigglypuff.png'),
('Wigglytuff',40 ,140, 70, 45, 85, 50, 45, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wigglytuff.png'),
('Zubat',41 ,40, 45, 35, 30, 40, 55, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zubat.png'),
('Golbat',42 ,75, 80, 70, 65, 75, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/golbat.png'),
('Oddish',43 ,45, 50, 55, 75, 65, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/oddish.png'),
('Gloom',44 ,60, 65, 70, 85, 75, 40, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gloom.png'),
('Vileplume',45 ,75, 80, 85, 110, 90, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vileplume.png'),
('Paras',46 ,35, 70, 55, 45, 55, 25, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/paras.png'),
('Parasect',47 ,60, 95, 80, 60, 80, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/parasect.png'),
('Venonat',48 ,60, 55, 50, 40, 55, 45, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/venonat.png'),
('Venomoth',49 ,70, 65, 60, 90, 75, 90, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/venomoth.png'),
('Diglett',50 ,10, 55, 25, 35, 45, 95, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/diglett.png'),
('Dugtrio',51 ,35, 100, 50, 50, 70, 120, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dugtrio.png'),
('Meowth',52 ,40, 45, 35, 40, 40, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/meowth.png'),
('Persian',53 ,65, 70, 60, 65, 65, 115, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/persian.png'),
('Psyduck',54 ,50, 52, 48, 65, 50, 55, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/psyduck.png'),
('Golduck',55 ,80, 82, 78, 95, 80, 85, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/golduck.png'),
('Mankey',56 ,40, 80, 35, 35, 45, 70, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mankey.png'),
('Primeape',57 ,65, 105, 60, 60, 70, 95, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/primeape.png'),
('Growlithe',58 ,55, 70, 45, 70, 50, 60, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/growlithe.png'),
('Arcanine',59 ,90, 110, 80, 100, 80, 95, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/arcanine.png'),
('Poliwag',60 ,40, 50, 40, 40, 40, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/poliwag.png'),
('Poliwhirl',61 ,65, 65, 65, 50, 50, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/poliwhirl.png'),
('Poliwrath',62 ,90, 95, 95, 70, 90, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/poliwrath.png'),
('Abra',63 ,25, 20, 15, 105, 55, 90, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/abra.png'),
('Kadabra',64 ,40, 35, 30, 120, 70, 105, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kadabra.png'),
('Alakazam',65 ,55, 50, 45, 135, 95, 120, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/alakazam.png'),
('Machop',66 ,70, 80, 50, 35, 35, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/machop.png'),
('Machoke',67 ,80, 100, 70, 50, 60, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/machoke.png'),
('Machamp',68 ,90, 130, 80, 65, 85, 55, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/machamp.png'),
('Bellsprout',69 ,50, 75, 35, 70, 30, 40, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bellsprout.png'),
('Weepinbell',70 ,65, 90, 50, 85, 45, 55, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/weepinbell.png'),
('Victreebel',71 ,80, 105, 65, 100, 70, 70, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/victreebel.png'),
('Tentacool',72 ,40, 40, 35, 50, 100, 70, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tentacool.png'),
('Tentacruel',73 ,80, 70, 65, 80, 120, 100, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tentacruel.png'),
('Geodude',74 ,40, 80, 100, 30, 30, 20, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/geodude.png'),
('Graveler',75 ,55, 95, 115, 45, 45, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/graveler.png'),
('Golem',76 ,80, 120, 130, 55, 65, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/golem.png'),
('Ponyta',77 ,50, 85, 55, 65, 65, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ponyta.png'),
('Rapidash',78 ,65, 100, 70, 80, 80, 105, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rapidash.png'),
('Slowpoke',79 ,90, 65, 65, 40, 40, 15, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/slowpoke.png'),
('Slowbro',80 ,95, 75, 110, 100, 80, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/slowbro.png'),
('Magnemite',81 ,25, 35, 70, 95, 55, 45, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/magnemite.png'),
('Magneton',82 ,50, 60, 95, 120, 70, 70, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/magneton.png'),
('Farfetchd',83 ,52, 90, 55, 58, 62, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/farfetchd.png'),
('Doduo',84 ,35, 85, 45, 35, 35, 75, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/doduo.png'),
('Dodrio',85 ,60, 110, 70, 60, 60, 110, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dodrio.png'),
('Seel',86 ,65, 45, 55, 45, 70, 45, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/seel.png'),
('Dewgong',87 ,90, 70, 80, 70, 95, 70, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dewgong.png'),
('Grimer',88 ,80, 80, 50, 40, 50, 25, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/grimer.png'),
('Muk',89 ,105, 105, 75, 65, 100, 50, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/muk.png'),
('Shellder',90 ,30, 65, 100, 45, 25, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shellder.png'),
('Cloyster',91 ,50, 95, 180, 85, 45, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cloyster.png'),
('Gastly',92 ,30, 35, 30, 100, 35, 80, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gastly.png'),
('Haunter',93 ,45, 50, 45, 115, 55, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/haunter.png'),
('Gengar',94 ,60, 65, 60, 130, 75, 110, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gengar.png'),
('Onix',95 ,35, 45, 160, 30, 45, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/onix.png'),
('Drowzee',96 ,60, 48, 45, 43, 90, 42, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/drowzee.png'),
('Hypno',97 ,85, 73, 70, 73, 115, 67, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hypno.png'),
('Krabby',98 ,30, 105, 90, 25, 25, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/krabby.png'),
('Kingler',99 ,55, 130, 115, 50, 50, 75, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kingler.png'),
('Voltorb',100 ,40, 30, 50, 55, 55, 100, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/voltorb.png'),
('Electrode',101 ,60, 50, 70, 80, 80, 150, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/electrode.png'),
('Exeggcute',102 ,60, 40, 80, 60, 45, 40, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/exeggcute.png'),
('Exeggutor',103 ,95, 95, 85, 125, 75, 55, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/exeggutor.png'),
('Cubone',104 ,50, 50, 95, 40, 50, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cubone.png'),
('Marowak',105 ,60, 80, 110, 50, 80, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/marowak.png'),
('Hitmonlee',106 ,50, 120, 53, 35, 110, 87, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hitmonlee.png'),
('Hitmonchan',107 ,50, 105, 79, 35, 110, 76, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hitmonchan.png'),
('Lickitung',108 ,90, 55, 75, 60, 75, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lickitung.png'),
('Koffing',109 ,40, 65, 95, 60, 45, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/koffing.png'),
('Weezing',110 ,65, 90, 120, 85, 70, 60, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/weezing.png'),
('Rhyhorn',111 ,80, 85, 95, 30, 30, 25, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rhyhorn.png'),
('Rhydon',112 ,105, 130, 120, 45, 45, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rhydon.png'),
('Chansey',113 ,250, 5, 5, 35, 105, 50, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/chansey.png'),
('Tangela',114 ,65, 55, 115, 100, 40, 60, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tangela.png'),
('Kangaskhan',115 ,105, 95, 80, 40, 80, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kangaskhan.png'),
('Horsea',116 ,30, 40, 70, 70, 25, 60, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/horsea.png'),
('Seadra',117 ,55, 65, 95, 95, 45, 85, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/seadra.png'),
('Goldeen',118 ,45, 67, 60, 35, 50, 63, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/goldeen.png'),
('Seaking',119 ,80, 92, 65, 65, 80, 68, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/seaking.png'),
('Staryu',120 ,30, 45, 55, 70, 55, 85, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/staryu.png'),
('Starmie',121 ,60, 75, 85, 100, 85, 115, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/starmie.png'),
('Mr Mime',122 ,40, 45, 65, 100, 120, 90, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mr-mime.png'),
('Scyther',123 ,70, 110, 80, 55, 80, 105, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/scyther.png'),
('Jynx',124 ,65, 50, 35, 115, 95, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/jynx.png'),
('Electabuzz',125 ,65, 83, 57, 95, 85, 105, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/electabuzz.png'),
('Magmar',126 ,65, 95, 57, 100, 85, 93, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/magmar.png'),
('Pinsir',127 ,65, 125, 100, 55, 70, 85, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pinsir.png'),
('Tauros',128 ,75, 100, 95, 40, 70, 110, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tauros.png'),
('Magikarp',129 ,20, 10, 55, 15, 20, 80, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/magikarp.png'),
('Gyarados',130 ,95, 125, 79, 60, 100, 81, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gyarados.png'),
('Lapras',131 ,130, 85, 80, 85, 95, 60, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lapras.png'),
('Ditto',132 ,48, 48, 48, 48, 48, 48, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ditto.png'),
('Eevee',133 ,55, 55, 50, 45, 65, 55, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/eevee.png'),
('Vaporeon',134 ,130, 65, 60, 110, 95, 65, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vaporeon.png'),
('Jolteon',135 ,65, 65, 60, 110, 95, 130, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/jolteon.png'),
('Flareon',136 ,65, 130, 60, 95, 110, 65, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/flareon.png'),
('Porygon',137 ,65, 60, 70, 85, 75, 40, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/porygon.png'),
('Omanyte',138 ,35, 40, 100, 90, 55, 35, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/omanyte.png'),
('Omastar',139 ,70, 60, 125, 115, 70, 55, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/omastar.png'),
('Kabuto',140 ,30, 80, 90, 55, 45, 55, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kabuto.png'),
('Kabutops',141 ,60, 115, 105, 65, 70, 80, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kabutops.png'),
('Aerodactyl',142 ,80, 105, 65, 60, 75, 130, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/aerodactyl.png'),
('Snorlax',143 ,160, 110, 65, 65, 110, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/snorlax.png'),
('Articuno',144 ,90, 85, 100, 95, 125, 85, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/articuno.png'),
('Zapdos',145 ,90, 90, 85, 125, 90, 100, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zapdos.png'),
('Moltres',146 ,90, 100, 90, 125, 85, 90, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/moltres.png'),
('Dratini',147 ,41, 64, 45, 50, 50, 50, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dratini.png'),
('Dragonair',148 ,61, 84, 65, 70, 70, 70, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dragonair.png'),
('Dragonite',149 ,91, 134, 95, 100, 100, 80, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dragonite.png'),
('Mewtwo',150 ,106, 110, 90, 154, 90, 130, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mewtwo.png'),
('Mew',151 ,100, 100, 100, 100, 100, 100, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mew.png'),
('Chikorita',152 ,45, 49, 65, 49, 65, 45, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/chikorita.png'),
('Bayleef',153 ,60, 62, 80, 63, 80, 60, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bayleef.png'),
('Meganium',154 ,80, 82, 100, 83, 100, 80, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/meganium.png'),
('Cyndaquil',155 ,39, 52, 43, 60, 50, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cyndaquil.png'),
('Quilava',156 ,58, 64, 58, 80, 65, 80, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/quilava.png'),
('Typhlosion',157 ,78, 84, 78, 109, 85, 100, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/typhlosion.png'),
('Totodile',158 ,50, 65, 64, 44, 48, 43, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/totodile.png'),
('Croconaw',159 ,65, 80, 80, 59, 63, 58, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/croconaw.png'),
('Feraligatr',160 ,85, 105, 100, 79, 83, 78, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/feraligatr.png'),
('Sentret',161 ,35, 46, 34, 35, 45, 20, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sentret.png'),
('Furret',162 ,85, 76, 64, 45, 55, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/furret.png'),
('Hoothoot',163 ,60, 30, 30, 36, 56, 50, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hoothoot.png'),
('Noctowl',164 ,100, 50, 50, 86, 96, 70, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/noctowl.png'),
('Ledyba',165 ,40, 20, 30, 40, 80, 55, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ledyba.png'),
('Ledian',166 ,55, 35, 50, 55, 110, 85, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ledian.png'),
('Spinarak',167 ,40, 60, 40, 40, 40, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/spinarak.png'),
('Ariados',168 ,70, 90, 70, 60, 70, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ariados.png'),
('Crobat',169 ,85, 90, 80, 70, 80, 130, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/crobat.png'),
('Chinchou',170 ,75, 38, 38, 56, 56, 67, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/chinchou.png'),
('Lanturn',171 ,125, 58, 58, 76, 76, 67, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lanturn.png'),
('Pichu',172 ,20, 40, 15, 35, 35, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pichu.png'),
('Cleffa',173 ,50, 25, 28, 45, 55, 15, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cleffa.png'),
('Igglybuff',174 ,90, 30, 15, 40, 20, 15, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/igglybuff.png'),
('Togepi',175 ,35, 20, 65, 40, 65, 20, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/togepi.png'),
('Togetic',176 ,55, 40, 85, 80, 105, 40, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/togetic.png'),
('Natu',177 ,40, 50, 45, 70, 45, 70, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/natu.png'),
('Xatu',178 ,65, 75, 70, 95, 70, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/xatu.png'),
('Mareep',179 ,55, 40, 40, 65, 45, 35, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mareep.png'),
('Flaaffy',180 ,70, 55, 55, 80, 60, 45, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/flaaffy.png'),
('Ampharos',181 ,90, 75, 85, 115, 90, 55, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ampharos.png'),
('Bellossom',182 ,75, 80, 95, 90, 100, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bellossom.png'),
('Marill',183 ,70, 20, 50, 20, 50, 40, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/marill.png'),
('Azumarill',184 ,100, 50, 80, 60, 80, 50, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/azumarill.png'),
('Sudowoodo',185 ,70, 100, 115, 30, 65, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sudowoodo.png'),
('Politoed',186 ,90, 75, 75, 90, 100, 70, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/politoed.png'),
('Hoppip',187 ,35, 35, 40, 35, 55, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hoppip.png'),
('Skiploom',188 ,55, 45, 50, 45, 65, 80, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/skiploom.png'),
('Jumpluff',189 ,75, 55, 70, 55, 95, 110, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/jumpluff.png'),
('Aipom',190 ,55, 70, 55, 40, 55, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/aipom.png'),
('Sunkern',191 ,30, 30, 30, 30, 30, 30, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sunkern.png'),
('Sunflora',192 ,75, 75, 55, 105, 85, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sunflora.png'),
('Yanma',193 ,65, 65, 45, 75, 45, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/yanma.png'),
('Wooper',194 ,55, 45, 45, 25, 25, 15, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wooper.png'),
('Quagsire',195 ,95, 85, 85, 65, 65, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/quagsire.png'),
('Espeon',196 ,65, 65, 60, 130, 95, 110, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/espeon.png'),
('Umbreon',197 ,95, 65, 110, 60, 130, 65, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/umbreon.png'),
('Murkrow',198 ,60, 85, 42, 85, 42, 91, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/murkrow.png'),
('Slowking',199 ,95, 75, 80, 100, 110, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/slowking.png'),
('Misdreavus',200 ,60, 60, 60, 85, 85, 85, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/misdreavus.png'),
('Unown',201 ,48, 72, 48, 72, 48, 48, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/unown.png'),
('Wobbuffet',202 ,190, 33, 58, 33, 58, 33, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wobbuffet.png'),
('Girafarig',203 ,70, 80, 65, 90, 65, 85, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/girafarig.png'),
('Pineco',204 ,50, 65, 90, 35, 35, 15, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pineco.png'),
('Forretress',205 ,75, 90, 140, 60, 60, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/forretress.png'),
('Dunsparce',206 ,100, 70, 70, 65, 65, 45, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dunsparce.png'),
('Gligar',207 ,65, 75, 105, 35, 65, 85, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gligar.png'),
('Steelix',208 ,75, 85, 200, 55, 65, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/steelix.png'),
('Snubbull',209 ,60, 80, 50, 40, 40, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/snubbull.png'),
('Granbull',210 ,90, 120, 75, 60, 60, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/granbull.png'),
('Qwilfish',211 ,65, 95, 85, 55, 55, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/qwilfish.png'),
('Scizor',212 ,70, 130, 100, 55, 80, 65, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/scizor.png'),
('Shuckle',213 ,20, 10, 230, 10, 230, 5, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shuckle.png'),
('Heracross',214 ,80, 125, 75, 40, 95, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/heracross.png'),
('Sneasel',215 ,55, 95, 55, 35, 75, 115, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sneasel.png'),
('Teddiursa',216 ,60, 80, 50, 50, 50, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/teddiursa.png'),
('Ursaring',217 ,90, 130, 75, 75, 75, 55, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ursaring.png'),
('Slugma',218 ,40, 40, 40, 70, 40, 20, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/slugma.png'),
('Magcargo',219 ,60, 50, 120, 90, 80, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/magcargo.png'),
('Swinub',220 ,50, 50, 40, 30, 30, 50, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/swinub.png'),
('Piloswine',221 ,100, 100, 80, 60, 60, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/piloswine.png'),
('Corsola',222 ,65, 55, 95, 65, 95, 35, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/corsola.png'),
('Remoraid',223 ,35, 65, 35, 65, 35, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/remoraid.png'),
('Octillery',224 ,75, 105, 75, 105, 75, 45, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/octillery.png'),
('Delibird',225 ,45, 55, 45, 65, 45, 75, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/delibird.png'),
('Mantine',226 ,85, 40, 70, 80, 140, 70, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mantine.png'),
('Skarmory',227 ,65, 80, 140, 40, 70, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/skarmory.png'),
('Houndour',228 ,45, 60, 30, 80, 50, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/houndour.png'),
('Houndoom',229 ,75, 90, 50, 110, 80, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/houndoom.png'),
('Kingdra',230 ,75, 95, 95, 95, 95, 85, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kingdra.png'),
('Phanpy',231 ,90, 60, 60, 40, 40, 40, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/phanpy.png'),
('Donphan',232 ,90, 120, 120, 60, 60, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/donphan.png'),
('Porygon2',233 ,85, 80, 90, 105, 95, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/porygon2.png'),
('Stantler',234 ,73, 95, 62, 85, 65, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/stantler.png'),
('Smeargle',235 ,55, 20, 35, 20, 45, 75, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/smeargle.png'),
('Tyrogue',236 ,35, 35, 35, 35, 35, 35, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tyrogue.png'),
('Hitmontop',237 ,50, 95, 95, 35, 110, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hitmontop.png'),
('Smoochum',238 ,45, 30, 15, 85, 65, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/smoochum.png'),
('Elekid',239 ,45, 63, 37, 65, 55, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/elekid.png'),
('Magby',240 ,45, 75, 37, 70, 55, 83, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/magby.png'),
('Miltank',241 ,95, 80, 105, 40, 70, 100, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/miltank.png'),
('Blissey',242 ,255, 10, 10, 75, 135, 55, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/blissey.png'),
('Raikou',243 ,90, 85, 75, 115, 100, 115, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/raikou.png'),
('Entei',244 ,115, 115, 85, 90, 75, 100, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/entei.png'),
('Suicune',245 ,100, 75, 115, 90, 115, 85, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/suicune.png'),
('Larvitar',246 ,50, 64, 50, 45, 50, 41, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/larvitar.png'),
('Pupitar',247 ,70, 84, 70, 65, 70, 51, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pupitar.png'),
('Tyranitar',248 ,100, 134, 110, 95, 100, 61, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tyranitar.png'),
('Lugia',249 ,106, 90, 130, 90, 154, 110, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lugia.png'),
('Ho Oh',250 ,106, 130, 90, 110, 154, 90, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ho-oh.png'),
('Celebi',251 ,100, 100, 100, 100, 100, 100, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/celebi.png'),
('Treecko',252 ,40, 45, 35, 65, 55, 70, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/treecko.png'),
('Grovyle',253 ,50, 65, 45, 85, 65, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/grovyle.png'),
('Sceptile',254 ,70, 85, 65, 105, 85, 120, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sceptile.png'),
('Torchic',255 ,45, 60, 40, 70, 50, 45, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/torchic.png'),
('Combusken',256 ,60, 85, 60, 85, 60, 55, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/combusken.png'),
('Blaziken',257 ,80, 120, 70, 110, 70, 80, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/blaziken.png'),
('Mudkip',258 ,50, 70, 50, 50, 50, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mudkip.png'),
('Marshtomp',259 ,70, 85, 70, 60, 70, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/marshtomp.png'),
('Swampert',260 ,100, 110, 90, 85, 90, 60, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/swampert.png'),
('Poochyena',261 ,35, 55, 35, 30, 30, 35, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/poochyena.png'),
('Mightyena',262 ,70, 90, 70, 60, 60, 70, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mightyena.png'),
('Zigzagoon',263 ,38, 30, 41, 30, 41, 60, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zigzagoon.png'),
('Linoone',264 ,78, 70, 61, 50, 61, 100, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/linoone.png'),
('Wurmple',265 ,45, 45, 35, 20, 30, 20, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wurmple.png'),
('Silcoon',266 ,50, 35, 55, 25, 25, 15, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/silcoon.png'),
('Beautifly',267 ,60, 70, 50, 100, 50, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/beautifly.png'),
('Cascoon',268 ,50, 35, 55, 25, 25, 15, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cascoon.png'),
('Dustox',269 ,60, 50, 70, 50, 90, 65, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dustox.png'),
('Lotad',270 ,40, 30, 30, 40, 50, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lotad.png'),
('Lombre',271 ,60, 50, 50, 60, 70, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lombre.png'),
('Ludicolo',272 ,80, 70, 70, 90, 100, 70, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ludicolo.png'),
('Seedot',273 ,40, 40, 50, 30, 30, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/seedot.png'),
('Nuzleaf',274 ,70, 70, 40, 60, 40, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/nuzleaf.png'),
('Shiftry',275 ,90, 100, 60, 90, 60, 80, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shiftry.png'),
('Taillow',276 ,40, 55, 30, 30, 30, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/taillow.png'),
('Swellow',277 ,60, 85, 60, 75, 50, 125, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/swellow.png'),
('Wingull',278 ,40, 30, 30, 55, 30, 85, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wingull.png'),
('Pelipper',279 ,60, 50, 100, 95, 70, 65, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pelipper.png'),
('Ralts',280 ,28, 25, 25, 45, 35, 40, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ralts.png'),
('Kirlia',281 ,38, 35, 35, 65, 55, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kirlia.png'),
('Gardevoir',282 ,68, 65, 65, 125, 115, 80, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gardevoir.png'),
('Surskit',283 ,40, 30, 32, 50, 52, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/surskit.png'),
('Masquerain',284 ,70, 60, 62, 100, 82, 80, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/masquerain.png'),
('Shroomish',285 ,60, 40, 60, 40, 60, 35, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shroomish.png'),
('Breloom',286 ,60, 130, 80, 60, 60, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/breloom.png'),
('Slakoth',287 ,60, 60, 60, 35, 35, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/slakoth.png'),
('Vigoroth',288 ,80, 80, 80, 55, 55, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vigoroth.png'),
('Slaking',289 ,150, 160, 100, 95, 65, 100, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/slaking.png'),
('Nincada',290 ,31, 45, 90, 30, 30, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/nincada.png'),
('Ninjask',291 ,61, 90, 45, 50, 50, 160, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ninjask.png'),
('Shedinja',292 ,1, 90, 45, 30, 30, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shedinja.png'),
('Whismur',293 ,64, 51, 23, 51, 23, 28, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/whismur.png'),
('Loudred',294 ,84, 71, 43, 71, 43, 48, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/loudred.png'),
('Exploud',295 ,104, 91, 63, 91, 73, 68, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/exploud.png'),
('Makuhita',296 ,72, 60, 30, 20, 30, 25, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/makuhita.png'),
('Hariyama',297 ,144, 120, 60, 40, 60, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hariyama.png'),
('Azurill',298 ,50, 20, 40, 20, 40, 20, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/azurill.png'),
('Nosepass',299 ,30, 45, 135, 45, 90, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/nosepass.png'),
('Skitty',300 ,50, 45, 45, 35, 35, 50, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/skitty.png'),
('Delcatty',301 ,70, 65, 65, 55, 55, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/delcatty.png'),
('Sableye',302 ,50, 75, 75, 65, 65, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sableye.png'),
('Mawile',303 ,50, 85, 85, 55, 55, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mawile.png'),
('Aron',304 ,50, 70, 100, 40, 40, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/aron.png'),
('Lairon',305 ,60, 90, 140, 50, 50, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lairon.png'),
('Aggron',306 ,70, 110, 180, 60, 60, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/aggron.png'),
('Meditite',307 ,30, 40, 55, 40, 55, 60, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/meditite.png'),
('Medicham',308 ,60, 60, 75, 60, 75, 80, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/medicham.png'),
('Electrike',309 ,40, 45, 40, 65, 40, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/electrike.png'),
('Manectric',310 ,70, 75, 60, 105, 60, 105, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/manectric.png'),
('Plusle',311 ,60, 50, 40, 85, 75, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/plusle.png'),
('Minun',312 ,60, 40, 50, 75, 85, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/minun.png'),
('Volbeat',313 ,65, 73, 75, 47, 85, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/volbeat.png'),
('Illumise',314 ,65, 47, 75, 73, 85, 85, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/illumise.png'),
('Roselia',315 ,50, 60, 45, 100, 80, 65, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/roselia.png'),
('Gulpin',316 ,70, 43, 53, 43, 53, 40, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gulpin.png'),
('Swalot',317 ,100, 73, 83, 73, 83, 55, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/swalot.png'),
('Carvanha',318 ,45, 90, 20, 65, 20, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/carvanha.png'),
('Sharpedo',319 ,70, 120, 40, 95, 40, 95, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sharpedo.png'),
('Wailmer',320 ,130, 70, 35, 70, 35, 60, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wailmer.png'),
('Wailord',321 ,170, 90, 45, 90, 45, 60, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wailord.png'),
('Numel',322 ,60, 60, 40, 65, 45, 35, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/numel.png'),
('Camerupt',323 ,70, 100, 70, 105, 75, 40, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/camerupt.png'),
('Torkoal',324 ,70, 85, 140, 85, 70, 20, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/torkoal.png'),
('Spoink',325 ,60, 25, 35, 70, 80, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/spoink.png'),
('Grumpig',326 ,80, 45, 65, 90, 110, 80, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/grumpig.png'),
('Spinda',327 ,60, 60, 60, 60, 60, 60, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/spinda.png'),
('Trapinch',328 ,45, 100, 45, 45, 45, 10, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/trapinch.png'),
('Vibrava',329 ,50, 70, 50, 50, 50, 70, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vibrava.png'),
('Flygon',330 ,80, 100, 80, 80, 80, 100, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/flygon.png'),
('Cacnea',331 ,50, 85, 40, 85, 40, 35, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cacnea.png'),
('Cacturne',332 ,70, 115, 60, 115, 60, 55, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cacturne.png'),
('Swablu',333 ,45, 40, 60, 40, 75, 50, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/swablu.png'),
('Altaria',334 ,75, 70, 90, 70, 105, 80, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/altaria.png'),
('Zangoose',335 ,73, 115, 60, 60, 60, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zangoose.png'),
('Seviper',336 ,73, 100, 60, 100, 60, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/seviper.png'),
('Lunatone',337 ,90, 55, 65, 95, 85, 70, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lunatone.png'),
('Solrock',338 ,90, 95, 85, 55, 65, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/solrock.png'),
('Barboach',339 ,50, 48, 43, 46, 41, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/barboach.png'),
('Whiscash',340 ,110, 78, 73, 76, 71, 60, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/whiscash.png'),
('Corphish',341 ,43, 80, 65, 50, 35, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/corphish.png'),
('Crawdaunt',342 ,63, 120, 85, 90, 55, 55, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/crawdaunt.png'),
('Baltoy',343 ,40, 40, 55, 40, 70, 55, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/baltoy.png'),
('Claydol',344 ,60, 70, 105, 70, 120, 75, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/claydol.png'),
('Lileep',345 ,66, 41, 77, 61, 87, 23, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lileep.png'),
('Cradily',346 ,86, 81, 97, 81, 107, 43, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cradily.png'),
('Anorith',347 ,45, 95, 50, 40, 50, 75, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/anorith.png'),
('Armaldo',348 ,75, 125, 100, 70, 80, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/armaldo.png'),
('Feebas',349 ,20, 15, 20, 10, 55, 80, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/feebas.png'),
('Milotic',350 ,95, 60, 79, 100, 125, 81, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/milotic.png'),
('Castform',351 ,70, 70, 70, 70, 70, 70, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/castform.png'),
('Kecleon',352 ,60, 90, 70, 60, 120, 40, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kecleon.png'),
('Shuppet',353 ,44, 75, 35, 63, 33, 45, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shuppet.png'),
('Banette',354 ,64, 115, 65, 83, 63, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/banette.png'),
('Duskull',355 ,20, 40, 90, 30, 90, 25, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/duskull.png'),
('Dusclops',356 ,40, 70, 130, 60, 130, 25, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dusclops.png'),
('Tropius',357 ,99, 68, 83, 72, 87, 51, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tropius.png'),
('Chimecho',358 ,75, 50, 80, 95, 90, 65, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/chimecho.png'),
('Absol',359 ,65, 130, 60, 75, 60, 75, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/absol.png'),
('Wynaut',360 ,95, 23, 48, 23, 48, 23, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wynaut.png'),
('Snorunt',361 ,50, 50, 50, 50, 50, 50, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/snorunt.png'),
('Glalie',362 ,80, 80, 80, 80, 80, 80, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/glalie.png'),
('Spheal',363 ,70, 40, 50, 55, 50, 25, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/spheal.png'),
('Sealeo',364 ,90, 60, 70, 75, 70, 45, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sealeo.png'),
('Walrein',365 ,110, 80, 90, 95, 90, 65, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/walrein.png'),
('Clamperl',366 ,35, 64, 85, 74, 55, 32, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/clamperl.png'),
('Huntail',367 ,55, 104, 105, 94, 75, 52, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/huntail.png'),
('Gorebyss',368 ,55, 84, 105, 114, 75, 52, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gorebyss.png'),
('Relicanth',369 ,100, 90, 130, 45, 65, 55, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/relicanth.png'),
('Luvdisc',370 ,43, 30, 55, 40, 65, 97, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/luvdisc.png'),
('Bagon',371 ,45, 75, 60, 40, 30, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bagon.png'),
('Shelgon',372 ,65, 95, 100, 60, 50, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shelgon.png'),
('Salamence',373 ,95, 135, 80, 110, 80, 100, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/salamence.png'),
('Beldum',374 ,40, 55, 80, 35, 60, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/beldum.png'),
('Metang',375 ,60, 75, 100, 55, 80, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/metang.png'),
('Metagross',376 ,80, 135, 130, 95, 90, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/metagross.png'),
('Regirock',377 ,80, 100, 200, 50, 100, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/regirock.png'),
('Regice',378 ,80, 50, 100, 100, 200, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/regice.png'),
('Registeel',379 ,80, 75, 150, 75, 150, 50, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/registeel.png'),
('Latias',380 ,80, 80, 90, 110, 130, 110, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/latias.png'),
('Latios',381 ,80, 90, 80, 130, 110, 110, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/latios.png'),
('Kyogre',382 ,100, 100, 90, 150, 140, 90, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kyogre.png'),
('Groudon',383 ,100, 150, 140, 100, 90, 90, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/groudon.png'),
('Rayquaza',384 ,105, 150, 90, 150, 90, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rayquaza.png'),
('Jirachi',385 ,100, 100, 100, 100, 100, 100, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/jirachi.png'),
('Deoxys Normal',386 ,50, 150, 50, 150, 50, 150, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/deoxys-normal.png'),
('Turtwig',387 ,55, 68, 64, 45, 55, 31, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/turtwig.png'),
('Grotle',388 ,75, 89, 85, 55, 65, 36, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/grotle.png'),
('Torterra',389 ,95, 109, 105, 75, 85, 56, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/torterra.png'),
('Chimchar',390 ,44, 58, 44, 58, 44, 61, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/chimchar.png'),
('Monferno',391 ,64, 78, 52, 78, 52, 81, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/monferno.png'),
('Infernape',392 ,76, 104, 71, 104, 71, 108, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/infernape.png'),
('Piplup',393 ,53, 51, 53, 61, 56, 40, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/piplup.png'),
('Prinplup',394 ,64, 66, 68, 81, 76, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/prinplup.png'),
('Empoleon',395 ,84, 86, 88, 111, 101, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/empoleon.png'),
('Starly',396 ,40, 55, 30, 30, 30, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/starly.png'),
('Staravia',397 ,55, 75, 50, 40, 40, 80, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/staravia.png'),
('Staraptor',398 ,85, 120, 70, 50, 60, 100, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/staraptor.png'),
('Bidoof',399 ,59, 45, 40, 35, 40, 31, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bidoof.png'),
('Bibarel',400 ,79, 85, 60, 55, 60, 71, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bibarel.png'),
('Kricketot',401 ,37, 25, 41, 25, 41, 25, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kricketot.png'),
('Kricketune',402 ,77, 85, 51, 55, 51, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kricketune.png'),
('Shinx',403 ,45, 65, 34, 40, 34, 45, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shinx.png'),
('Luxio',404 ,60, 85, 49, 60, 49, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/luxio.png'),
('Luxray',405 ,80, 120, 79, 95, 79, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/luxray.png'),
('Budew',406 ,40, 30, 35, 50, 70, 55, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/budew.png'),
('Roserade',407 ,60, 70, 65, 125, 105, 90, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/roserade.png'),
('Cranidos',408 ,67, 125, 40, 30, 30, 58, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cranidos.png'),
('Rampardos',409 ,97, 165, 60, 65, 50, 58, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rampardos.png'),
('Shieldon',410 ,30, 42, 118, 42, 88, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shieldon.png'),
('Bastiodon',411 ,60, 52, 168, 47, 138, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bastiodon.png'),
('Burmy',412 ,40, 29, 45, 29, 45, 36, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/burmy.png'),
('Wormadam Plant',413 ,60, 59, 85, 79, 105, 36, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wormadam-plant.png'),
('Mothim',414 ,70, 94, 50, 94, 50, 66, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mothim.png'),
('Combee',415 ,30, 30, 42, 30, 42, 70, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/combee.png'),
('Vespiquen',416 ,70, 80, 102, 80, 102, 40, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vespiquen.png'),
('Pachirisu',417 ,60, 45, 70, 45, 90, 95, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pachirisu.png'),
('Buizel',418 ,55, 65, 35, 60, 30, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/buizel.png'),
('Floatzel',419 ,85, 105, 55, 85, 50, 115, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/floatzel.png'),
('Cherubi',420 ,45, 35, 45, 62, 53, 35, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cherubi.png'),
('Cherrim',421 ,70, 60, 70, 87, 78, 85, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cherrim.png'),
('Shellos',422 ,76, 48, 48, 57, 62, 34, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shellos.png'),
('Gastrodon',423 ,111, 83, 68, 92, 82, 39, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gastrodon.png'),
('Ambipom',424 ,75, 100, 66, 60, 66, 115, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ambipom.png'),
('Drifloon',425 ,90, 50, 34, 60, 44, 70, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/drifloon.png'),
('Drifblim',426 ,150, 80, 44, 90, 54, 80, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/drifblim.png'),
('Buneary',427 ,55, 66, 44, 44, 56, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/buneary.png'),
('Lopunny',428 ,65, 76, 84, 54, 96, 105, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lopunny.png'),
('Mismagius',429 ,60, 60, 60, 105, 105, 105, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mismagius.png'),
('Honchkrow',430 ,100, 125, 52, 105, 52, 71, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/honchkrow.png'),
('Glameow',431 ,49, 55, 42, 42, 37, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/glameow.png'),
('Purugly',432 ,71, 82, 64, 64, 59, 112, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/purugly.png'),
('Chingling',433 ,45, 30, 50, 65, 50, 45, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/chingling.png'),
('Stunky',434 ,63, 63, 47, 41, 41, 74, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/stunky.png'),
('Skuntank',435 ,103, 93, 67, 71, 61, 84, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/skuntank.png'),
('Bronzor',436 ,57, 24, 86, 24, 86, 23, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bronzor.png'),
('Bronzong',437 ,67, 89, 116, 79, 116, 33, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bronzong.png'),
('Bonsly',438 ,50, 80, 95, 10, 45, 10, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bonsly.png'),
('Mime Jr',439 ,20, 25, 45, 70, 90, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mime-jr.png'),
('Happiny',440 ,100, 5, 5, 15, 65, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/happiny.png'),
('Chatot',441 ,76, 65, 45, 92, 42, 91, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/chatot.png'),
('Spiritomb',442 ,50, 92, 108, 92, 108, 35, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/spiritomb.png'),
('Gible',443 ,58, 70, 45, 40, 45, 42, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gible.png'),
('Gabite',444 ,68, 90, 65, 50, 55, 82, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gabite.png'),
('Garchomp',445 ,108, 130, 95, 80, 85, 102, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/garchomp.png'),
('Munchlax',446 ,135, 85, 40, 40, 85, 5, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/munchlax.png'),
('Riolu',447 ,40, 70, 40, 35, 40, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/riolu.png'),
('Lucario',448 ,70, 110, 70, 115, 70, 90, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lucario.png'),
('Hippopotas',449 ,68, 72, 78, 38, 42, 32, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hippopotas.png'),
('Hippowdon',450 ,108, 112, 118, 68, 72, 47, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hippowdon.png'),
('Skorupi',451 ,40, 50, 90, 30, 55, 65, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/skorupi.png'),
('Drapion',452 ,70, 90, 110, 60, 75, 95, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/drapion.png'),
('Croagunk',453 ,48, 61, 40, 61, 40, 50, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/croagunk.png'),
('Toxicroak',454 ,83, 106, 65, 86, 65, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/toxicroak.png'),
('Carnivine',455 ,74, 100, 72, 90, 72, 46, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/carnivine.png'),
('Finneon',456 ,49, 49, 56, 49, 61, 66, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/finneon.png'),
('Lumineon',457 ,69, 69, 76, 69, 86, 91, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lumineon.png'),
('Mantyke',458 ,45, 20, 50, 60, 120, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mantyke.png'),
('Snover',459 ,60, 62, 50, 62, 60, 40, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/snover.png'),
('Abomasnow',460 ,90, 92, 75, 92, 85, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/abomasnow.png'),
('Weavile',461 ,70, 120, 65, 45, 85, 125, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/weavile.png'),
('Magnezone',462 ,70, 70, 115, 130, 90, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/magnezone.png'),
('Lickilicky',463 ,110, 85, 95, 80, 95, 50, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lickilicky.png'),
('Rhyperior',464 ,115, 140, 130, 55, 55, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rhyperior.png'),
('Tangrowth',465 ,100, 100, 125, 110, 50, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tangrowth.png'),
('Electivire',466 ,75, 123, 67, 95, 85, 95, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/electivire.png'),
('Magmortar',467 ,75, 95, 67, 125, 95, 83, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/magmortar.png'),
('Togekiss',468 ,85, 50, 95, 120, 115, 80, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/togekiss.png'),
('Yanmega',469 ,86, 76, 86, 116, 56, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/yanmega.png'),
('Leafeon',470 ,65, 110, 130, 60, 65, 95, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/leafeon.png'),
('Glaceon',471 ,65, 60, 110, 130, 95, 65, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/glaceon.png'),
('Gliscor',472 ,75, 95, 125, 45, 75, 95, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gliscor.png'),
('Mamoswine',473 ,110, 130, 80, 70, 60, 80, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mamoswine.png'),
('Porygon Z',474 ,85, 80, 70, 135, 75, 90, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/porygon-z.png'),
('Gallade',475 ,68, 125, 65, 65, 115, 80, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gallade.png'),
('Probopass',476 ,60, 55, 145, 75, 150, 40, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/probopass.png'),
('Dusknoir',477 ,45, 100, 135, 65, 135, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dusknoir.png'),
('Froslass',478 ,70, 80, 70, 80, 70, 110, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/froslass.png'),
('Rotom',479 ,50, 50, 77, 95, 77, 91, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rotom.png'),
('Uxie',480 ,75, 75, 130, 75, 130, 95, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/uxie.png'),
('Mesprit',481 ,80, 105, 105, 105, 105, 80, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mesprit.png'),
('Azelf',482 ,75, 125, 70, 125, 70, 115, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/azelf.png'),
('Dialga',483 ,100, 120, 120, 150, 100, 90, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dialga.png'),
('Palkia',484 ,90, 120, 100, 150, 120, 100, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/palkia.png'),
('Heatran',485 ,91, 90, 106, 130, 106, 77, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/heatran.png'),
('Regigigas',486 ,110, 160, 110, 80, 110, 100, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/regigigas.png'),
('Giratina Altered',487 ,150, 100, 120, 100, 120, 90, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/giratina-altered.png'),
('Cresselia',488 ,120, 70, 120, 75, 130, 85, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cresselia.png'),
('Phione',489 ,80, 80, 80, 80, 80, 80, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/phione.png'),
('Manaphy',490 ,100, 100, 100, 100, 100, 100, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/manaphy.png'),
('Darkrai',491 ,70, 90, 90, 135, 90, 125, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/darkrai.png'),
('Shaymin Land',492 ,100, 100, 100, 100, 100, 100, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shaymin-land.png'),
('Arceus',493 ,120, 120, 120, 120, 120, 120, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/arceus.png'),
('Victini',494 ,100, 100, 100, 100, 100, 100, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/victini.png'),
('Snivy',495 ,45, 45, 55, 45, 55, 63, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/snivy.png'),
('Servine',496 ,60, 60, 75, 60, 75, 83, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/servine.png'),
('Serperior',497 ,75, 75, 95, 75, 95, 113, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/serperior.png'),
('Tepig',498 ,65, 63, 45, 45, 45, 45, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tepig.png'),
('Pignite',499 ,90, 93, 55, 70, 55, 55, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pignite.png'),
('Emboar',500 ,110, 123, 65, 100, 65, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/emboar.png'),
('Oshawott',501 ,55, 55, 45, 63, 45, 45, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/oshawott.png'),
('Dewott',502 ,75, 75, 60, 83, 60, 60, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dewott.png'),
('Samurott',503 ,95, 100, 85, 108, 70, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/samurott.png'),
('Patrat',504 ,45, 55, 39, 35, 39, 42, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/patrat.png'),
('Watchog',505 ,60, 85, 69, 60, 69, 77, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/watchog.png'),
('Lillipup',506 ,45, 60, 45, 25, 45, 55, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lillipup.png'),
('Herdier',507 ,65, 80, 65, 35, 65, 60, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/herdier.png'),
('Stoutland',508 ,85, 110, 90, 45, 90, 80, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/stoutland.png'),
('Purrloin',509 ,41, 50, 37, 50, 37, 66, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/purrloin.png'),
('Liepard',510 ,64, 88, 50, 88, 50, 106, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/liepard.png'),
('Pansage',511 ,50, 53, 48, 53, 48, 64, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pansage.png'),
('Simisage',512 ,75, 98, 63, 98, 63, 101, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/simisage.png'),
('Pansear',513 ,50, 53, 48, 53, 48, 64, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pansear.png'),
('Simisear',514 ,75, 98, 63, 98, 63, 101, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/simisear.png'),
('Panpour',515 ,50, 53, 48, 53, 48, 64, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/panpour.png'),
('Simipour',516 ,75, 98, 63, 98, 63, 101, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/simipour.png'),
('Munna',517 ,76, 25, 45, 67, 55, 24, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/munna.png'),
('Musharna',518 ,116, 55, 85, 107, 95, 29, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/musharna.png'),
('Pidove',519 ,50, 55, 50, 36, 30, 43, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pidove.png'),
('Tranquill',520 ,62, 77, 62, 50, 42, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tranquill.png'),
('Unfezant',521 ,80, 115, 80, 65, 55, 93, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/unfezant.png'),
('Blitzle',522 ,45, 60, 32, 50, 32, 76, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/blitzle.png'),
('Zebstrika',523 ,75, 100, 63, 80, 63, 116, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zebstrika.png'),
('Roggenrola',524 ,55, 75, 85, 25, 25, 15, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/roggenrola.png'),
('Boldore',525 ,70, 105, 105, 50, 40, 20, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/boldore.png'),
('Gigalith',526 ,85, 135, 130, 60, 80, 25, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gigalith.png'),
('Woobat',527 ,65, 45, 43, 55, 43, 72, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/woobat.png'),
('Swoobat',528 ,67, 57, 55, 77, 55, 114, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/swoobat.png'),
('Drilbur',529 ,60, 85, 40, 30, 45, 68, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/drilbur.png'),
('Excadrill',530 ,110, 135, 60, 50, 65, 88, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/excadrill.png'),
('Audino',531 ,103, 60, 86, 60, 86, 50, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/audino.png'),
('Timburr',532 ,75, 80, 55, 25, 35, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/timburr.png'),
('Gurdurr',533 ,85, 105, 85, 40, 50, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gurdurr.png'),
('Conkeldurr',534 ,105, 140, 95, 55, 65, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/conkeldurr.png'),
('Tympole',535 ,50, 50, 40, 50, 40, 64, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tympole.png'),
('Palpitoad',536 ,75, 65, 55, 65, 55, 69, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/palpitoad.png'),
('Seismitoad',537 ,105, 95, 75, 85, 75, 74, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/seismitoad.png'),
('Throh',538 ,120, 100, 85, 30, 85, 45, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/throh.png'),
('Sawk',539 ,75, 125, 75, 30, 75, 85, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sawk.png'),
('Sewaddle',540 ,45, 53, 70, 40, 60, 42, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sewaddle.png'),
('Swadloon',541 ,55, 63, 90, 50, 80, 42, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/swadloon.png'),
('Leavanny',542 ,75, 103, 80, 70, 80, 92, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/leavanny.png'),
('Venipede',543 ,30, 45, 59, 30, 39, 57, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/venipede.png'),
('Whirlipede',544 ,40, 55, 99, 40, 79, 47, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/whirlipede.png'),
('Scolipede',545 ,60, 100, 89, 55, 69, 112, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/scolipede.png'),
('Cottonee',546 ,40, 27, 60, 37, 50, 66, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cottonee.png'),
('Whimsicott',547 ,60, 67, 85, 77, 75, 116, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/whimsicott.png'),
('Petilil',548 ,45, 35, 50, 70, 50, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/petilil.png'),
('Lilligant',549 ,70, 60, 75, 110, 75, 90, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lilligant.png'),
('Basculin Red Striped',550 ,70, 92, 65, 80, 55, 98, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/basculin-red-striped.png'),
('Sandile',551 ,50, 72, 35, 35, 35, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sandile.png'),
('Krokorok',552 ,60, 82, 45, 45, 45, 74, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/krokorok.png'),
('Krookodile',553 ,95, 117, 80, 65, 70, 92, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/krookodile.png'),
('Darumaka',554 ,70, 90, 45, 15, 45, 50, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/darumaka.png'),
('Darmanitan Standard',555 ,105, 140, 55, 30, 55, 95, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/darmanitan-standard.png'),
('Maractus',556 ,75, 86, 67, 106, 67, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/maractus.png'),
('Dwebble',557 ,50, 65, 85, 35, 35, 55, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dwebble.png'),
('Crustle',558 ,70, 105, 125, 65, 75, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/crustle.png'),
('Scraggy',559 ,50, 75, 70, 35, 70, 48, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/scraggy.png'),
('Scrafty',560 ,65, 90, 115, 45, 115, 58, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/scrafty.png'),
('Sigilyph',561 ,72, 58, 80, 103, 80, 97, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sigilyph.png'),
('Yamask',562 ,38, 30, 85, 55, 65, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/yamask.png'),
('Cofagrigus',563 ,58, 50, 145, 95, 105, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cofagrigus.png'),
('Tirtouga',564 ,54, 78, 103, 53, 45, 22, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tirtouga.png'),
('Carracosta',565 ,74, 108, 133, 83, 65, 32, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/carracosta.png'),
('Archen',566 ,55, 112, 45, 74, 45, 70, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/archen.png'),
('Archeops',567 ,75, 140, 65, 112, 65, 110, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/archeops.png'),
('Trubbish',568 ,50, 50, 62, 40, 62, 65, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/trubbish.png'),
('Garbodor',569 ,80, 95, 82, 60, 82, 75, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/garbodor.png'),
('Zorua',570 ,40, 65, 40, 80, 40, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zorua.png'),
('Zoroark',571 ,60, 105, 60, 120, 60, 105, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zoroark.png'),
('Minccino',572 ,55, 50, 40, 40, 40, 75, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/minccino.png'),
('Cinccino',573 ,75, 95, 60, 65, 60, 115, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cinccino.png'),
('Gothita',574 ,45, 30, 50, 55, 65, 45, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gothita.png'),
('Gothorita',575 ,60, 45, 70, 75, 85, 55, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gothorita.png'),
('Gothitelle',576 ,70, 55, 95, 95, 110, 65, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gothitelle.png'),
('Solosis',577 ,45, 30, 40, 105, 50, 20, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/solosis.png'),
('Duosion',578 ,65, 40, 50, 125, 60, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/duosion.png'),
('Reuniclus',579 ,110, 65, 75, 125, 85, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/reuniclus.png'),
('Ducklett',580 ,62, 44, 50, 44, 50, 55, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ducklett.png'),
('Swanna',581 ,75, 87, 63, 87, 63, 98, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/swanna.png'),
('Vanillite',582 ,36, 50, 50, 65, 60, 44, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vanillite.png'),
('Vanillish',583 ,51, 65, 65, 80, 75, 59, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vanillish.png'),
('Vanilluxe',584 ,71, 95, 85, 110, 95, 79, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vanilluxe.png'),
('Deerling',585 ,60, 60, 50, 40, 50, 75, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/deerling.png'),
('Sawsbuck',586 ,80, 100, 70, 60, 70, 95, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sawsbuck.png'),
('Emolga',587 ,55, 75, 60, 75, 60, 103, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/emolga.png'),
('Karrablast',588 ,50, 75, 45, 40, 45, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/karrablast.png'),
('Escavalier',589 ,70, 135, 105, 60, 105, 20, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/escavalier.png'),
('Foongus',590 ,69, 55, 45, 55, 55, 15, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/foongus.png'),
('Amoonguss',591 ,114, 85, 70, 85, 80, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/amoonguss.png'),
('Frillish',592 ,55, 40, 50, 65, 85, 40, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/frillish.png'),
('Jellicent',593 ,100, 60, 70, 85, 105, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/jellicent.png'),
('Alomomola',594 ,165, 75, 80, 40, 45, 65, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/alomomola.png'),
('Joltik',595 ,50, 47, 50, 57, 50, 65, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/joltik.png'),
('Galvantula',596 ,70, 77, 60, 97, 60, 108, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/galvantula.png'),
('Ferroseed',597 ,44, 50, 91, 24, 86, 10, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ferroseed.png'),
('Ferrothorn',598 ,74, 94, 131, 54, 116, 20, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ferrothorn.png'),
('Klink',599 ,40, 55, 70, 45, 60, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/klink.png'),
('Klang',600 ,60, 80, 95, 70, 85, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/klang.png'),
('Klinklang',601 ,60, 100, 115, 70, 85, 90, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/klinklang.png'),
('Tynamo',602 ,35, 55, 40, 45, 40, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tynamo.png'),
('Eelektrik',603 ,65, 85, 70, 75, 70, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/eelektrik.png'),
('Eelektross',604 ,85, 115, 80, 105, 80, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/eelektross.png'),
('Elgyem',605 ,55, 55, 55, 85, 55, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/elgyem.png'),
('Beheeyem',606 ,75, 75, 75, 125, 95, 40, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/beheeyem.png'),
('Litwick',607 ,50, 30, 55, 65, 55, 20, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/litwick.png'),
('Lampent',608 ,60, 40, 60, 95, 60, 55, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lampent.png'),
('Chandelure',609 ,60, 55, 90, 145, 90, 80, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/chandelure.png'),
('Axew',610 ,46, 87, 60, 30, 40, 57, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/axew.png'),
('Fraxure',611 ,66, 117, 70, 40, 50, 67, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/fraxure.png'),
('Haxorus',612 ,76, 147, 90, 60, 70, 97, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/haxorus.png'),
('Cubchoo',613 ,55, 70, 40, 60, 40, 40, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cubchoo.png'),
('Beartic',614 ,95, 130, 80, 70, 80, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/beartic.png'),
('Cryogonal',615 ,80, 50, 50, 95, 135, 105, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cryogonal.png'),
('Shelmet',616 ,50, 40, 85, 40, 65, 25, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shelmet.png'),
('Accelgor',617 ,80, 70, 40, 100, 60, 145, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/accelgor.png'),
('Stunfisk',618 ,109, 66, 84, 81, 99, 32, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/stunfisk.png'),
('Mienfoo',619 ,45, 85, 50, 55, 50, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mienfoo.png'),
('Mienshao',620 ,65, 125, 60, 95, 60, 105, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mienshao.png'),
('Druddigon',621 ,77, 120, 90, 60, 90, 48, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/druddigon.png'),
('Golett',622 ,59, 74, 50, 35, 50, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/golett.png'),
('Golurk',623 ,89, 124, 80, 55, 80, 55, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/golurk.png'),
('Pawniard',624 ,45, 85, 70, 40, 40, 60, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pawniard.png'),
('Bisharp',625 ,65, 125, 100, 60, 70, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bisharp.png'),
('Bouffalant',626 ,95, 110, 95, 40, 95, 55, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bouffalant.png'),
('Rufflet',627 ,70, 83, 50, 37, 50, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rufflet.png'),
('Braviary',628 ,100, 123, 75, 57, 75, 80, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/braviary.png'),
('Vullaby',629 ,70, 55, 75, 45, 65, 60, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vullaby.png'),
('Mandibuzz',630 ,110, 65, 105, 55, 95, 80, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mandibuzz.png'),
('Heatmor',631 ,85, 97, 66, 105, 66, 65, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/heatmor.png'),
('Durant',632 ,58, 109, 112, 48, 48, 109, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/durant.png'),
('Deino',633 ,52, 65, 50, 45, 50, 38, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/deino.png'),
('Zweilous',634 ,72, 85, 70, 65, 70, 58, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zweilous.png'),
('Hydreigon',635 ,92, 105, 90, 125, 90, 98, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hydreigon.png'),
('Larvesta',636 ,55, 85, 55, 50, 55, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/larvesta.png'),
('Volcarona',637 ,85, 60, 65, 135, 105, 100, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/volcarona.png'),
('Cobalion',638 ,91, 90, 129, 90, 72, 108, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cobalion.png'),
('Terrakion',639 ,91, 129, 90, 72, 90, 108, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/terrakion.png'),
('Virizion',640 ,91, 90, 72, 90, 129, 108, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/virizion.png'),
('Tornadus Incarnate',641 ,79, 115, 70, 125, 80, 111, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tornadus-incarnate.png'),
('Thundurus Incarnate',642 ,79, 115, 70, 125, 80, 111, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/thundurus-incarnate.png'),
('Reshiram',643 ,100, 120, 100, 150, 120, 90, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/reshiram.png'),
('Zekrom',644 ,100, 150, 120, 120, 100, 90, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zekrom.png'),
('Landorus Incarnate',645 ,89, 125, 90, 115, 80, 101, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/landorus-incarnate.png'),
('Kyurem',646 ,125, 130, 90, 130, 90, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kyurem.png'),
('Keldeo Ordinary',647 ,91, 72, 90, 129, 90, 108, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/keldeo-ordinary.png'),
('Meloetta Aria',648 ,100, 77, 77, 128, 128, 90, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/meloetta-aria.png'),
('Genesect',649 ,71, 120, 95, 120, 95, 99, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/genesect.png'),
('Chespin',650 ,56, 61, 65, 48, 45, 38, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/chespin.png'),
('Quilladin',651 ,61, 78, 95, 56, 58, 57, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/quilladin.png'),
('Chesnaught',652 ,88, 107, 122, 74, 75, 64, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/chesnaught.png'),
('Fennekin',653 ,40, 45, 40, 62, 60, 60, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/fennekin.png'),
('Braixen',654 ,59, 59, 58, 90, 70, 73, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/braixen.png'),
('Delphox',655 ,75, 69, 72, 114, 100, 104, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/delphox.png'),
('Froakie',656 ,41, 56, 40, 62, 44, 71, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/froakie.png'),
('Frogadier',657 ,54, 63, 52, 83, 56, 97, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/frogadier.png'),
('Greninja',658 ,72, 95, 67, 103, 71, 122, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/greninja.png'),
('Bunnelby',659 ,38, 36, 38, 32, 36, 57, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bunnelby.png'),
('Diggersby',660 ,85, 56, 77, 50, 77, 78, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/diggersby.png'),
('Fletchling',661 ,45, 50, 43, 40, 38, 62, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/fletchling.png'),
('Fletchinder',662 ,62, 73, 55, 56, 52, 84, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/fletchinder.png'),
('Talonflame',663 ,78, 81, 71, 74, 69, 126, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/talonflame.png'),
('Scatterbug',664 ,38, 35, 40, 27, 25, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/scatterbug.png'),
('Spewpa',665 ,45, 22, 60, 27, 30, 29, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/spewpa.png'),
('Vivillon',666 ,80, 52, 50, 90, 50, 89, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vivillon.png'),
('Litleo',667 ,62, 50, 58, 73, 54, 72, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/litleo.png'),
('Pyroar',668 ,86, 68, 72, 109, 66, 106, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pyroar.png'),
('Flabebe',669 ,44, 38, 39, 61, 79, 42, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/flabebe.png'),
('Floette',670 ,54, 45, 47, 75, 98, 52, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/floette.png'),
('Florges',671 ,78, 65, 68, 112, 154, 75, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/florges.png'),
('Skiddo',672 ,66, 65, 48, 62, 57, 52, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/skiddo.png'),
('Gogoat',673 ,123, 100, 62, 97, 81, 68, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gogoat.png'),
('Pancham',674 ,67, 82, 62, 46, 48, 43, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pancham.png'),
('Pangoro',675 ,95, 124, 78, 69, 71, 58, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pangoro.png'),
('Furfrou',676 ,75, 80, 60, 65, 90, 102, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/furfrou.png'),
('Espurr',677 ,62, 48, 54, 63, 60, 68, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/espurr.png'),
('Meowstic Male',678 ,74, 48, 76, 83, 81, 104, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/meowstic-male.png'),
('Honedge',679 ,45, 80, 100, 35, 37, 28, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/honedge.png'),
('Doublade',680 ,59, 110, 150, 45, 49, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/doublade.png'),
('Aegislash Shield',681 ,60, 50, 140, 50, 140, 60, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/aegislash-shield.png'),
('Spritzee',682 ,78, 52, 60, 63, 65, 23, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/spritzee.png'),
('Aromatisse',683 ,101, 72, 72, 99, 89, 29, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/aromatisse.png'),
('Swirlix',684 ,62, 48, 66, 59, 57, 49, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/swirlix.png'),
('Slurpuff',685 ,82, 80, 86, 85, 75, 72, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/slurpuff.png'),
('Inkay',686 ,53, 54, 53, 37, 46, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/inkay.png'),
('Malamar',687 ,86, 92, 88, 68, 75, 73, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/malamar.png'),
('Binacle',688 ,42, 52, 67, 39, 56, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/binacle.png'),
('Barbaracle',689 ,72, 105, 115, 54, 86, 68, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/barbaracle.png'),
('Skrelp',690 ,50, 60, 60, 60, 60, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/skrelp.png'),
('Dragalge',691 ,65, 75, 90, 97, 123, 44, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dragalge.png'),
('Clauncher',692 ,50, 53, 62, 58, 63, 44, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/clauncher.png'),
('Clawitzer',693 ,71, 73, 88, 120, 89, 59, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/clawitzer.png'),
('Helioptile',694 ,44, 38, 33, 61, 43, 70, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/helioptile.png'),
('Heliolisk',695 ,62, 55, 52, 109, 94, 109, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/heliolisk.png'),
('Tyrunt',696 ,58, 89, 77, 45, 45, 48, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tyrunt.png'),
('Tyrantrum',697 ,82, 121, 119, 69, 59, 71, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tyrantrum.png'),
('Amaura',698 ,77, 59, 50, 67, 63, 46, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/amaura.png'),
('Aurorus',699 ,123, 77, 72, 99, 92, 58, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/aurorus.png'),
('Sylveon',700 ,95, 65, 65, 110, 130, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sylveon.png'),
('Hawlucha',701 ,78, 92, 75, 74, 63, 118, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hawlucha.png'),
('Dedenne',702 ,67, 58, 57, 81, 67, 101, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dedenne.png'),
('Carbink',703 ,50, 50, 150, 50, 150, 50, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/carbink.png'),
('Goomy',704 ,45, 50, 35, 55, 75, 40, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/goomy.png'),
('Sliggoo',705 ,68, 75, 53, 83, 113, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sliggoo.png'),
('Goodra',706 ,90, 100, 70, 110, 150, 80, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/goodra.png'),
('Klefki',707 ,57, 80, 91, 80, 87, 75, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/klefki.png'),
('Phantump',708 ,43, 70, 48, 50, 60, 38, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/phantump.png'),
('Trevenant',709 ,85, 110, 76, 65, 82, 56, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/trevenant.png'),
('Pumpkaboo Average',710 ,49, 66, 70, 44, 55, 51, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pumpkaboo-average.png'),
('Gourgeist Average',711 ,65, 90, 122, 58, 75, 84, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gourgeist-average.png'),
('Bergmite',712 ,55, 69, 85, 32, 35, 28, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bergmite.png'),
('Avalugg',713 ,95, 117, 184, 44, 46, 28, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/avalugg.png'),
('Noibat',714 ,40, 30, 35, 45, 40, 55, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/noibat.png'),
('Noivern',715 ,85, 70, 80, 97, 80, 123, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/noivern.png'),
('Xerneas',716 ,126, 131, 95, 131, 98, 99, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/xerneas.png'),
('Yveltal',717 ,126, 131, 95, 131, 98, 99, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/yveltal.png'),
('Zygarde 50',718 ,108, 100, 121, 81, 95, 95, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zygarde-50.png'),
('Diancie',719 ,50, 100, 150, 100, 150, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/diancie.png'),
('Hoopa Confined',720 ,80, 110, 60, 150, 130, 70, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hoopa-confined.png'),
('Volcanion',721 ,80, 110, 120, 130, 90, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/volcanion.png'),
('Rowlet',722 ,68, 55, 55, 50, 50, 42, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rowlet.png'),
('Dartrix',723 ,78, 75, 75, 70, 70, 52, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dartrix.png'),
('Decidueye',724 ,78, 107, 75, 100, 100, 70, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/decidueye.png'),
('Litten',725 ,45, 65, 40, 60, 40, 70, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/litten.png'),
('Torracat',726 ,65, 85, 50, 80, 50, 90, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/torracat.png'),
('Incineroar',727 ,95, 115, 90, 80, 90, 60, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/incineroar.png'),
('Popplio',728 ,50, 54, 54, 66, 56, 40, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/popplio.png'),
('Brionne',729 ,60, 69, 69, 91, 81, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/brionne.png'),
('Primarina',730 ,80, 74, 74, 126, 116, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/primarina.png'),
('Pikipek',731 ,35, 75, 30, 30, 30, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pikipek.png'),
('Trumbeak',732 ,55, 85, 50, 40, 50, 75, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/trumbeak.png'),
('Toucannon',733 ,80, 120, 75, 75, 75, 60, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/toucannon.png'),
('Yungoos',734 ,48, 70, 30, 30, 30, 45, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/yungoos.png'),
('Gumshoos',735 ,88, 110, 60, 55, 60, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gumshoos.png'),
('Grubbin',736 ,47, 62, 45, 55, 45, 46, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/grubbin.png'),
('Charjabug',737 ,57, 82, 95, 55, 75, 36, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/charjabug.png'),
('Vikavolt',738 ,77, 70, 90, 145, 75, 43, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/vikavolt.png'),
('Crabrawler',739 ,47, 82, 57, 42, 47, 63, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/crabrawler.png'),
('Crabominable',740 ,97, 132, 77, 62, 67, 43, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/crabominable.png'),
('Oricorio Baile',741 ,75, 70, 70, 98, 70, 93, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/oricorio-baile.png'),
('Cutiefly',742 ,40, 45, 40, 55, 40, 84, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cutiefly.png'),
('Ribombee',743 ,60, 55, 60, 95, 70, 124, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/ribombee.png'),
('Rockruff',744 ,45, 65, 40, 30, 40, 60, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rockruff.png'),
('Lycanroc Midday',745 ,75, 115, 65, 55, 65, 112, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lycanroc-midday.png'),
('Wishiwashi Solo',746 ,45, 20, 20, 25, 25, 40, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wishiwashi-solo.png'),
('Mareanie',747 ,50, 53, 62, 43, 52, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mareanie.png'),
('Toxapex',748 ,50, 63, 152, 53, 142, 35, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/toxapex.png'),
('Mudbray',749 ,70, 100, 70, 45, 55, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mudbray.png'),
('Mudsdale',750 ,100, 125, 100, 55, 85, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mudsdale.png'),
('Dewpider',751 ,38, 40, 52, 40, 72, 27, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dewpider.png'),
('Araquanid',752 ,68, 70, 92, 50, 132, 42, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/araquanid.png'),
('Fomantis',753 ,40, 55, 35, 50, 35, 35, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/fomantis.png'),
('Lurantis',754 ,70, 105, 90, 80, 90, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lurantis.png'),
('Morelull',755 ,40, 35, 55, 65, 75, 15, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/morelull.png'),
('Shiinotic',756 ,60, 45, 80, 90, 100, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/shiinotic.png'),
('Salandit',757 ,48, 44, 40, 71, 40, 77, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/salandit.png'),
('Salazzle',758 ,68, 64, 60, 111, 60, 117, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/salazzle.png'),
('Stufful',759 ,70, 75, 50, 45, 50, 50, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/stufful.png'),
('Bewear',760 ,120, 125, 80, 55, 60, 60, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bewear.png'),
('Bounsweet',761 ,42, 30, 38, 30, 38, 32, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bounsweet.png'),
('Steenee',762 ,52, 40, 48, 40, 48, 62, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/steenee.png'),
('Tsareena',763 ,72, 120, 98, 50, 98, 72, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tsareena.png'),
('Comfey',764 ,51, 52, 90, 82, 110, 100, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/comfey.png'),
('Oranguru',765 ,90, 60, 80, 90, 110, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/oranguru.png'),
('Passimian',766 ,100, 120, 90, 40, 60, 80, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/passimian.png'),
('Wimpod',767 ,25, 35, 40, 20, 30, 80, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wimpod.png'),
('Golisopod',768 ,75, 125, 140, 60, 90, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/golisopod.png'),
('Sandygast',769 ,55, 55, 80, 70, 45, 15, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sandygast.png'),
('Palossand',770 ,85, 75, 110, 100, 75, 35, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/palossand.png'),
('Pyukumuku',771 ,55, 60, 130, 30, 130, 5, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pyukumuku.png'),
('Type Null',772 ,95, 95, 95, 95, 95, 59, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/type-null.png'),
('Silvally',773 ,95, 95, 95, 95, 95, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/silvally.png'),
('Minior Meteor',774 ,60, 60, 100, 60, 100, 60, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/minior-meteor.png'),
('Komala',775 ,65, 115, 65, 75, 95, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/komala.png'),
('Turtonator',776 ,60, 78, 135, 91, 85, 36, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/turtonator.png'),
('Togedemaru',777 ,65, 98, 63, 40, 73, 96, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/togedemaru.png'),
('Mimikyu',778 ,55, 90, 80, 50, 105, 96, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mimikyu.png'),
('Bruxish',779 ,68, 105, 70, 70, 70, 92, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/bruxish.png'),
('Drampa',780 ,78, 60, 85, 135, 91, 36, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/drampa.png'),
('Dhelmise',781 ,70, 131, 100, 86, 90, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dhelmise.png'),
('Jangmo O',782 ,45, 55, 65, 45, 45, 45, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/jangmo-o.png'),
('Hakamo O',783 ,55, 75, 90, 65, 70, 65, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hakamo-o.png'),
('Kommo O',784 ,75, 110, 125, 100, 105, 85, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kommo-o.png'),
('Tapu Koko',785 ,70, 115, 85, 95, 75, 130, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tapu-koko.png'),
('Tapu Lele',786 ,70, 85, 75, 130, 115, 95, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tapu-lele.png'),
('Tapu Bulu',787 ,70, 130, 115, 85, 95, 75, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tapu-bulu.png'),
('Tapu Fini',788 ,70, 75, 115, 95, 130, 85, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/tapu-fini.png'),
('Cosmog',789 ,43, 29, 31, 29, 31, 37, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cosmog.png'),
('Cosmoem',790 ,43, 29, 131, 29, 131, 37, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cosmoem.png'),
('Solgaleo',791 ,137, 137, 107, 113, 89, 97, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/solgaleo.png'),
('Lunala',792 ,137, 113, 89, 137, 107, 97, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/lunala.png'),
('Nihilego',793 ,109, 53, 47, 127, 131, 103, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/nihilego.png'),
('Buzzwole',794 ,107, 139, 139, 53, 53, 79, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/buzzwole.png'),
('Pheromosa',795 ,71, 137, 37, 137, 37, 151, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pheromosa.png'),
('Xurkitree',796 ,83, 89, 71, 173, 71, 83, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/xurkitree.png'),
('Celesteela',797 ,97, 101, 103, 107, 101, 61, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/celesteela.png'),
('Kartana',798 ,59, 181, 131, 59, 31, 109, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kartana.png'),
('Guzzlord',799 ,223, 101, 53, 97, 53, 43, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/guzzlord.png'),
('Necrozma',800 ,97, 107, 101, 127, 89, 79, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/necrozma.png'),
('Magearna',801 ,80, 95, 115, 130, 115, 65, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/magearna.png'),
('Marshadow',802 ,90, 125, 80, 90, 90, 125, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/marshadow.png'),
('Poipole',803 ,67, 73, 67, 73, 67, 73, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/poipole.png'),
('Naganadel',804 ,73, 73, 73, 127, 73, 121, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/naganadel.png'),
('Stakataka',805 ,61, 131, 211, 53, 101, 13, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/stakataka.png'),
('Blacephalon',806 ,53, 127, 53, 151, 79, 107, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/blacephalon.png'),
('Zeraora',807 ,88, 112, 75, 102, 80, 143, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zeraora.png'),
('Meltan',808 ,46, 65, 65, 55, 35, 34, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/meltan.png'),
('Melmetal',809 ,135, 143, 143, 80, 65, 34, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/melmetal.png'),
('Grookey',810 ,50, 65, 50, 40, 40, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/grookey.png'),
('Thwackey',811 ,70, 85, 70, 55, 60, 80, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/thwackey.png'),
('Rillaboom',812 ,100, 125, 90, 60, 70, 85, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rillaboom.png'),
('Scorbunny',813 ,50, 71, 40, 40, 40, 69, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/scorbunny.png'),
('Raboot',814 ,65, 86, 60, 55, 60, 94, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/raboot.png'),
('Cinderace',815 ,80, 116, 75, 65, 75, 119, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cinderace.png'),
('Sobble',816 ,50, 40, 40, 70, 40, 70, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sobble.png'),
('Drizzile',817 ,65, 60, 55, 95, 55, 90, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/drizzile.png'),
('Inteleon',818 ,70, 85, 65, 125, 65, 120, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/inteleon.png'),
('Skwovet',819 ,70, 55, 55, 35, 35, 25, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/skwovet.png'),
('Greedent',820 ,120, 95, 95, 55, 75, 20, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/greedent.png'),
('Rookidee',821 ,38, 47, 35, 33, 35, 57, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rookidee.png'),
('Corvisquire',822 ,68, 67, 55, 43, 55, 77, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/corvisquire.png'),
('Corviknight',823 ,98, 87, 105, 53, 85, 67, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/corviknight.png'),
('Blipbug',824 ,25, 20, 20, 25, 45, 45, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/blipbug.png'),
('Dottler',825 ,50, 35, 80, 50, 90, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dottler.png'),
('Orbeetle',826 ,60, 45, 110, 80, 120, 90, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/orbeetle.png'),
('Nickit',827 ,40, 28, 28, 47, 52, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/nickit.png'),
('Thievul',828 ,70, 58, 58, 87, 92, 90, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/thievul.png'),
('Gossifleur',829 ,40, 40, 60, 40, 60, 10, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/gossifleur.png'),
('Eldegoss',830 ,60, 50, 90, 80, 120, 60, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/eldegoss.png'),
('Wooloo',831 ,42, 40, 55, 40, 45, 48, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/wooloo.png'),
('Dubwool',832 ,72, 80, 100, 60, 90, 88, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dubwool.png'),
('Chewtle',833 ,50, 64, 50, 38, 38, 44, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/chewtle.png'),
('Drednaw',834 ,90, 115, 90, 48, 68, 74, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/drednaw.png'),
('Yamper',835 ,59, 45, 50, 40, 50, 26, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/yamper.png'),
('Boltund',836 ,69, 90, 60, 90, 60, 121, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/boltund.png'),
('Rolycoly',837 ,30, 40, 50, 40, 50, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/rolycoly.png'),
('Carkol',838 ,80, 60, 90, 60, 70, 50, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/carkol.png'),
('Coalossal',839 ,110, 80, 120, 80, 90, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/coalossal.png'),
('Applin',840 ,40, 40, 80, 40, 40, 20, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/applin.png'),
('Flapple',841 ,70, 110, 80, 95, 60, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/flapple.png'),
('Appletun',842 ,110, 85, 80, 100, 80, 30, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/appletun.png'),
('Silicobra',843 ,52, 57, 75, 35, 50, 46, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/silicobra.png'),
('Sandaconda',844 ,72, 107, 125, 65, 70, 71, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sandaconda.png'),
('Cramorant',845 ,70, 85, 55, 85, 95, 85, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cramorant.png'),
('Arrokuda',846 ,41, 63, 40, 40, 30, 66, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/arrokuda.png'),
('Barraskewda',847 ,61, 123, 60, 60, 50, 136, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/barraskewda.png'),
('Toxel',848 ,40, 38, 35, 54, 35, 40, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/toxel.png'),
('Toxtricity Low Key',849 ,75, 98, 70, 114, 70, 75, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/toxtricity-low-key.png'),
('Sizzlipede',850 ,50, 65, 45, 50, 50, 45, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sizzlipede.png'),
('Centiskorch',851 ,100, 115, 65, 90, 90, 65, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/centiskorch.png'),
('Clobbopus',852 ,50, 68, 60, 50, 50, 32, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/clobbopus.png'),
('Grapploct',853 ,80, 118, 90, 70, 80, 42, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/grapploct.png'),
('Sinistea',854 ,40, 45, 45, 74, 54, 50, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sinistea.png'),
('Polteageist',855 ,60, 65, 65, 134, 114, 70, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/polteageist.png'),
('Hatenna',856 ,42, 30, 45, 56, 53, 39, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hatenna.png'),
('Hattrem',857 ,57, 40, 65, 86, 73, 49, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hattrem.png'),
('Hatterene',858 ,57, 90, 95, 136, 103, 29, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/hatterene.png'),
('Impidimp',859 ,45, 45, 30, 55, 40, 50, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/impidimp.png'),
('Morgrem',860 ,65, 60, 45, 75, 55, 70, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/morgrem.png'),
('Grimmsnarl',861 ,95, 120, 65, 95, 75, 60, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/grimmsnarl.png'),
('Obstagoon',862 ,93, 90, 101, 60, 81, 95, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/obstagoon.png'),
('Perrserker',863 ,70, 110, 100, 50, 60, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/perrserker.png'),
('Cursola',864 ,60, 95, 50, 145, 130, 30, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cursola.png'),
('Sirfetchd',865 ,62, 135, 95, 68, 82, 65, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/sirfetchd.png'),
('Mr Rime',866 ,80, 85, 75, 110, 100, 70, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/mr-rime.png'),
('Runerigus',867 ,58, 95, 145, 50, 105, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/runerigus.png'),
('Milcery',868 ,45, 40, 40, 50, 61, 34, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/milcery.png'),
('Alcremie',869 ,65, 60, 75, 110, 121, 64, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/alcremie.png'),
('Falinks',870 ,65, 100, 100, 70, 60, 75, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/falinks.png'),
('Pincurchin',871 ,48, 101, 95, 91, 85, 15, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/pincurchin.png'),
('Snom',872 ,30, 25, 35, 45, 30, 20, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/snom.png'),
('Frosmoth',873 ,70, 65, 60, 125, 90, 65, 4, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/frosmoth.png'),
('Stonjourner',874 ,100, 125, 135, 20, 20, 70, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/stonjourner.png'),
('Eiscue Ice',875 ,75, 80, 110, 65, 90, 50, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/eiscue-ice.png'),
('Indeedee Male',876 ,60, 65, 55, 105, 95, 95, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/indeedee-male.png'),
('Morpeko Full Belly',877 ,58, 95, 58, 70, 58, 97, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/morpeko-full-belly.png'),
('Cufant',878 ,72, 80, 49, 40, 49, 40, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/cufant.png'),
('Copperajah',879 ,122, 130, 69, 80, 69, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/copperajah.png'),
('Dracozolt',880 ,90, 100, 90, 80, 70, 75, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dracozolt.png'),
('Arctozolt',881 ,90, 100, 90, 90, 80, 55, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/arctozolt.png'),
('Dracovish',882 ,90, 90, 100, 70, 80, 75, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dracovish.png'),
('Arctovish',883 ,90, 90, 100, 80, 90, 55, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/arctovish.png'),
('Duraludon',884 ,70, 95, 115, 120, 50, 85, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/duraludon.png'),
('Dreepy',885 ,28, 60, 30, 40, 30, 82, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dreepy.png'),
('Drakloak',886 ,68, 80, 50, 60, 50, 102, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/drakloak.png'),
('Dragapult',887 ,88, 120, 75, 100, 75, 142, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/dragapult.png'),
('Zacian Crowned',888 ,92, 170, 115, 80, 115, 148, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zacian-crowned.png'),
('Zamazenta Crowned',889 ,92, 130, 145, 80, 145, 128, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zamazenta-crowned.png'),
('Eternatus',890 ,140, 85, 95, 145, 95, 130, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/eternatus.png'),
('Kubfu',891 ,60, 90, 60, 53, 50, 72, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/kubfu.png'),
('Urshifu Single Strike',892 ,100, 130, 100, 63, 60, 97, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/urshifu-single-strike.png'),
('Zarude',893 ,105, 120, 105, 70, 95, 105, 3, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/zarude.png'),
('Regieleki',894 ,80, 100, 50, 100, 50, 200, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/regieleki.png'),
('Regidrago',895 ,200, 100, 50, 100, 50, 80, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/regidrago.png'),
('Glastrier',896 ,100, 145, 130, 65, 110, 30, 5, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/glastrier.png'),
('Spectrier',897 ,100, 65, 60, 145, 80, 130, 1, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/spectrier.png'),
('Calyrex',898 ,100, 80, 80, 80, 80, 80, 2, 100, 'https://img.pokemondb.net/sprites/sword-shield/icon/calyrex.png');

ALTER SEQUENCE pokemon_id_pokemon_seq RESTART WITH 899;

DROP TABLE IF EXISTS pokemon_attack CASCADE;
CREATE TABLE pokemon_attack (
    id_pokemon integer REFERENCES pokemon(id_pokemon) ON DELETE CASCADE,
    id_attack integer REFERENCES attack(id_attack) ON DELETE CASCADE,
    level integer,
    PRIMARY KEY (id_pokemon, id_attack)
);
INSERT INTO pokemon_attack(id_pokemon,id_attack, level) VALUES
(1, 271, 1),
(1, 272, 6),
(1, 354, 9),
(1, 501, 12),
(1, 461, 15),
(1, 580, 15),
(1, 664, 21),
(1, 654, 24),
(1, 659, 27),
(1, 733, 30),
(1, 150, 33),
(1, 597, 36),
(2, 271, 1),
(2, 272, 1),
(2, 354, 9),
(2, 501, 12),
(2, 461, 15),
(2, 580, 15),
(2, 664, 25),
(2, 654, 30),
(2, 659, 35),
(2, 733, 40),
(2, 150, 45),
(2, 597, 50),
(3, 271, 1),
(3, 272, 1),
(3, 448, 1),
(3, 449, 1),
(3, 354, 9),
(3, 501, 12),
(3, 461, 15),
(3, 580, 15),
(3, 664, 25),
(3, 654, 30),
(3, 659, 37),
(3, 733, 44),
(3, 150, 51),
(3, 597, 58),
(4, 271, 1),
(4, 180, 4),
(4, 589, 8),
(4, 153, 12),
(4, 207, 17),
(4, 579, 20),
(4, 219, 24),
(4, 541, 28),
(4, 211, 32),
(4, 329, 36),
(4, 220, 40),
(5, 180, 1),
(5, 271, 1),
(5, 589, 1),
(5, 153, 12),
(5, 207, 19),
(5, 579, 24),
(5, 219, 30),
(5, 541, 37),
(5, 211, 42),
(5, 329, 48),
(5, 220, 54),
(6, 14, 1),
(6, 180, 1),
(6, 271, 1),
(6, 297, 1),
(6, 589, 1),
(6, 153, 12),
(6, 207, 19),
(6, 579, 24),
(6, 219, 30),
(6, 541, 39),
(6, 211, 46),
(6, 329, 54),
(6, 220, 62),
(7, 662, 1),
(7, 729, 6),
(7, 500, 9),
(7, 52, 12),
(7, 716, 15),
(7, 476, 18),
(7, 499, 21),
(7, 560, 27),
(7, 334, 30),
(7, 574, 36),
(8, 662, 1),
(8, 729, 1),
(8, 500, 9),
(8, 52, 12),
(8, 716, 15),
(8, 476, 20),
(8, 499, 25),
(8, 560, 35),
(8, 334, 40),
(8, 574, 50),
(9, 222, 1),
(9, 662, 1),
(9, 729, 1),
(9, 500, 9),
(9, 52, 12),
(9, 716, 15),
(9, 476, 20),
(9, 499, 25),
(9, 560, 35),
(9, 334, 42),
(9, 574, 56),
(10, 636, 1),
(10, 75, 9),
(11, 284, 1),
(12, 75, 1),
(12, 279, 1),
(12, 284, 1),
(12, 636, 1),
(12, 648, 4),
(12, 106, 8),
(12, 461, 12),
(12, 580, 12),
(12, 640, 12),
(12, 477, 16),
(12, 723, 20),
(12, 14, 24),
(12, 534, 28),
(12, 76, 32),
(12, 663, 36),
(12, 498, 40),
(12, 496, 44),
(25, 91, 1),
(25, 271, 1),
(25, 420, 1),
(25, 431, 1),
(25, 455, 1),
(25, 494, 1),
(25, 653, 1),
(25, 662, 1),
(25, 683, 1),
(25, 684, 4),
(25, 149, 8),
(25, 177, 12),
(25, 200, 16),
(25, 602, 20),
(25, 12, 24),
(25, 141, 32),
(25, 685, 36),
(25, 360, 40),
(25, 679, 44),
(30, 271, 1),
(30, 462, 1),
(30, 662, 1),
(30, 249, 15),
(30, 691, 22),
(30, 147, 29),
(30, 52, 36),
(30, 299, 43),
(30, 690, 50),
(30, 223, 57),
(30, 123, 64),
(30, 170, 71),
(31, 52, 1),
(31, 123, 1),
(31, 147, 1),
(31, 170, 1),
(31, 223, 1),
(31, 249, 1),
(31, 271, 1),
(31, 299, 1),
(31, 462, 1),
(31, 647, 1),
(31, 662, 1),
(31, 690, 1),
(31, 691, 1),
(33, 233, 1),
(33, 355, 1),
(33, 462, 1),
(33, 247, 15),
(33, 691, 22),
(33, 147, 29),
(33, 299, 43),
(33, 690, 50),
(33, 223, 57),
(33, 460, 64),
(33, 170, 71),
(34, 147, 1),
(34, 170, 1),
(34, 223, 1),
(34, 233, 1),
(34, 247, 1),
(34, 299, 1),
(34, 355, 1),
(34, 460, 1),
(34, 462, 1),
(34, 690, 1),
(34, 691, 1),
(35, 91, 1),
(35, 110, 1),
(35, 133, 1),
(35, 140, 1),
(35, 181, 1),
(35, 271, 1),
(35, 568, 1),
(35, 615, 1),
(35, 653, 1),
(35, 632, 4),
(35, 400, 8),
(35, 11, 12),
(35, 358, 16),
(35, 395, 20),
(35, 411, 24),
(35, 270, 28),
(35, 394, 32),
(35, 235, 36),
(35, 113, 40),
(35, 409, 44),
(35, 293, 48),
(36, 11, 1),
(36, 91, 1),
(36, 110, 1),
(36, 113, 1),
(36, 133, 1),
(36, 140, 1),
(36, 181, 1),
(36, 235, 1),
(36, 270, 1),
(36, 271, 1),
(36, 293, 1),
(36, 358, 1),
(36, 394, 1),
(36, 395, 1),
(36, 400, 1),
(36, 409, 1),
(36, 411, 1),
(36, 568, 1),
(36, 615, 1),
(36, 632, 1),
(36, 653, 1),
(39, 91, 1),
(39, 110, 1),
(39, 133, 1),
(39, 139, 1),
(39, 140, 1),
(39, 568, 1),
(39, 653, 1),
(39, 172, 4),
(39, 118, 8),
(39, 613, 12),
(39, 627, 12),
(39, 652, 12),
(39, 531, 16),
(39, 510, 20),
(39, 59, 24),
(39, 397, 28),
(39, 280, 32),
(39, 456, 40),
(39, 150, 44),
(40, 59, 1),
(40, 91, 1),
(40, 110, 1),
(40, 118, 1),
(40, 133, 1),
(40, 139, 1),
(40, 140, 1),
(40, 150, 1),
(40, 172, 1),
(40, 280, 1),
(40, 397, 1),
(40, 456, 1),
(40, 510, 1),
(40, 531, 1),
(40, 568, 1),
(40, 613, 1),
(40, 627, 1),
(40, 652, 1),
(40, 653, 1),
(41, 2, 1),
(41, 648, 1),
(41, 27, 5),
(41, 384, 10),
(41, 458, 15),
(41, 495, 20),
(41, 13, 25),
(41, 52, 30),
(41, 285, 35),
(41, 710, 40),
(41, 105, 45),
(41, 14, 50),
(41, 353, 55),
(42, 2, 1),
(42, 27, 1),
(42, 384, 1),
(42, 543, 1),
(42, 648, 1),
(42, 458, 15),
(42, 495, 20),
(42, 13, 27),
(42, 52, 34),
(42, 285, 41),
(42, 710, 48),
(42, 105, 55),
(42, 14, 62),
(42, 353, 69),
(43, 2, 1),
(43, 272, 1),
(43, 4, 4),
(43, 654, 8),
(43, 386, 12),
(43, 461, 14),
(43, 640, 16),
(43, 580, 18),
(43, 258, 20),
(43, 690, 24),
(43, 409, 28),
(43, 268, 32),
(43, 411, 36),
(43, 449, 40),
(44, 2, 1),
(44, 4, 1),
(44, 272, 1),
(44, 654, 1),
(44, 386, 12),
(44, 461, 14),
(44, 640, 16),
(44, 580, 18),
(44, 258, 20),
(44, 690, 26),
(44, 409, 32),
(44, 268, 38),
(44, 411, 44),
(44, 449, 50),
(45, 2, 1),
(45, 4, 1),
(45, 23, 1),
(45, 258, 1),
(45, 268, 1),
(45, 272, 1),
(45, 386, 1),
(45, 409, 1),
(45, 411, 1),
(45, 448, 1),
(45, 449, 1),
(45, 461, 1),
(45, 580, 1),
(45, 640, 1),
(45, 654, 1),
(45, 690, 1),
(54, 662, 1),
(54, 106, 6),
(54, 249, 9),
(54, 716, 12),
(54, 139, 15),
(54, 738, 18),
(54, 543, 21),
(54, 595, 27),
(54, 478, 30),
(54, 16, 34),
(54, 730, 39),
(55, 20, 1),
(55, 106, 1),
(55, 662, 1),
(55, 249, 9),
(55, 716, 12),
(55, 139, 15),
(55, 738, 18),
(55, 543, 21),
(55, 595, 27),
(55, 478, 30),
(55, 16, 36),
(55, 730, 45),
(58, 180, 1),
(58, 355, 1),
(58, 309, 4),
(58, 52, 8),
(58, 218, 12),
(58, 299, 16),
(58, 12, 20),
(58, 207, 24),
(58, 511, 28),
(58, 123, 32),
(58, 664, 36),
(58, 219, 40),
(58, 517, 44),
(58, 456, 48),
(58, 515, 52),
(58, 220, 56),
(59, 12, 1),
(59, 52, 1),
(59, 81, 1),
(59, 123, 1),
(59, 180, 1),
(59, 192, 1),
(59, 207, 1),
(59, 218, 1),
(59, 219, 1),
(59, 220, 1),
(59, 299, 1),
(59, 309, 1),
(59, 355, 1),
(59, 456, 1),
(59, 511, 1),
(59, 515, 1),
(59, 517, 1),
(59, 664, 1),
(60, 316, 1),
(60, 414, 12),
(60, 74, 18),
(60, 499, 24),
(60, 59, 30),
(60, 170, 36),
(60, 48, 48),
(60, 150, 54),
(61, 316, 1),
(61, 414, 1),
(61, 74, 18),
(61, 499, 24),
(61, 59, 32),
(61, 170, 40),
(61, 48, 56),
(61, 150, 66),
(62, 48, 1),
(62, 59, 1),
(62, 74, 1),
(62, 94, 1),
(62, 150, 1),
(62, 169, 1),
(62, 170, 1),
(62, 316, 1),
(62, 399, 1),
(62, 414, 1),
(62, 499, 1),
(62, 641, 1),
(63, 672, 1),
(64, 106, 1),
(64, 139, 1),
(64, 342, 1),
(64, 672, 1),
(64, 477, 5),
(64, 506, 10),
(64, 15, 15),
(64, 483, 20),
(64, 504, 25),
(64, 485, 30),
(64, 479, 35),
(64, 526, 40),
(64, 252, 45),
(64, 84, 50),
(65, 106, 1),
(65, 139, 1),
(65, 342, 1),
(65, 672, 1),
(65, 477, 5),
(65, 506, 10),
(65, 15, 15),
(65, 483, 20),
(65, 504, 25),
(65, 485, 30),
(65, 479, 35),
(65, 526, 40),
(65, 252, 45),
(65, 84, 50),
(66, 355, 1),
(66, 365, 1),
(66, 233, 4),
(66, 514, 8),
(66, 366, 12),
(66, 344, 16),
(66, 541, 20),
(66, 711, 24),
(66, 166, 32),
(66, 77, 36),
(66, 549, 40),
(66, 169, 44),
(66, 121, 48),
(66, 150, 52),
(67, 233, 1),
(67, 355, 1),
(67, 365, 1),
(67, 514, 1),
(67, 366, 12),
(67, 344, 16),
(67, 541, 20),
(67, 711, 24),
(67, 166, 36),
(67, 77, 42),
(67, 549, 48),
(67, 169, 54),
(67, 121, 60),
(67, 150, 66),
(68, 233, 1),
(68, 355, 1),
(68, 365, 1),
(68, 514, 1),
(68, 725, 1),
(68, 366, 12),
(68, 344, 16),
(68, 541, 20),
(68, 711, 24),
(68, 166, 36),
(68, 77, 42),
(68, 549, 48),
(68, 169, 54),
(68, 121, 60),
(68, 150, 66),
(72, 462, 1),
(72, 4, 4),
(72, 734, 8),
(72, 648, 12),
(72, 716, 16),
(72, 543, 20),
(72, 74, 24),
(72, 300, 28),
(72, 5, 32),
(72, 460, 36),
(72, 649, 40),
(72, 584, 44),
(73, 4, 1),
(73, 462, 1),
(73, 507, 1),
(73, 734, 1),
(73, 648, 12),
(73, 716, 16),
(73, 543, 20),
(73, 74, 24),
(73, 300, 28),
(73, 5, 34),
(73, 460, 40),
(73, 649, 46),
(73, 584, 52),
(81, 683, 1),
(81, 648, 4),
(81, 684, 8),
(81, 177, 12),
(81, 280, 16),
(81, 602, 20),
(81, 543, 24),
(81, 378, 28),
(81, 222, 32),
(81, 141, 36),
(81, 391, 40),
(81, 360, 44),
(81, 363, 48),
(81, 737, 52),
(82, 175, 1),
(82, 648, 1),
(82, 683, 1),
(82, 684, 1),
(82, 694, 1),
(82, 177, 12),
(82, 280, 16),
(82, 602, 20),
(82, 543, 24),
(82, 378, 28),
(82, 222, 34),
(82, 141, 40),
(82, 391, 46),
(82, 360, 52),
(82, 363, 58),
(82, 737, 64),
(90, 729, 4),
(90, 323, 8),
(90, 355, 12),
(90, 722, 16),
(90, 648, 20),
(90, 33, 24),
(90, 476, 28),
(90, 502, 32),
(90, 334, 36),
(90, 318, 40),
(90, 560, 44),
(91, 33, 1),
(91, 318, 1),
(91, 323, 1),
(91, 324, 1),
(91, 325, 1),
(91, 334, 1),
(91, 355, 1),
(91, 476, 1),
(91, 502, 1),
(91, 560, 1),
(91, 609, 1),
(91, 648, 1),
(91, 691, 1),
(91, 722, 1),
(91, 729, 1),
(92, 105, 1),
(92, 357, 1),
(92, 316, 4),
(92, 384, 8),
(92, 446, 12),
(92, 614, 16),
(92, 126, 20),
(92, 300, 24),
(92, 426, 28),
(92, 643, 32),
(92, 127, 36),
(92, 551, 40),
(92, 135, 44),
(92, 163, 48),
(93, 105, 1),
(93, 316, 1),
(93, 357, 1),
(93, 384, 1),
(93, 555, 1),
(93, 446, 12),
(93, 614, 16),
(93, 126, 20),
(93, 300, 24),
(93, 426, 30),
(93, 643, 36),
(93, 127, 42),
(93, 551, 48),
(93, 135, 54),
(93, 163, 60),
(94, 105, 1),
(94, 316, 1),
(94, 357, 1),
(94, 384, 1),
(94, 447, 1),
(94, 507, 1),
(94, 555, 1),
(94, 446, 12),
(94, 614, 16),
(94, 126, 20),
(94, 300, 24),
(94, 426, 30),
(94, 643, 36),
(94, 127, 42),
(94, 551, 48),
(94, 135, 54),
(94, 163, 60),
(95, 51, 1),
(95, 284, 1),
(95, 585, 4),
(95, 521, 8),
(95, 153, 12),
(95, 126, 16),
(95, 522, 20),
(95, 543, 24),
(95, 536, 28),
(95, 620, 32),
(95, 537, 40),
(95, 138, 44),
(95, 336, 48),
(95, 631, 52),
(95, 150, 56),
(98, 355, 1),
(98, 284, 4),
(98, 390, 8),
(98, 414, 12),
(98, 476, 16),
(98, 74, 20),
(98, 629, 24),
(98, 215, 29),
(98, 502, 32),
(98, 657, 40),
(98, 119, 44),
(98, 277, 48),
(99, 282, 1),
(99, 284, 1),
(99, 355, 1),
(99, 390, 1),
(99, 725, 1),
(99, 414, 12),
(99, 476, 16),
(99, 74, 20),
(99, 629, 24),
(99, 215, 31),
(99, 502, 36),
(99, 657, 48),
(99, 119, 54),
(99, 277, 60),
(102, 2, 1),
(102, 316, 1),
(102, 506, 5),
(102, 354, 10),
(102, 386, 15),
(102, 106, 20),
(102, 659, 25),
(102, 80, 30),
(102, 258, 35),
(102, 190, 40),
(102, 705, 45),
(102, 733, 50),
(102, 597, 55),
(104, 271, 1),
(104, 416, 1),
(104, 662, 4),
(104, 198, 8),
(104, 288, 12),
(104, 511, 16),
(104, 225, 20),
(104, 630, 24),
(104, 63, 29),
(104, 233, 32),
(104, 182, 36),
(104, 64, 40),
(104, 677, 44),
(104, 150, 48),
(106, 70, 1),
(106, 195, 1),
(106, 200, 1),
(106, 233, 1),
(106, 299, 1),
(106, 366, 1),
(106, 147, 4),
(106, 365, 8),
(106, 183, 12),
(106, 514, 16),
(106, 725, 21),
(106, 54, 24),
(106, 399, 28),
(106, 100, 36),
(106, 515, 40),
(106, 303, 44),
(107, 79, 1),
(107, 161, 1),
(107, 195, 1),
(107, 200, 1),
(107, 233, 1),
(107, 299, 1),
(107, 707, 1),
(107, 371, 4),
(107, 472, 8),
(107, 136, 12),
(107, 514, 16),
(107, 495, 21),
(107, 210, 24),
(107, 322, 24),
(107, 682, 24),
(107, 12, 28),
(107, 100, 36),
(107, 116, 40),
(107, 234, 44),
(108, 133, 1),
(108, 357, 1),
(108, 528, 6),
(108, 648, 12),
(108, 734, 18),
(108, 139, 24),
(108, 629, 30),
(108, 344, 36),
(108, 543, 42),
(108, 48, 60),
(109, 459, 1),
(109, 588, 4),
(109, 589, 8),
(109, 99, 12),
(109, 26, 16),
(109, 582, 20),
(109, 285, 24),
(109, 550, 28),
(109, 583, 32),
(109, 690, 36),
(109, 47, 40),
(109, 189, 44),
(109, 387, 48),
(109, 135, 52),
(111, 662, 1),
(111, 585, 5),
(111, 78, 10),
(111, 541, 20),
(111, 629, 25),
(111, 519, 30),
(111, 164, 35),
(111, 664, 40),
(111, 171, 45),
(111, 631, 50),
(111, 307, 60),
(112, 78, 1),
(112, 282, 1),
(112, 585, 1),
(112, 662, 1),
(112, 541, 20),
(112, 629, 25),
(112, 519, 30),
(112, 164, 35),
(112, 664, 40),
(112, 171, 47),
(112, 631, 54),
(112, 307, 68),
(113, 91, 1),
(113, 110, 1),
(113, 118, 1),
(113, 133, 1),
(113, 140, 1),
(113, 400, 1),
(113, 653, 1),
(113, 662, 4),
(113, 172, 8),
(113, 358, 12),
(113, 568, 16),
(113, 225, 20),
(113, 664, 24),
(113, 292, 28),
(113, 299, 32),
(113, 360, 36),
(113, 150, 40),
(113, 596, 44),
(113, 347, 48),
(113, 293, 52),
(114, 2, 1),
(114, 51, 1),
(114, 640, 4),
(114, 272, 8),
(114, 386, 12),
(114, 461, 20),
(114, 18, 24),
(114, 344, 28),
(114, 258, 32),
(114, 580, 36),
(114, 687, 44),
(114, 331, 52),
(114, 268, 56),
(115, 662, 1),
(115, 271, 4),
(115, 195, 8),
(115, 52, 12),
(115, 629, 16),
(115, 233, 20),
(115, 288, 24),
(115, 643, 28),
(115, 145, 32),
(115, 123, 36),
(115, 183, 40),
(115, 515, 44),
(115, 440, 48),
(115, 347, 52),
(116, 355, 1),
(116, 589, 5),
(116, 703, 10),
(116, 233, 15),
(116, 153, 20),
(116, 74, 25),
(116, 12, 30),
(116, 345, 35),
(116, 154, 50),
(116, 499, 55),
(117, 355, 1),
(117, 589, 1),
(117, 703, 1),
(117, 233, 15),
(117, 153, 20),
(117, 74, 25),
(117, 12, 30),
(117, 345, 37),
(117, 154, 58),
(117, 499, 65),
(118, 662, 1),
(118, 648, 5),
(118, 716, 10),
(118, 12, 20),
(118, 21, 25),
(118, 215, 30),
(118, 720, 35),
(118, 595, 40),
(118, 307, 50),
(119, 648, 1),
(119, 662, 1),
(119, 716, 1),
(119, 12, 20),
(119, 21, 25),
(119, 215, 30),
(119, 720, 37),
(119, 595, 44),
(119, 307, 58),
(120, 284, 1),
(120, 105, 8),
(120, 500, 12),
(120, 400, 16),
(120, 655, 20),
(120, 477, 24),
(120, 71, 28),
(120, 360, 32),
(120, 479, 40),
(120, 649, 44),
(120, 504, 48),
(120, 113, 52),
(121, 71, 1),
(121, 105, 1),
(121, 113, 1),
(121, 284, 1),
(121, 360, 1),
(121, 400, 1),
(121, 477, 1),
(121, 479, 1),
(121, 500, 1),
(121, 504, 1),
(121, 649, 1),
(121, 655, 1),
(123, 355, 1),
(123, 494, 1),
(123, 248, 4),
(123, 198, 8),
(123, 149, 16),
(123, 145, 20),
(123, 579, 24),
(123, 233, 28),
(123, 12, 32),
(123, 14, 36),
(123, 345, 44),
(123, 657, 48),
(124, 110, 1),
(124, 357, 1),
(124, 467, 1),
(124, 653, 1),
(124, 106, 12),
(124, 118, 16),
(124, 568, 20),
(124, 196, 24),
(124, 322, 28),
(124, 479, 34),
(124, 364, 40),
(124, 384, 46),
(124, 447, 52),
(124, 55, 58),
(125, 89, 1),
(125, 355, 1),
(125, 494, 1),
(125, 683, 1),
(125, 655, 12),
(125, 563, 16),
(125, 684, 20),
(125, 543, 24),
(125, 682, 28),
(125, 141, 34),
(125, 365, 40),
(125, 685, 46),
(125, 360, 52),
(125, 679, 58),
(125, 259, 64),
(126, 180, 1),
(126, 355, 1),
(126, 588, 1),
(126, 589, 1),
(126, 99, 12),
(126, 218, 16),
(126, 105, 20),
(126, 541, 24),
(126, 210, 28),
(126, 348, 34),
(126, 365, 40),
(126, 219, 46),
(126, 644, 52),
(126, 206, 58),
(126, 312, 64),
(127, 284, 1),
(127, 233, 4),
(127, 51, 8),
(127, 549, 12),
(127, 75, 16),
(127, 633, 20),
(127, 145, 24),
(127, 711, 28),
(127, 657, 40),
(127, 641, 44),
(127, 277, 48),
(127, 647, 52),
(128, 662, 1),
(128, 732, 5),
(128, 446, 10),
(128, 26, 15),
(128, 541, 25),
(128, 738, 30),
(128, 664, 35),
(128, 510, 40),
(128, 651, 45),
(128, 677, 50),
(128, 150, 55),
(128, 259, 60),
(129, 615, 1),
(129, 215, 25),
(130, 52, 1),
(130, 215, 1),
(130, 355, 1),
(130, 615, 1),
(130, 703, 1),
(130, 722, 4),
(130, 320, 8),
(130, 71, 12),
(130, 541, 16),
(130, 720, 21),
(130, 123, 24),
(130, 499, 28),
(130, 154, 36),
(130, 310, 44),
(130, 677, 48),
(130, 312, 52),
(131, 271, 1),
(131, 568, 5),
(131, 405, 10),
(131, 358, 15),
(131, 323, 20),
(131, 105, 25),
(131, 716, 30),
(131, 71, 35),
(131, 59, 40),
(131, 318, 45),
(131, 499, 50),
(131, 447, 60),
(131, 558, 65),
(132, 693, 1),
(133, 118, 1),
(133, 271, 1),
(133, 299, 1),
(133, 662, 1),
(133, 535, 5),
(133, 494, 10),
(133, 37, 15),
(133, 655, 20),
(133, 52, 25),
(133, 110, 30),
(133, 42, 35),
(133, 664, 40),
(133, 91, 45),
(133, 150, 50),
(133, 347, 55),
(134, 42, 1),
(134, 52, 1),
(134, 91, 1),
(134, 110, 1),
(134, 118, 1),
(134, 150, 1),
(134, 271, 1),
(134, 299, 1),
(134, 655, 1),
(134, 662, 1),
(134, 664, 1),
(134, 535, 5),
(134, 494, 10),
(134, 37, 15),
(134, 285, 20),
(134, 716, 25),
(134, 33, 30),
(134, 21, 35),
(134, 417, 40),
(134, 5, 45),
(134, 347, 55),
(135, 42, 1),
(135, 52, 1),
(135, 91, 1),
(135, 110, 1),
(135, 118, 1),
(135, 150, 1),
(135, 271, 1),
(135, 299, 1),
(135, 655, 1),
(135, 662, 1),
(135, 664, 1),
(135, 683, 1),
(135, 535, 5),
(135, 494, 10),
(135, 37, 15),
(135, 684, 20),
(135, 147, 25),
(135, 681, 30),
(135, 453, 35),
(135, 141, 40),
(135, 12, 45),
(135, 679, 50),
(135, 347, 55),
(136, 42, 1),
(136, 91, 1),
(136, 110, 1),
(136, 118, 1),
(136, 150, 1),
(136, 180, 1),
(136, 271, 1),
(136, 299, 1),
(136, 655, 1),
(136, 662, 1),
(136, 664, 1),
(136, 535, 5),
(136, 494, 10),
(136, 37, 15),
(136, 588, 20),
(136, 52, 25),
(136, 207, 30),
(136, 211, 35),
(136, 348, 40),
(136, 541, 45),
(136, 220, 50),
(136, 347, 55),
(137, 108, 1),
(137, 505, 5),
(137, 378, 10),
(137, 683, 15),
(137, 477, 20),
(137, 109, 25),
(137, 12, 30),
(137, 504, 35),
(137, 141, 40),
(137, 694, 45),
(137, 372, 50),
(137, 363, 55),
(137, 737, 60),
(138, 51, 1),
(138, 729, 1),
(138, 528, 5),
(138, 535, 10),
(138, 355, 20),
(138, 414, 25),
(138, 18, 30),
(138, 71, 35),
(138, 476, 41),
(138, 519, 45),
(138, 649, 50),
(138, 560, 55),
(139, 51, 1),
(139, 123, 1),
(139, 528, 1),
(139, 535, 1),
(139, 729, 1),
(139, 355, 20),
(139, 414, 25),
(139, 18, 30),
(139, 71, 35),
(139, 476, 43),
(139, 519, 49),
(139, 649, 56),
(139, 560, 63),
(140, 2, 1),
(140, 284, 1),
(140, 535, 10),
(140, 20, 15),
(140, 355, 20),
(140, 414, 25),
(140, 18, 30),
(140, 71, 35),
(140, 476, 41),
(140, 353, 45),
(140, 362, 50),
(140, 391, 55),
(140, 631, 60),
(141, 2, 1),
(141, 200, 1),
(141, 284, 1),
(141, 427, 1),
(141, 535, 1),
(141, 579, 1),
(141, 20, 15),
(141, 355, 20),
(141, 414, 25),
(141, 18, 30),
(141, 71, 35),
(141, 476, 43),
(141, 353, 49),
(141, 362, 56),
(141, 391, 63),
(141, 631, 70),
(142, 18, 1),
(142, 52, 1),
(142, 648, 5),
(142, 541, 15),
(142, 522, 20),
(142, 517, 25),
(142, 123, 30),
(142, 335, 35),
(142, 664, 40),
(142, 631, 45),
(142, 12, 50),
(142, 312, 55),
(142, 259, 60),
(143, 56, 1),
(143, 118, 1),
(143, 133, 1),
(143, 215, 1),
(143, 225, 1),
(143, 347, 1),
(143, 357, 1),
(143, 395, 1),
(143, 505, 1),
(143, 543, 1),
(143, 627, 1),
(143, 652, 1),
(143, 736, 12),
(143, 52, 16),
(143, 510, 20),
(143, 581, 20),
(143, 594, 20),
(143, 123, 24),
(143, 59, 28),
(143, 298, 32),
(143, 16, 36),
(143, 302, 40),
(143, 282, 44),
(143, 48, 48),
(143, 47, 52),
(143, 259, 56),
(147, 355, 1),
(147, 734, 1),
(147, 703, 5),
(147, 684, 10),
(147, 160, 15),
(147, 12, 20),
(147, 159, 35),
(147, 534, 40),
(147, 499, 45),
(147, 154, 50),
(147, 440, 55),
(147, 312, 60),
(148, 355, 1),
(148, 684, 1),
(148, 703, 1),
(148, 734, 1),
(148, 160, 15),
(148, 12, 20),
(148, 159, 39),
(148, 534, 46),
(148, 499, 53),
(148, 154, 60),
(148, 440, 67),
(148, 312, 74),
(149, 192, 1),
(149, 210, 1),
(149, 310, 1),
(149, 355, 1),
(149, 529, 1),
(149, 682, 1),
(149, 684, 1),
(149, 703, 1),
(149, 734, 1),
(149, 160, 15),
(149, 12, 20),
(149, 159, 39),
(149, 440, 41),
(149, 534, 46),
(149, 499, 53),
(149, 154, 62),
(149, 312, 80),
(150, 106, 1),
(150, 139, 1),
(150, 345, 1),
(150, 358, 1),
(150, 655, 1),
(150, 18, 8),
(150, 483, 16),
(150, 534, 24),
(150, 16, 32),
(150, 31, 40),
(150, 479, 48),
(150, 275, 56),
(150, 469, 56),
(150, 405, 64),
(150, 486, 72),
(150, 504, 80),
(150, 252, 88),
(151, 507, 1),
(151, 16, 10),
(151, 42, 20),
(151, 18, 30),
(151, 358, 40),
(151, 420, 50),
(151, 395, 60),
(151, 327, 70),
(151, 693, 80),
(151, 31, 90),
(151, 479, 100),
(163, 271, 1),
(163, 172, 6),
(163, 106, 9),
(163, 506, 12),
(163, 484, 15),
(163, 14, 18),
(163, 190, 21),
(163, 664, 24),
(163, 705, 27),
(163, 529, 30),
(163, 409, 33),
(163, 316, 36),
(163, 163, 39),
(164, 172, 1),
(164, 271, 1),
(164, 575, 1),
(164, 106, 9),
(164, 506, 12),
(164, 484, 15),
(164, 14, 18),
(164, 190, 23),
(164, 664, 28),
(164, 705, 33),
(164, 529, 38),
(164, 409, 43),
(164, 316, 48),
(164, 163, 53),
(169, 2, 1),
(169, 27, 1),
(169, 122, 1),
(169, 384, 1),
(169, 543, 1),
(169, 648, 1),
(169, 663, 1),
(169, 690, 1),
(169, 458, 15),
(169, 495, 20),
(169, 13, 27),
(169, 52, 34),
(169, 285, 41),
(169, 710, 48),
(169, 105, 55),
(169, 14, 62),
(169, 353, 69),
(170, 648, 1),
(170, 177, 4),
(170, 684, 8),
(170, 74, 12),
(170, 105, 16),
(170, 602, 20),
(170, 89, 24),
(170, 141, 28),
(170, 21, 32),
(170, 215, 36),
(170, 664, 40),
(171, 173, 1),
(171, 177, 1),
(171, 613, 1),
(171, 627, 1),
(171, 648, 1),
(171, 652, 1),
(171, 684, 1),
(171, 74, 12),
(171, 105, 16),
(171, 602, 20),
(171, 89, 24),
(171, 141, 30),
(171, 21, 36),
(171, 215, 42),
(171, 664, 48),
(172, 662, 1),
(172, 683, 1),
(172, 455, 4),
(172, 653, 8),
(172, 431, 12),
(172, 420, 16),
(172, 91, 20),
(173, 110, 1),
(173, 615, 1),
(173, 568, 4),
(173, 653, 8),
(173, 140, 12),
(173, 181, 16),
(173, 91, 20),
(174, 110, 1),
(174, 568, 1),
(174, 133, 4),
(174, 653, 8),
(174, 140, 12),
(174, 139, 16),
(174, 91, 20),
(175, 271, 1),
(175, 653, 4),
(175, 358, 8),
(175, 91, 12),
(175, 18, 16),
(175, 736, 20),
(175, 395, 24),
(175, 11, 28),
(175, 150, 32),
(175, 534, 36),
(175, 235, 40),
(175, 42, 44),
(175, 347, 48),
(175, 728, 52),
(176, 271, 1),
(176, 358, 1),
(176, 653, 1),
(176, 91, 12),
(176, 18, 16),
(176, 736, 20),
(176, 395, 24),
(176, 11, 28),
(176, 150, 32),
(176, 534, 36),
(176, 235, 40),
(176, 42, 44),
(176, 347, 48),
(176, 728, 52),
(177, 355, 1),
(177, 632, 5),
(177, 672, 10),
(177, 105, 15),
(177, 426, 20),
(177, 484, 26),
(177, 469, 30),
(177, 275, 35),
(177, 479, 35),
(177, 728, 40),
(177, 252, 45),
(178, 14, 1),
(178, 355, 1),
(178, 632, 1),
(178, 663, 1),
(178, 672, 1),
(178, 105, 15),
(178, 426, 20),
(178, 484, 28),
(178, 275, 34),
(178, 469, 34),
(178, 479, 41),
(178, 728, 48),
(178, 252, 55),
(182, 2, 1),
(182, 4, 1),
(182, 258, 1),
(182, 268, 1),
(182, 272, 1),
(182, 386, 1),
(182, 409, 1),
(182, 411, 1),
(182, 448, 1),
(182, 449, 1),
(182, 461, 1),
(182, 496, 1),
(182, 580, 1),
(182, 640, 1),
(182, 654, 1),
(182, 690, 1),
(183, 133, 1),
(183, 299, 1),
(183, 528, 1),
(183, 662, 1),
(183, 74, 6),
(183, 91, 9),
(183, 66, 15),
(183, 456, 21),
(183, 21, 24),
(183, 499, 27),
(183, 150, 33),
(183, 647, 36),
(184, 133, 1),
(184, 299, 1),
(184, 528, 1),
(184, 662, 1),
(184, 74, 6),
(184, 91, 9),
(184, 66, 15),
(184, 456, 25),
(184, 21, 30),
(184, 499, 35),
(184, 150, 45),
(184, 647, 50),
(185, 110, 1),
(185, 196, 1),
(185, 215, 1),
(185, 282, 1),
(185, 631, 1),
(185, 731, 1),
(185, 56, 12),
(185, 397, 16),
(185, 524, 20),
(185, 667, 24),
(185, 643, 28),
(185, 522, 32),
(185, 365, 36),
(185, 116, 40),
(185, 150, 44),
(185, 287, 48),
(186, 48, 1),
(186, 59, 1),
(186, 66, 1),
(186, 74, 1),
(186, 150, 1),
(186, 170, 1),
(186, 316, 1),
(186, 414, 1),
(186, 447, 1),
(186, 499, 1),
(186, 651, 1),
(194, 662, 1),
(194, 499, 4),
(194, 414, 8),
(194, 285, 12),
(194, 405, 12),
(194, 736, 21),
(194, 417, 28),
(194, 16, 32),
(194, 690, 36),
(194, 171, 40),
(195, 414, 1),
(195, 499, 1),
(195, 662, 1),
(195, 285, 12),
(195, 405, 12),
(195, 736, 23),
(195, 417, 34),
(195, 16, 40),
(195, 690, 46),
(195, 171, 52),
(196, 42, 1),
(196, 52, 1),
(196, 91, 1),
(196, 106, 1),
(196, 110, 1),
(196, 118, 1),
(196, 150, 1),
(196, 271, 1),
(196, 299, 1),
(196, 662, 1),
(196, 664, 1),
(196, 535, 5),
(196, 494, 10),
(196, 37, 15),
(196, 655, 20),
(196, 477, 25),
(196, 412, 30),
(196, 469, 35),
(196, 479, 40),
(196, 478, 45),
(196, 252, 50),
(196, 347, 55),
(197, 42, 1),
(197, 52, 1),
(197, 91, 1),
(197, 110, 1),
(197, 118, 1),
(197, 150, 1),
(197, 271, 1),
(197, 299, 1),
(197, 591, 1),
(197, 655, 1),
(197, 662, 1),
(197, 664, 1),
(197, 535, 5),
(197, 494, 10),
(197, 37, 15),
(197, 105, 20),
(197, 26, 25),
(197, 411, 30),
(197, 275, 35),
(197, 127, 40),
(197, 543, 45),
(197, 384, 50),
(197, 347, 55),
(202, 16, 1),
(202, 91, 1),
(202, 116, 1),
(202, 135, 1),
(202, 181, 1),
(202, 402, 1),
(202, 534, 1),
(202, 615, 1),
(206, 133, 1),
(206, 215, 1),
(206, 416, 4),
(206, 528, 8),
(206, 262, 12),
(206, 543, 16),
(206, 18, 20),
(206, 164, 24),
(206, 736, 28),
(206, 59, 32),
(206, 664, 36),
(206, 529, 40),
(206, 159, 44),
(206, 102, 48),
(206, 150, 52),
(206, 182, 56),
(208, 51, 1),
(208, 123, 1),
(208, 207, 1),
(208, 284, 1),
(208, 320, 1),
(208, 521, 1),
(208, 681, 1),
(208, 585, 4),
(208, 35, 8),
(208, 153, 12),
(208, 126, 16),
(208, 522, 20),
(208, 543, 24),
(208, 536, 28),
(208, 620, 32),
(208, 537, 40),
(208, 138, 44),
(208, 336, 48),
(208, 631, 52),
(208, 150, 56),
(208, 378, 60),
(211, 462, 1),
(211, 284, 4),
(211, 202, 12),
(211, 400, 16),
(211, 609, 20),
(211, 71, 24),
(211, 514, 28),
(211, 453, 32),
(211, 691, 36),
(211, 460, 40),
(211, 613, 44),
(211, 627, 44),
(211, 664, 48),
(211, 690, 52),
(211, 8, 60),
(211, 135, 66),
(212, 12, 1),
(212, 14, 1),
(212, 79, 1),
(212, 198, 1),
(212, 248, 1),
(212, 355, 1),
(212, 494, 1),
(212, 390, 12),
(212, 149, 16),
(212, 145, 20),
(212, 579, 24),
(212, 233, 28),
(212, 334, 32),
(212, 335, 36),
(212, 345, 44),
(212, 657, 48),
(213, 729, 1),
(213, 734, 1),
(213, 528, 5),
(213, 638, 10),
(213, 534, 20),
(213, 510, 25),
(213, 75, 30),
(213, 274, 35),
(213, 468, 35),
(213, 522, 40),
(213, 253, 45),
(213, 626, 50),
(213, 470, 55),
(213, 631, 60),
(213, 560, 65),
(214, 355, 1),
(214, 247, 5),
(214, 183, 10),
(214, 9, 15),
(214, 116, 25),
(214, 70, 30),
(214, 453, 35),
(214, 678, 40),
(214, 677, 45),
(214, 657, 50),
(214, 100, 60),
(215, 355, 1),
(215, 666, 6),
(215, 494, 12),
(215, 390, 18),
(215, 326, 24),
(215, 249, 30),
(215, 306, 36),
(215, 44, 42),
(215, 12, 48),
(215, 543, 54),
(215, 579, 60),
(220, 416, 1),
(220, 467, 5),
(220, 215, 10),
(220, 323, 15),
(220, 405, 20),
(220, 183, 25),
(220, 326, 30),
(220, 16, 35),
(220, 664, 40),
(220, 171, 45),
(220, 55, 50),
(221, 18, 1),
(221, 215, 1),
(221, 320, 1),
(221, 416, 1),
(221, 467, 1),
(221, 323, 15),
(221, 405, 20),
(221, 183, 25),
(221, 326, 30),
(221, 16, 37),
(221, 664, 44),
(221, 171, 51),
(221, 55, 58),
(221, 677, 65),
(223, 299, 1),
(223, 716, 4),
(223, 233, 8),
(223, 477, 12),
(223, 33, 16),
(223, 74, 20),
(223, 363, 24),
(223, 80, 28),
(223, 318, 32),
(223, 595, 40),
(223, 312, 44),
(224, 233, 1),
(224, 278, 1),
(224, 299, 1),
(224, 435, 1),
(224, 519, 1),
(224, 716, 1),
(224, 734, 1),
(224, 477, 12),
(224, 33, 16),
(224, 74, 20),
(224, 363, 24),
(224, 80, 30),
(224, 318, 36),
(224, 595, 48),
(224, 312, 54),
(225, 474, 1),
(226, 80, 1),
(226, 477, 1),
(226, 529, 1),
(226, 648, 1),
(226, 716, 12),
(226, 725, 16),
(226, 12, 20),
(226, 74, 24),
(226, 288, 28),
(226, 14, 32),
(226, 21, 36),
(226, 66, 40),
(226, 664, 44),
(227, 355, 1),
(227, 535, 4),
(227, 247, 8),
(227, 390, 12),
(227, 12, 16),
(227, 579, 24),
(227, 625, 28),
(227, 35, 32),
(227, 391, 40),
(227, 609, 44),
(227, 334, 48),
(227, 68, 52),
(230, 355, 1),
(230, 589, 1),
(230, 703, 1),
(230, 722, 1),
(230, 736, 1),
(230, 233, 15),
(230, 153, 20),
(230, 74, 25),
(230, 12, 30),
(230, 345, 37),
(230, 154, 58),
(230, 499, 65),
(233, 108, 1),
(233, 133, 1),
(233, 378, 1),
(233, 505, 1),
(233, 683, 15),
(233, 477, 20),
(233, 109, 25),
(233, 12, 30),
(233, 504, 35),
(233, 141, 40),
(233, 694, 45),
(233, 372, 50),
(233, 363, 55),
(233, 737, 60),
(233, 312, 65),
(236, 195, 1),
(236, 233, 1),
(236, 299, 1),
(237, 195, 1),
(237, 200, 1),
(237, 233, 1),
(237, 299, 1),
(237, 500, 1),
(237, 699, 1),
(237, 494, 4),
(237, 280, 8),
(237, 136, 12),
(237, 514, 16),
(237, 495, 21),
(237, 725, 21),
(237, 643, 24),
(237, 12, 28),
(237, 138, 32),
(237, 100, 36),
(237, 116, 40),
(237, 182, 44),
(238, 357, 1),
(238, 467, 4),
(238, 110, 8),
(238, 106, 12),
(238, 118, 16),
(238, 568, 20),
(238, 196, 24),
(238, 322, 28),
(238, 479, 32),
(238, 653, 36),
(238, 384, 40),
(238, 447, 44),
(238, 55, 48),
(239, 355, 1),
(239, 494, 1),
(239, 683, 4),
(239, 89, 8),
(239, 655, 12),
(239, 563, 16),
(239, 684, 20),
(239, 543, 24),
(239, 682, 28),
(239, 141, 32),
(239, 365, 36),
(239, 685, 40),
(239, 360, 44),
(239, 679, 48),
(240, 355, 1),
(240, 588, 1),
(240, 180, 4),
(240, 589, 8),
(240, 99, 12),
(240, 218, 16),
(240, 105, 20),
(240, 541, 24),
(240, 210, 28),
(240, 348, 32),
(240, 365, 36),
(240, 219, 40),
(240, 644, 44),
(240, 206, 48),
(241, 271, 1),
(241, 528, 5),
(241, 133, 10),
(241, 629, 15),
(241, 289, 20),
(241, 288, 25),
(241, 738, 30),
(241, 396, 35),
(241, 59, 40),
(241, 456, 45),
(241, 91, 50),
(241, 302, 55),
(242, 91, 1),
(242, 110, 1),
(242, 118, 1),
(242, 133, 1),
(242, 140, 1),
(242, 400, 1),
(242, 653, 1),
(242, 662, 4),
(242, 172, 8),
(242, 358, 12),
(242, 568, 16),
(242, 225, 20),
(242, 664, 24),
(242, 292, 28),
(242, 299, 32),
(242, 360, 36),
(242, 150, 40),
(242, 596, 44),
(242, 347, 48),
(242, 293, 52),
(243, 89, 1),
(243, 192, 1),
(243, 355, 1),
(243, 494, 1),
(243, 683, 1),
(243, 602, 6),
(243, 52, 12),
(243, 84, 18),
(243, 517, 24),
(243, 681, 30),
(243, 309, 36),
(243, 123, 42),
(243, 190, 48),
(243, 141, 54),
(243, 506, 60),
(243, 499, 66),
(243, 679, 72),
(243, 737, 78),
(244, 180, 1),
(244, 192, 1),
(244, 355, 1),
(244, 532, 1),
(244, 589, 1),
(244, 629, 1),
(244, 218, 6),
(244, 52, 12),
(244, 84, 18),
(244, 517, 24),
(244, 207, 30),
(244, 541, 36),
(244, 123, 42),
(244, 190, 48),
(244, 348, 54),
(244, 651, 60),
(244, 644, 66),
(244, 206, 72),
(244, 186, 78),
(245, 192, 1),
(245, 279, 1),
(245, 355, 1),
(245, 405, 1),
(245, 558, 1),
(245, 716, 6),
(245, 52, 12),
(245, 84, 18),
(245, 517, 24),
(245, 320, 30),
(245, 663, 36),
(245, 123, 42),
(245, 190, 48),
(245, 649, 54),
(245, 402, 60),
(245, 499, 66),
(245, 55, 78),
(246, 355, 1),
(246, 446, 6),
(246, 52, 9),
(246, 541, 12),
(246, 522, 15),
(246, 630, 18),
(246, 543, 21),
(246, 127, 24),
(246, 123, 27),
(246, 171, 31),
(246, 631, 33),
(246, 677, 36),
(246, 537, 39),
(246, 312, 42),
(247, 334, 1),
(247, 355, 1),
(247, 446, 1),
(247, 52, 9),
(247, 541, 12),
(247, 522, 15),
(247, 630, 18),
(247, 543, 21),
(247, 127, 24),
(247, 123, 27),
(247, 171, 33),
(247, 631, 37),
(247, 677, 42),
(247, 537, 47),
(247, 312, 52),
(248, 207, 1),
(248, 320, 1),
(248, 334, 1),
(248, 355, 1),
(248, 446, 1),
(248, 681, 1),
(248, 52, 9),
(248, 541, 12),
(248, 522, 15),
(248, 630, 18),
(248, 543, 21),
(248, 127, 24),
(248, 123, 27),
(248, 171, 33),
(248, 631, 37),
(248, 677, 42),
(248, 537, 47),
(248, 312, 52),
(248, 259, 59),
(249, 18, 1),
(249, 159, 1),
(249, 279, 1),
(249, 721, 1),
(249, 723, 1),
(249, 405, 9),
(249, 534, 18),
(249, 84, 27),
(249, 190, 36),
(249, 504, 45),
(249, 10, 54),
(249, 499, 63),
(249, 252, 81),
(249, 575, 90),
(251, 106, 1),
(251, 289, 1),
(251, 375, 10),
(251, 42, 20),
(251, 18, 30),
(251, 358, 40),
(251, 354, 50),
(251, 504, 60),
(251, 252, 70),
(251, 293, 80),
(251, 350, 90),
(251, 447, 100),
(252, 355, 1),
(252, 352, 3),
(252, 494, 6),
(252, 386, 9),
(252, 136, 12),
(252, 495, 15),
(252, 26, 18),
(252, 258, 21),
(252, 149, 27),
(252, 184, 30),
(252, 543, 33),
(252, 182, 36),
(252, 350, 39),
(253, 184, 1),
(253, 198, 1),
(253, 248, 1),
(253, 352, 1),
(253, 355, 1),
(253, 494, 1),
(253, 386, 9),
(253, 136, 12),
(253, 495, 15),
(253, 26, 20),
(253, 258, 25),
(253, 149, 35),
(253, 349, 40),
(253, 543, 45),
(253, 182, 50),
(253, 350, 55),
(254, 166, 1),
(254, 184, 1),
(254, 198, 1),
(254, 248, 1),
(254, 352, 1),
(254, 355, 1),
(254, 494, 1),
(254, 386, 5),
(254, 136, 12),
(254, 495, 15),
(254, 26, 20),
(254, 258, 25),
(254, 149, 35),
(254, 349, 42),
(254, 543, 49),
(254, 182, 56),
(254, 350, 63),
(255, 271, 1),
(255, 180, 3),
(255, 494, 6),
(255, 217, 9),
(255, 136, 12),
(255, 535, 15),
(255, 9, 18),
(255, 579, 21),
(255, 66, 24),
(255, 233, 27),
(255, 219, 30),
(255, 199, 33),
(255, 515, 36),
(255, 220, 39),
(256, 147, 1),
(256, 180, 1),
(256, 199, 1),
(256, 219, 1),
(256, 271, 1),
(256, 494, 1),
(256, 217, 9),
(256, 136, 12),
(256, 535, 15),
(256, 9, 20),
(256, 579, 25),
(256, 66, 30),
(256, 233, 35),
(256, 54, 40),
(256, 77, 45),
(256, 515, 50),
(256, 220, 55),
(257, 68, 1),
(257, 147, 1),
(257, 180, 1),
(257, 199, 1),
(257, 210, 1),
(257, 219, 1),
(257, 271, 1),
(257, 494, 1),
(257, 217, 9),
(257, 136, 12),
(257, 535, 15),
(257, 9, 20),
(257, 579, 25),
(257, 66, 30),
(257, 233, 35),
(257, 54, 42),
(257, 77, 49),
(257, 515, 56),
(257, 220, 63),
(258, 271, 1),
(258, 523, 6),
(258, 476, 12),
(258, 648, 15),
(258, 716, 18),
(258, 522, 21),
(258, 664, 24),
(258, 16, 27),
(258, 649, 30),
(258, 543, 33),
(258, 182, 36),
(259, 171, 1),
(259, 271, 1),
(259, 414, 1),
(259, 523, 1),
(259, 649, 1),
(259, 476, 12),
(259, 648, 15),
(259, 716, 20),
(259, 522, 25),
(259, 664, 30),
(259, 16, 35),
(259, 417, 40),
(259, 543, 45),
(259, 182, 50),
(260, 171, 1),
(260, 271, 1),
(260, 282, 1),
(260, 414, 1),
(260, 523, 1),
(260, 649, 1),
(260, 476, 12),
(260, 648, 15),
(260, 716, 20),
(260, 522, 25),
(260, 664, 30),
(260, 16, 35),
(260, 417, 42),
(260, 543, 49),
(260, 182, 56),
(270, 27, 1),
(270, 271, 1),
(270, 2, 3),
(270, 405, 9),
(270, 386, 12),
(270, 215, 16),
(270, 74, 20),
(270, 422, 24),
(270, 258, 28),
(270, 499, 33),
(270, 738, 38),
(270, 184, 43),
(271, 2, 1),
(271, 27, 1),
(271, 195, 1),
(271, 215, 1),
(271, 271, 1),
(271, 344, 1),
(271, 670, 1),
(271, 405, 9),
(271, 386, 12),
(271, 249, 18),
(271, 74, 24),
(271, 422, 30),
(271, 258, 36),
(271, 499, 43),
(271, 738, 50),
(271, 184, 57),
(272, 2, 1),
(272, 27, 1),
(272, 74, 1),
(272, 184, 1),
(272, 195, 1),
(272, 215, 1),
(272, 249, 1),
(272, 258, 1),
(272, 271, 1),
(272, 344, 1),
(272, 386, 1),
(272, 405, 1),
(272, 422, 1),
(272, 499, 1),
(272, 670, 1),
(272, 738, 1),
(273, 284, 1),
(273, 2, 3),
(273, 27, 6),
(273, 272, 9),
(273, 528, 12),
(273, 386, 15),
(273, 446, 18),
(273, 422, 21),
(273, 644, 24),
(273, 659, 27),
(273, 643, 30),
(273, 189, 33),
(274, 2, 1),
(274, 13, 1),
(274, 27, 1),
(274, 189, 1),
(274, 195, 1),
(274, 284, 1),
(274, 501, 1),
(274, 651, 1),
(274, 659, 1),
(274, 689, 1),
(274, 272, 9),
(274, 528, 12),
(274, 386, 18),
(274, 446, 24),
(274, 422, 30),
(274, 644, 36),
(274, 190, 43),
(274, 643, 50),
(274, 349, 57),
(275, 2, 1),
(275, 13, 1),
(275, 27, 1),
(275, 189, 1),
(275, 190, 1),
(275, 195, 1),
(275, 272, 1),
(275, 284, 1),
(275, 310, 1),
(275, 349, 1),
(275, 351, 1),
(275, 386, 1),
(275, 422, 1),
(275, 446, 1),
(275, 501, 1),
(275, 528, 1),
(275, 643, 1),
(275, 644, 1),
(275, 651, 1),
(275, 659, 1),
(275, 689, 1),
(275, 723, 1),
(278, 271, 1),
(278, 494, 5),
(278, 648, 10),
(278, 716, 20),
(278, 12, 26),
(278, 14, 30),
(278, 405, 35),
(278, 529, 40),
(278, 310, 45),
(279, 12, 1),
(279, 14, 1),
(279, 271, 1),
(279, 476, 1),
(279, 494, 1),
(279, 595, 1),
(279, 648, 1),
(279, 663, 1),
(279, 716, 20),
(279, 613, 28),
(279, 627, 28),
(279, 652, 28),
(279, 225, 34),
(279, 405, 41),
(279, 529, 48),
(279, 310, 55),
(280, 140, 1),
(280, 271, 1),
(280, 149, 3),
(280, 106, 6),
(280, 316, 9),
(280, 162, 12),
(280, 672, 15),
(280, 477, 18),
(280, 358, 21),
(280, 91, 24),
(280, 84, 27),
(280, 479, 30),
(280, 292, 33),
(280, 163, 36),
(280, 252, 39),
(281, 106, 1),
(281, 140, 1),
(281, 149, 1),
(281, 271, 1),
(281, 316, 9),
(281, 162, 12),
(281, 672, 15),
(281, 477, 18),
(281, 358, 23),
(281, 91, 28),
(281, 84, 33),
(281, 479, 38),
(281, 292, 43),
(281, 163, 48),
(281, 252, 53),
(282, 91, 1),
(282, 106, 1),
(282, 130, 1),
(282, 140, 1),
(282, 149, 1),
(282, 271, 1),
(282, 293, 1),
(282, 408, 1),
(282, 409, 1),
(282, 316, 9),
(282, 162, 12),
(282, 672, 15),
(282, 477, 18),
(282, 358, 23),
(282, 728, 28),
(282, 84, 35),
(282, 479, 42),
(282, 292, 49),
(282, 163, 56),
(282, 252, 63),
(290, 535, 1),
(290, 284, 5),
(290, 198, 10),
(290, 416, 15),
(290, 2, 21),
(290, 390, 25),
(290, 249, 30),
(290, 399, 35),
(290, 138, 40),
(291, 9, 1),
(291, 42, 1),
(291, 138, 1),
(291, 149, 1),
(291, 198, 1),
(291, 248, 1),
(291, 284, 1),
(291, 390, 1),
(291, 416, 1),
(291, 535, 1),
(291, 543, 1),
(291, 12, 15),
(291, 2, 23),
(291, 75, 29),
(291, 249, 36),
(291, 399, 43),
(291, 579, 50),
(291, 657, 57),
(292, 138, 1),
(292, 198, 1),
(292, 273, 1),
(292, 284, 1),
(292, 390, 1),
(292, 416, 1),
(292, 535, 1),
(292, 553, 1),
(292, 105, 15),
(292, 2, 23),
(292, 556, 29),
(292, 249, 36),
(292, 399, 43),
(292, 551, 50),
(292, 614, 57),
(292, 450, 64),
(293, 27, 1),
(293, 172, 5),
(293, 309, 10),
(293, 510, 15),
(293, 581, 15),
(293, 629, 21),
(293, 517, 25),
(293, 648, 30),
(293, 705, 35),
(293, 543, 40),
(294, 27, 1),
(294, 52, 1),
(294, 172, 1),
(294, 309, 1),
(294, 510, 15),
(294, 581, 15),
(294, 629, 23),
(294, 517, 29),
(294, 648, 36),
(294, 705, 43),
(294, 543, 50),
(295, 27, 1),
(295, 52, 1),
(295, 123, 1),
(295, 172, 1),
(295, 207, 1),
(295, 309, 1),
(295, 320, 1),
(295, 681, 1),
(295, 510, 15),
(295, 581, 15),
(295, 629, 23),
(295, 517, 29),
(295, 648, 36),
(295, 705, 45),
(295, 543, 54),
(295, 65, 72),
(295, 312, 81),
(298, 615, 1),
(298, 662, 1),
(298, 299, 3),
(298, 74, 6),
(298, 91, 9),
(298, 66, 15),
(302, 355, 1),
(302, 27, 3),
(302, 105, 6),
(302, 556, 9),
(302, 195, 12),
(302, 139, 15),
(302, 136, 18),
(302, 426, 21),
(302, 249, 24),
(302, 344, 27),
(302, 493, 30),
(302, 553, 33),
(302, 384, 36),
(302, 738, 42),
(302, 551, 45),
(302, 239, 48),
(303, 27, 1),
(303, 271, 1),
(303, 42, 8),
(303, 52, 12),
(303, 613, 16),
(303, 627, 16),
(303, 652, 16),
(303, 643, 20),
(303, 334, 24),
(303, 123, 28),
(303, 654, 32),
(303, 335, 36),
(303, 666, 40),
(303, 196, 44),
(303, 456, 48),
(304, 284, 1),
(304, 390, 4),
(304, 524, 8),
(304, 517, 12),
(304, 288, 16),
(304, 476, 20),
(304, 522, 24),
(304, 335, 28),
(304, 391, 33),
(304, 664, 36),
(304, 35, 40),
(304, 336, 44),
(304, 334, 48),
(304, 298, 52),
(304, 150, 56),
(304, 389, 60),
(305, 284, 1),
(305, 390, 1),
(305, 524, 1),
(305, 517, 12),
(305, 288, 16),
(305, 476, 20),
(305, 522, 24),
(305, 335, 28),
(305, 391, 35),
(305, 664, 40),
(305, 35, 46),
(305, 336, 52),
(305, 334, 58),
(305, 298, 64),
(305, 150, 70),
(305, 389, 76),
(306, 284, 1),
(306, 390, 1),
(306, 524, 1),
(306, 517, 12),
(306, 288, 16),
(306, 476, 20),
(306, 522, 24),
(306, 335, 28),
(306, 391, 35),
(306, 664, 40),
(306, 35, 48),
(306, 336, 56),
(306, 334, 64),
(306, 298, 72),
(306, 150, 80),
(306, 389, 88),
(309, 684, 1),
(309, 355, 4),
(309, 309, 8),
(309, 494, 12),
(309, 563, 16),
(309, 52, 20),
(309, 681, 24),
(309, 517, 28),
(309, 141, 32),
(309, 89, 36),
(309, 726, 40),
(309, 679, 44),
(310, 207, 1),
(310, 309, 1),
(310, 355, 1),
(310, 684, 1),
(310, 494, 12),
(310, 563, 16),
(310, 52, 20),
(310, 681, 24),
(310, 517, 30),
(310, 141, 36),
(310, 89, 42),
(310, 726, 48),
(310, 679, 54),
(310, 175, 60),
(315, 2, 1),
(315, 272, 1),
(315, 462, 1),
(315, 640, 1),
(315, 733, 1),
(315, 386, 5),
(315, 354, 10),
(315, 375, 15),
(315, 691, 20),
(315, 654, 25),
(315, 258, 30),
(315, 659, 35),
(315, 690, 40),
(315, 448, 45),
(315, 23, 50),
(315, 331, 55),
(315, 449, 60),
(318, 20, 1),
(318, 355, 1),
(318, 458, 4),
(318, 233, 8),
(318, 541, 12),
(318, 52, 16),
(318, 320, 20),
(318, 543, 24),
(318, 651, 28),
(318, 123, 32),
(318, 12, 36),
(318, 362, 40),
(318, 664, 44),
(319, 20, 1),
(319, 233, 1),
(319, 355, 1),
(319, 427, 1),
(319, 458, 1),
(319, 579, 1),
(319, 541, 12),
(319, 52, 16),
(319, 320, 20),
(319, 543, 24),
(319, 651, 28),
(319, 123, 34),
(319, 12, 40),
(319, 362, 46),
(319, 664, 52),
(320, 615, 1),
(320, 271, 3),
(320, 27, 6),
(320, 405, 15),
(320, 716, 18),
(320, 298, 21),
(320, 71, 24),
(320, 722, 27),
(320, 142, 30),
(320, 66, 33),
(320, 59, 36),
(320, 510, 39),
(320, 16, 42),
(320, 719, 48),
(321, 27, 1),
(321, 271, 1),
(321, 430, 1),
(321, 595, 1),
(321, 615, 1),
(321, 405, 15),
(321, 716, 18),
(321, 298, 21),
(321, 71, 24),
(321, 722, 27),
(321, 142, 30),
(321, 66, 33),
(321, 59, 36),
(321, 510, 39),
(321, 16, 44),
(321, 719, 54),
(324, 180, 1),
(324, 588, 1),
(324, 729, 4),
(324, 500, 8),
(324, 589, 12),
(324, 99, 16),
(324, 218, 20),
(324, 476, 24),
(324, 348, 28),
(324, 59, 32),
(324, 334, 36),
(324, 219, 40),
(324, 126, 44),
(324, 297, 48),
(324, 16, 52),
(324, 329, 56),
(324, 560, 60),
(324, 186, 64),
(328, 27, 1),
(328, 535, 1),
(328, 345, 4),
(328, 52, 8),
(328, 416, 12),
(328, 536, 16),
(328, 78, 20),
(328, 138, 24),
(328, 123, 28),
(328, 537, 32),
(328, 170, 36),
(328, 171, 40),
(328, 647, 44),
(328, 214, 48),
(329, 27, 1),
(329, 52, 1),
(329, 78, 1),
(329, 123, 1),
(329, 138, 1),
(329, 153, 1),
(329, 214, 1),
(329, 345, 1),
(329, 535, 1),
(329, 647, 1),
(329, 648, 1),
(329, 416, 12),
(329, 536, 16),
(329, 160, 20),
(329, 543, 24),
(329, 76, 28),
(329, 537, 32),
(329, 170, 38),
(329, 171, 44),
(329, 705, 50),
(329, 159, 56),
(329, 65, 62),
(330, 27, 1),
(330, 52, 1),
(330, 78, 1),
(330, 123, 1),
(330, 138, 1),
(330, 153, 1),
(330, 154, 1),
(330, 200, 1),
(330, 214, 1),
(330, 345, 1),
(330, 535, 1),
(330, 647, 1),
(330, 648, 1),
(330, 416, 12),
(330, 536, 16),
(330, 160, 20),
(330, 543, 24),
(330, 76, 28),
(330, 537, 32),
(330, 170, 38),
(330, 171, 44),
(330, 705, 52),
(330, 159, 60),
(330, 65, 68),
(333, 271, 1),
(333, 140, 4),
(333, 405, 8),
(333, 247, 12),
(333, 531, 16),
(333, 153, 20),
(333, 534, 24),
(333, 568, 28),
(333, 114, 32),
(333, 664, 36),
(333, 409, 40),
(333, 447, 44),
(334, 140, 1),
(334, 271, 1),
(334, 405, 1),
(334, 457, 1),
(334, 247, 12),
(334, 531, 16),
(334, 153, 20),
(334, 534, 24),
(334, 568, 28),
(334, 114, 32),
(334, 664, 38),
(334, 409, 44),
(334, 447, 50),
(334, 575, 56),
(337, 106, 1),
(337, 284, 1),
(337, 409, 1),
(337, 411, 1),
(337, 316, 5),
(337, 521, 10),
(337, 522, 15),
(337, 485, 20),
(337, 113, 25),
(337, 479, 30),
(337, 631, 35),
(337, 252, 40),
(337, 374, 45),
(337, 189, 50),
(338, 106, 1),
(338, 220, 1),
(338, 284, 1),
(338, 412, 1),
(338, 316, 5),
(338, 521, 10),
(338, 522, 15),
(338, 738, 20),
(338, 113, 25),
(338, 479, 30),
(338, 631, 35),
(338, 597, 40),
(338, 730, 45),
(338, 189, 50),
(339, 416, 1),
(339, 510, 6),
(339, 594, 6),
(339, 716, 12),
(339, 16, 18),
(339, 417, 31),
(339, 171, 36),
(339, 252, 42),
(339, 214, 48),
(340, 47, 1),
(340, 416, 1),
(340, 510, 1),
(340, 594, 1),
(340, 677, 1),
(340, 687, 1),
(340, 738, 1),
(340, 716, 12),
(340, 16, 18),
(340, 417, 33),
(340, 171, 40),
(340, 252, 48),
(340, 214, 56),
(341, 284, 1),
(341, 355, 4),
(341, 666, 8),
(341, 74, 12),
(341, 344, 16),
(341, 145, 20),
(341, 476, 24),
(341, 427, 28),
(341, 502, 32),
(341, 657, 36),
(341, 123, 40),
(341, 119, 44),
(341, 182, 48),
(341, 277, 52),
(342, 284, 1),
(342, 355, 1),
(342, 655, 1),
(342, 666, 1),
(342, 74, 12),
(342, 344, 16),
(342, 145, 20),
(342, 476, 24),
(342, 427, 28),
(342, 502, 34),
(342, 657, 40),
(342, 123, 46),
(342, 119, 52),
(342, 182, 58),
(342, 277, 64),
(343, 284, 1),
(343, 416, 1),
(343, 500, 3),
(343, 106, 6),
(343, 524, 9),
(343, 470, 12),
(343, 477, 15),
(343, 18, 18),
(343, 327, 21),
(343, 113, 24),
(343, 190, 27),
(343, 170, 30),
(343, 550, 33),
(343, 274, 36),
(343, 468, 36),
(343, 537, 39),
(343, 189, 42),
(344, 106, 1),
(344, 284, 1),
(344, 312, 1),
(344, 416, 1),
(344, 500, 1),
(344, 672, 1),
(344, 524, 9),
(344, 470, 12),
(344, 477, 15),
(344, 18, 18),
(344, 327, 21),
(344, 113, 24),
(344, 190, 27),
(344, 170, 30),
(344, 550, 33),
(344, 274, 38),
(344, 468, 38),
(344, 537, 43),
(344, 189, 48),
(345, 27, 1),
(345, 734, 1),
(345, 4, 4),
(345, 105, 8),
(345, 331, 12),
(345, 18, 16),
(345, 386, 20),
(345, 71, 24),
(345, 16, 28),
(345, 253, 32),
(345, 258, 36),
(345, 613, 41),
(345, 627, 41),
(345, 652, 41),
(345, 184, 44),
(346, 4, 1),
(346, 27, 1),
(346, 105, 1),
(346, 354, 1),
(346, 734, 1),
(346, 331, 12),
(346, 18, 16),
(346, 386, 20),
(346, 71, 24),
(346, 16, 28),
(346, 253, 32),
(346, 258, 36),
(346, 613, 43),
(346, 627, 43),
(346, 652, 43),
(346, 184, 48),
(347, 248, 1),
(347, 284, 1),
(347, 585, 8),
(347, 390, 12),
(347, 18, 16),
(347, 75, 20),
(347, 71, 24),
(347, 579, 28),
(347, 124, 32),
(347, 519, 36),
(347, 476, 41),
(348, 248, 1),
(348, 284, 1),
(348, 585, 1),
(348, 390, 12),
(348, 18, 16),
(348, 75, 20),
(348, 71, 24),
(348, 579, 28),
(348, 124, 32),
(348, 519, 36),
(348, 476, 43),
(349, 615, 1),
(349, 215, 25),
(350, 215, 1),
(350, 615, 1),
(350, 716, 1),
(350, 734, 1),
(350, 140, 4),
(350, 703, 8),
(350, 21, 12),
(350, 30, 16),
(350, 358, 20),
(350, 160, 24),
(350, 504, 28),
(350, 534, 36),
(350, 649, 40),
(350, 499, 44),
(350, 102, 48),
(355, 27, 1),
(355, 355, 1),
(355, 139, 4),
(355, 556, 8),
(355, 105, 12),
(355, 426, 16),
(355, 446, 20),
(355, 727, 24),
(355, 384, 28),
(355, 300, 32),
(355, 126, 36),
(355, 551, 40),
(355, 252, 44),
(356, 27, 1),
(356, 51, 1),
(356, 139, 1),
(356, 210, 1),
(356, 270, 1),
(356, 322, 1),
(356, 355, 1),
(356, 555, 1),
(356, 556, 1),
(356, 682, 1),
(356, 105, 12),
(356, 426, 16),
(356, 446, 20),
(356, 727, 24),
(356, 384, 28),
(356, 300, 32),
(356, 126, 36),
(356, 551, 42),
(356, 252, 48),
(359, 355, 1),
(359, 494, 1),
(359, 149, 5),
(359, 344, 10),
(359, 136, 15),
(359, 666, 20),
(359, 579, 25),
(359, 427, 30),
(359, 233, 35),
(359, 643, 40),
(359, 657, 45),
(359, 252, 50),
(359, 447, 55),
(360, 16, 1),
(360, 91, 1),
(360, 116, 1),
(360, 135, 1),
(360, 181, 1),
(360, 402, 1),
(360, 534, 1),
(360, 615, 1),
(361, 27, 1),
(361, 467, 1),
(361, 355, 5),
(361, 149, 10),
(361, 323, 15),
(361, 476, 20),
(361, 326, 25),
(361, 245, 30),
(361, 52, 35),
(361, 320, 40),
(361, 281, 45),
(361, 288, 50),
(361, 123, 55),
(361, 55, 60),
(362, 27, 1),
(362, 149, 1),
(362, 241, 1),
(362, 355, 1),
(362, 467, 1),
(362, 558, 1),
(362, 323, 15),
(362, 476, 20),
(362, 326, 25),
(362, 245, 30),
(362, 52, 35),
(362, 320, 40),
(362, 281, 47),
(362, 288, 54),
(362, 123, 61),
(362, 55, 68),
(363, 133, 1),
(363, 528, 1),
(363, 271, 4),
(363, 467, 12),
(363, 510, 16),
(363, 594, 20),
(363, 71, 24),
(363, 33, 28),
(363, 181, 33),
(363, 59, 36),
(363, 649, 40),
(363, 55, 44),
(363, 281, 48),
(363, 558, 52),
(364, 133, 1),
(364, 271, 1),
(364, 528, 1),
(364, 651, 1),
(364, 467, 12),
(364, 510, 16),
(364, 594, 20),
(364, 71, 24),
(364, 33, 28),
(364, 181, 35),
(364, 59, 40),
(364, 649, 46),
(364, 55, 52),
(364, 281, 58),
(364, 558, 64),
(365, 123, 1),
(365, 133, 1),
(365, 271, 1),
(365, 320, 1),
(365, 528, 1),
(365, 651, 1),
(365, 467, 12),
(365, 510, 16),
(365, 594, 20),
(365, 71, 24),
(365, 33, 28),
(365, 181, 35),
(365, 59, 40),
(365, 649, 48),
(365, 55, 56),
(365, 281, 64),
(365, 558, 72),
(369, 284, 1),
(369, 18, 10),
(369, 736, 15),
(369, 142, 20),
(369, 664, 25),
(369, 510, 35),
(369, 215, 40),
(369, 150, 50),
(369, 287, 55),
(371, 180, 1),
(371, 355, 1),
(371, 52, 5),
(371, 153, 10),
(371, 288, 15),
(371, 541, 20),
(371, 123, 25),
(371, 738, 35),
(371, 233, 40),
(371, 219, 45),
(371, 440, 50),
(371, 150, 55),
(372, 52, 1),
(372, 153, 1),
(372, 180, 1),
(372, 355, 1),
(372, 476, 1),
(372, 288, 15),
(372, 541, 20),
(372, 123, 25),
(372, 738, 39),
(372, 233, 46),
(372, 219, 53),
(372, 440, 60),
(372, 150, 67),
(373, 52, 1),
(373, 153, 1),
(373, 160, 1),
(373, 180, 1),
(373, 230, 1),
(373, 355, 1),
(373, 476, 1),
(373, 288, 15),
(373, 541, 20),
(373, 123, 25),
(373, 738, 39),
(373, 233, 46),
(373, 219, 55),
(373, 440, 64),
(373, 150, 73),
(375, 79, 1),
(375, 106, 1),
(375, 390, 1),
(375, 738, 6),
(375, 378, 12),
(375, 222, 18),
(375, 664, 26),
(375, 479, 34),
(375, 541, 42),
(375, 394, 50),
(375, 334, 58),
(375, 12, 66),
(375, 312, 74),
(376, 79, 1),
(376, 106, 1),
(376, 282, 1),
(376, 390, 1),
(376, 738, 6),
(376, 378, 12),
(376, 222, 16),
(376, 664, 26),
(376, 479, 34),
(376, 541, 42),
(376, 394, 52),
(376, 334, 62),
(376, 12, 72),
(376, 312, 82),
(377, 90, 1),
(377, 78, 6),
(377, 18, 12),
(377, 629, 18),
(377, 522, 24),
(377, 126, 30),
(377, 334, 36),
(377, 282, 42),
(377, 631, 48),
(377, 647, 54),
(377, 363, 60),
(377, 737, 66),
(377, 312, 72),
(377, 189, 78),
(378, 90, 1),
(378, 326, 1),
(378, 78, 6),
(378, 18, 12),
(378, 629, 18),
(378, 318, 24),
(378, 126, 30),
(378, 16, 36),
(378, 282, 42),
(378, 55, 48),
(378, 647, 54),
(378, 363, 60),
(378, 737, 66),
(378, 312, 72),
(378, 189, 78),
(379, 90, 1),
(379, 390, 1),
(379, 78, 6),
(379, 18, 12),
(379, 629, 18),
(379, 222, 24),
(379, 335, 24),
(379, 126, 30),
(379, 16, 36),
(379, 334, 36),
(379, 282, 42),
(379, 298, 48),
(379, 647, 54),
(379, 363, 60),
(379, 737, 66),
(379, 312, 72),
(379, 189, 78),
(380, 91, 1),
(380, 632, 1),
(380, 299, 5),
(380, 504, 10),
(380, 106, 15),
(380, 663, 20),
(380, 153, 25),
(380, 728, 30),
(380, 406, 35),
(380, 738, 40),
(380, 292, 50),
(380, 507, 55),
(380, 479, 60),
(380, 274, 65),
(380, 293, 70),
(380, 484, 75),
(381, 154, 1),
(381, 632, 1),
(381, 299, 5),
(381, 504, 10),
(381, 106, 15),
(381, 663, 20),
(381, 153, 25),
(381, 15, 30),
(381, 370, 35),
(381, 738, 40),
(381, 292, 50),
(381, 567, 55),
(381, 479, 60),
(381, 468, 65),
(381, 387, 70),
(381, 484, 75),
(382, 18, 1),
(382, 59, 1),
(382, 541, 1),
(382, 716, 1),
(382, 84, 18),
(382, 417, 27),
(382, 318, 36),
(382, 558, 45),
(382, 21, 54),
(382, 439, 63),
(382, 150, 81),
(382, 719, 90),
(383, 18, 1),
(383, 348, 1),
(383, 414, 1),
(383, 541, 1),
(383, 170, 9),
(383, 77, 18),
(383, 171, 27),
(383, 282, 36),
(383, 214, 45),
(383, 510, 54),
(383, 473, 63),
(383, 206, 72),
(383, 597, 81),
(383, 186, 90),
(384, 14, 1),
(384, 18, 1),
(384, 152, 1),
(384, 541, 1),
(384, 703, 1),
(384, 123, 9),
(384, 154, 18),
(384, 192, 27),
(384, 510, 54),
(384, 230, 63),
(384, 310, 72),
(384, 440, 81),
(384, 312, 90),
(385, 106, 1),
(385, 728, 1),
(385, 655, 7),
(385, 299, 14),
(385, 358, 21),
(385, 738, 28),
(385, 270, 35),
(385, 479, 42),
(385, 394, 49),
(385, 293, 56),
(385, 510, 63),
(385, 252, 70),
(385, 150, 77),
(385, 113, 84),
(385, 347, 91),
(385, 144, 98),
(403, 355, 1),
(403, 683, 4),
(403, 89, 8),
(403, 52, 12),
(403, 602, 16),
(403, 517, 20),
(403, 712, 24),
(403, 541, 28),
(403, 684, 32),
(403, 123, 36),
(403, 141, 40),
(403, 651, 44),
(403, 726, 48),
(404, 89, 1),
(404, 355, 1),
(404, 683, 1),
(404, 52, 12),
(404, 602, 18),
(404, 517, 24),
(404, 712, 31),
(404, 541, 36),
(404, 684, 42),
(404, 123, 48),
(404, 141, 54),
(404, 651, 60),
(404, 726, 68),
(405, 89, 1),
(405, 175, 1),
(405, 355, 1),
(405, 683, 1),
(405, 52, 12),
(405, 602, 18),
(405, 517, 24),
(405, 712, 33),
(405, 541, 40),
(405, 684, 48),
(405, 123, 56),
(405, 141, 64),
(405, 651, 72),
(405, 726, 80),
(406, 2, 1),
(406, 272, 1),
(406, 640, 1),
(406, 733, 1),
(407, 2, 1),
(407, 23, 1),
(407, 258, 1),
(407, 268, 1),
(407, 272, 1),
(407, 331, 1),
(407, 354, 1),
(407, 375, 1),
(407, 386, 1),
(407, 448, 1),
(407, 449, 1),
(407, 462, 1),
(407, 640, 1),
(407, 654, 1),
(407, 659, 1),
(407, 690, 1),
(407, 691, 1),
(407, 709, 1),
(407, 733, 1),
(415, 75, 1),
(415, 279, 1),
(415, 638, 1),
(415, 654, 1),
(416, 75, 1),
(416, 105, 1),
(416, 279, 1),
(416, 462, 1),
(416, 579, 1),
(416, 638, 1),
(416, 654, 1),
(416, 248, 4),
(416, 24, 8),
(416, 202, 12),
(416, 249, 16),
(416, 651, 20),
(416, 23, 24),
(416, 14, 28),
(416, 690, 36),
(416, 29, 40),
(416, 132, 40),
(416, 135, 44),
(420, 412, 1),
(420, 352, 5),
(420, 272, 10),
(420, 299, 15),
(420, 375, 20),
(420, 354, 26),
(420, 664, 30),
(420, 448, 35),
(420, 733, 40),
(420, 597, 45),
(421, 229, 1),
(421, 272, 1),
(421, 352, 1),
(421, 412, 1),
(421, 644, 1),
(421, 299, 15),
(421, 375, 20),
(421, 354, 28),
(421, 664, 34),
(421, 448, 41),
(421, 733, 48),
(421, 597, 55),
(421, 449, 62),
(422, 416, 1),
(422, 284, 5),
(422, 504, 10),
(422, 716, 15),
(422, 18, 20),
(422, 59, 25),
(422, 417, 31),
(422, 170, 35),
(422, 499, 40),
(422, 387, 45),
(423, 284, 1),
(423, 416, 1),
(423, 504, 1),
(423, 716, 15),
(423, 18, 20),
(423, 59, 25),
(423, 417, 33),
(423, 170, 39),
(423, 499, 46),
(423, 387, 53),
(425, 27, 1),
(425, 400, 1),
(425, 279, 4),
(425, 233, 8),
(425, 446, 12),
(425, 300, 16),
(425, 551, 20),
(425, 613, 24),
(425, 627, 24),
(425, 652, 24),
(425, 550, 29),
(425, 135, 32),
(425, 42, 36),
(425, 663, 40),
(425, 189, 44),
(426, 27, 1),
(426, 233, 1),
(426, 279, 1),
(426, 400, 1),
(426, 450, 1),
(426, 635, 1),
(426, 446, 12),
(426, 300, 16),
(426, 551, 20),
(426, 613, 24),
(426, 627, 24),
(426, 652, 24),
(426, 550, 31),
(426, 135, 36),
(426, 42, 42),
(426, 663, 48),
(426, 189, 54),
(427, 615, 1),
(427, 133, 4),
(427, 37, 8),
(427, 11, 12),
(427, 494, 16),
(427, 147, 20),
(427, 91, 24),
(427, 42, 28),
(427, 288, 32),
(427, 12, 36),
(427, 185, 40),
(427, 223, 44),
(427, 66, 48),
(427, 293, 52),
(428, 37, 1),
(428, 133, 1),
(428, 372, 1),
(428, 402, 1),
(428, 615, 1),
(428, 11, 12),
(428, 494, 16),
(428, 147, 20),
(428, 91, 24),
(428, 42, 28),
(428, 288, 32),
(428, 12, 36),
(428, 185, 40),
(428, 223, 44),
(428, 66, 48),
(428, 293, 52),
(428, 303, 56),
(434, 459, 1),
(434, 200, 3),
(434, 589, 6),
(434, 6, 9),
(434, 249, 12),
(434, 233, 15),
(434, 52, 18),
(434, 710, 21),
(434, 543, 24),
(434, 690, 27),
(434, 643, 30),
(434, 387, 33),
(434, 427, 36),
(434, 47, 39),
(434, 709, 42),
(434, 189, 45),
(435, 200, 1),
(435, 219, 1),
(435, 459, 1),
(435, 589, 1),
(435, 6, 9),
(435, 249, 12),
(435, 233, 15),
(435, 52, 18),
(435, 710, 21),
(435, 543, 24),
(435, 690, 27),
(435, 643, 30),
(435, 387, 33),
(435, 427, 38),
(435, 47, 43),
(435, 709, 48),
(435, 189, 53),
(436, 106, 1),
(436, 105, 4),
(436, 446, 8),
(436, 327, 12),
(436, 280, 16),
(436, 316, 20),
(436, 534, 24),
(436, 190, 28),
(436, 298, 32),
(436, 334, 36),
(436, 391, 40),
(436, 252, 44),
(437, 56, 1),
(437, 105, 1),
(437, 106, 1),
(437, 446, 1),
(437, 644, 1),
(437, 721, 1),
(437, 327, 12),
(437, 280, 16),
(437, 316, 20),
(437, 534, 24),
(437, 190, 28),
(437, 298, 32),
(437, 334, 38),
(437, 391, 44),
(437, 252, 50),
(437, 499, 56),
(438, 110, 1),
(438, 196, 1),
(438, 215, 4),
(438, 56, 12),
(438, 397, 16),
(438, 524, 20),
(438, 667, 24),
(438, 643, 28),
(438, 522, 32),
(438, 365, 36),
(438, 116, 40),
(438, 150, 44),
(440, 110, 1),
(440, 400, 1),
(440, 133, 4),
(440, 653, 8),
(440, 140, 12),
(440, 118, 16),
(440, 91, 20),
(442, 105, 1),
(442, 426, 1),
(442, 556, 5),
(442, 614, 10),
(442, 446, 15),
(442, 420, 20),
(442, 300, 25),
(442, 387, 30),
(442, 643, 35),
(442, 126, 40),
(442, 551, 45),
(442, 127, 50),
(442, 316, 55),
(442, 163, 60),
(443, 536, 1),
(443, 535, 6),
(443, 153, 12),
(443, 78, 18),
(443, 52, 25),
(443, 579, 30),
(443, 138, 42),
(443, 537, 48),
(443, 664, 54),
(443, 159, 60),
(444, 153, 1),
(444, 166, 1),
(444, 535, 1),
(444, 536, 1),
(444, 78, 18),
(444, 52, 27),
(444, 579, 34),
(444, 138, 50),
(444, 537, 58),
(444, 664, 66),
(444, 159, 74),
(445, 123, 1),
(445, 153, 1),
(445, 166, 1),
(445, 535, 1),
(445, 536, 1),
(445, 78, 18),
(445, 52, 27),
(445, 579, 34),
(445, 138, 52),
(445, 537, 62),
(445, 664, 72),
(445, 159, 82),
(446, 357, 1),
(446, 133, 4),
(446, 505, 8),
(446, 118, 12),
(446, 52, 16),
(446, 627, 20),
(446, 652, 20),
(446, 543, 24),
(446, 59, 28),
(446, 225, 32),
(446, 16, 36),
(446, 395, 40),
(446, 215, 44),
(446, 48, 48),
(446, 347, 52),
(447, 183, 1),
(447, 494, 1),
(447, 200, 4),
(447, 390, 8),
(447, 116, 12),
(447, 732, 16),
(447, 523, 20),
(447, 420, 24),
(447, 543, 28),
(447, 495, 32),
(447, 236, 36),
(447, 657, 40),
(447, 299, 44),
(447, 110, 48),
(447, 205, 52),
(447, 515, 56),
(448, 31, 1),
(448, 110, 1),
(448, 136, 1),
(448, 200, 1),
(448, 205, 1),
(448, 236, 1),
(448, 299, 1),
(448, 358, 1),
(448, 390, 1),
(448, 420, 1),
(448, 494, 1),
(448, 515, 1),
(448, 523, 1),
(448, 543, 1),
(448, 732, 1),
(448, 116, 12),
(448, 345, 16),
(448, 472, 20),
(448, 84, 24),
(448, 391, 28),
(448, 495, 32),
(448, 63, 36),
(448, 657, 40),
(448, 292, 44),
(448, 394, 48),
(448, 192, 56),
(448, 100, 60),
(449, 535, 1),
(449, 52, 4),
(449, 736, 8),
(449, 536, 12),
(449, 138, 16),
(449, 123, 20),
(449, 537, 24),
(449, 664, 28),
(449, 517, 32),
(449, 510, 36),
(449, 171, 40),
(449, 150, 44),
(449, 214, 48),
(449, 578, 52),
(450, 52, 1),
(450, 207, 1),
(450, 320, 1),
(450, 535, 1),
(450, 681, 1),
(450, 736, 1),
(450, 536, 12),
(450, 138, 16),
(450, 123, 20),
(450, 537, 24),
(450, 664, 28),
(450, 517, 32),
(450, 510, 38),
(450, 171, 44),
(450, 150, 50),
(450, 214, 56),
(450, 578, 62),
(451, 355, 1),
(451, 462, 1),
(451, 306, 3),
(451, 202, 6),
(451, 458, 9),
(451, 52, 12),
(451, 691, 15),
(451, 75, 18),
(451, 710, 21),
(451, 344, 24),
(451, 541, 27),
(451, 453, 30),
(451, 690, 33),
(451, 427, 36),
(451, 122, 39),
(451, 8, 45),
(451, 123, 48),
(452, 202, 1),
(452, 207, 1),
(452, 306, 1),
(452, 320, 1),
(452, 355, 1),
(452, 462, 1),
(452, 681, 1),
(452, 458, 9),
(452, 52, 12),
(452, 691, 15),
(452, 75, 18),
(452, 710, 21),
(452, 344, 24),
(452, 541, 27),
(452, 453, 30),
(452, 690, 33),
(452, 427, 36),
(452, 122, 39),
(452, 8, 49),
(452, 123, 54),
(453, 416, 1),
(453, 462, 1),
(453, 27, 4),
(453, 666, 8),
(453, 223, 12),
(453, 514, 16),
(453, 710, 20),
(453, 643, 24),
(453, 651, 28),
(453, 460, 32),
(453, 690, 36),
(453, 420, 40),
(453, 583, 44),
(453, 47, 48),
(454, 27, 1),
(454, 416, 1),
(454, 462, 1),
(454, 666, 1),
(454, 223, 12),
(454, 514, 16),
(454, 710, 20),
(454, 643, 24),
(454, 651, 28),
(454, 460, 32),
(454, 690, 36),
(454, 420, 42),
(454, 583, 48),
(454, 47, 54),
(458, 648, 4),
(458, 716, 12),
(458, 725, 16),
(458, 12, 20),
(458, 74, 24),
(458, 288, 28),
(458, 14, 32),
(458, 21, 36),
(458, 66, 40),
(458, 664, 44),
(459, 355, 1),
(459, 467, 1),
(459, 352, 5),
(459, 405, 10),
(459, 323, 15),
(459, 501, 20),
(459, 326, 25),
(459, 651, 30),
(459, 331, 35),
(459, 731, 41),
(459, 55, 45),
(459, 558, 50),
(460, 34, 1),
(460, 322, 1),
(460, 352, 1),
(460, 355, 1),
(460, 405, 1),
(460, 467, 1),
(460, 323, 15),
(460, 501, 20),
(460, 326, 25),
(460, 651, 30),
(460, 331, 35),
(460, 731, 43),
(460, 55, 49),
(460, 558, 56),
(461, 12, 1),
(461, 26, 1),
(461, 44, 1),
(461, 323, 1),
(461, 355, 1),
(461, 494, 1),
(461, 514, 1),
(461, 579, 1),
(461, 666, 1),
(461, 390, 18),
(461, 326, 24),
(461, 249, 30),
(461, 306, 36),
(461, 225, 42),
(461, 420, 48),
(461, 543, 54),
(461, 427, 60),
(461, 127, 66),
(462, 175, 1),
(462, 379, 1),
(462, 402, 1),
(462, 648, 1),
(462, 683, 1),
(462, 684, 1),
(462, 694, 1),
(462, 177, 12),
(462, 280, 16),
(462, 602, 20),
(462, 543, 24),
(462, 378, 28),
(462, 222, 34),
(462, 141, 40),
(462, 391, 46),
(462, 360, 52),
(462, 363, 58),
(462, 737, 64),
(463, 133, 1),
(463, 357, 1),
(463, 528, 1),
(463, 648, 1),
(463, 734, 18),
(463, 139, 24),
(463, 629, 30),
(463, 344, 36),
(463, 543, 42),
(463, 48, 60),
(464, 78, 1),
(464, 282, 1),
(464, 585, 1),
(464, 662, 1),
(464, 541, 20),
(464, 629, 25),
(464, 519, 30),
(464, 164, 35),
(464, 664, 40),
(464, 171, 47),
(464, 631, 54),
(464, 307, 68),
(464, 525, 75),
(465, 2, 1),
(465, 51, 1),
(465, 56, 1),
(465, 272, 1),
(465, 640, 1),
(465, 386, 12),
(465, 461, 20),
(465, 18, 24),
(465, 344, 28),
(465, 258, 32),
(465, 580, 36),
(465, 687, 44),
(465, 331, 52),
(465, 268, 56),
(466, 89, 1),
(466, 355, 1),
(466, 494, 1),
(466, 683, 1),
(466, 655, 12),
(466, 563, 16),
(466, 684, 20),
(466, 543, 24),
(466, 682, 28),
(466, 141, 34),
(466, 365, 40),
(466, 685, 46),
(466, 360, 52),
(466, 679, 58),
(466, 259, 64),
(467, 180, 1),
(467, 355, 1),
(467, 588, 1),
(467, 589, 1),
(467, 99, 12),
(467, 218, 16),
(467, 105, 20),
(467, 541, 24),
(467, 210, 28),
(467, 348, 34),
(467, 365, 40),
(467, 219, 46),
(467, 644, 52),
(467, 206, 58),
(467, 312, 64),
(468, 11, 1),
(468, 14, 1),
(468, 18, 1),
(468, 31, 1),
(468, 42, 1),
(468, 91, 1),
(468, 150, 1),
(468, 192, 1),
(468, 235, 1),
(468, 271, 1),
(468, 347, 1),
(468, 358, 1),
(468, 395, 1),
(468, 534, 1),
(468, 575, 1),
(468, 653, 1),
(468, 694, 1),
(468, 728, 1),
(468, 736, 1),
(470, 42, 1),
(470, 52, 1),
(470, 91, 1),
(470, 110, 1),
(470, 118, 1),
(470, 150, 1),
(470, 271, 1),
(470, 299, 1),
(470, 501, 1),
(470, 655, 1),
(470, 662, 1),
(470, 664, 1),
(470, 535, 5),
(470, 494, 10),
(470, 37, 15),
(470, 354, 20),
(470, 375, 25),
(470, 659, 30),
(470, 644, 35),
(470, 258, 40),
(470, 657, 45),
(470, 349, 50),
(470, 347, 55),
(471, 42, 1),
(471, 91, 1),
(471, 110, 1),
(471, 118, 1),
(471, 150, 1),
(471, 271, 1),
(471, 299, 1),
(471, 326, 1),
(471, 655, 1),
(471, 662, 1),
(471, 664, 1),
(471, 535, 5),
(471, 494, 10),
(471, 37, 15),
(471, 323, 20),
(471, 52, 25),
(471, 320, 30),
(471, 281, 35),
(471, 241, 40),
(471, 402, 45),
(471, 55, 50),
(471, 347, 55),
(473, 18, 1),
(473, 145, 1),
(473, 215, 1),
(473, 320, 1),
(473, 416, 1),
(473, 467, 1),
(473, 323, 15),
(473, 405, 20),
(473, 183, 25),
(473, 326, 30),
(473, 16, 37),
(473, 664, 44),
(473, 171, 51),
(473, 55, 58),
(473, 677, 65),
(475, 84, 1),
(475, 91, 1),
(475, 106, 1),
(475, 140, 1),
(475, 149, 1),
(475, 162, 1),
(475, 163, 1),
(475, 248, 1),
(475, 252, 1),
(475, 271, 1),
(475, 316, 1),
(475, 327, 1),
(475, 355, 1),
(475, 358, 1),
(475, 427, 1),
(475, 477, 1),
(475, 479, 1),
(475, 579, 1),
(475, 299, 9),
(475, 200, 12),
(475, 672, 15),
(475, 9, 18),
(475, 198, 23),
(475, 476, 28),
(475, 657, 35),
(475, 483, 42),
(475, 292, 49),
(475, 495, 56),
(475, 725, 56),
(475, 100, 63),
(477, 27, 1),
(477, 51, 1),
(477, 139, 1),
(477, 210, 1),
(477, 270, 1),
(477, 322, 1),
(477, 355, 1),
(477, 555, 1),
(477, 556, 1),
(477, 682, 1),
(477, 105, 12),
(477, 426, 16),
(477, 446, 20),
(477, 727, 24),
(477, 384, 28),
(477, 300, 32),
(477, 126, 36),
(477, 551, 42),
(477, 252, 48),
(477, 135, 54),
(478, 27, 1),
(478, 52, 1),
(478, 123, 1),
(478, 135, 1),
(478, 149, 1),
(478, 288, 1),
(478, 300, 1),
(478, 320, 1),
(478, 355, 1),
(478, 467, 1),
(478, 476, 1),
(478, 323, 15),
(478, 162, 20),
(478, 326, 25),
(478, 245, 30),
(478, 105, 35),
(478, 281, 40),
(478, 727, 47),
(478, 34, 54),
(478, 551, 61),
(478, 55, 68),
(479, 27, 1),
(479, 149, 1),
(479, 683, 5),
(479, 105, 10),
(479, 89, 15),
(479, 177, 20),
(479, 684, 25),
(479, 563, 30),
(479, 300, 35),
(479, 642, 40),
(479, 695, 45),
(479, 141, 50),
(479, 705, 55),
(480, 106, 1),
(480, 510, 1),
(480, 655, 7),
(480, 183, 14),
(480, 477, 21),
(480, 327, 28),
(480, 190, 35),
(480, 16, 42),
(480, 479, 49),
(480, 736, 56),
(480, 252, 63),
(480, 215, 70),
(480, 387, 77),
(481, 106, 1),
(481, 510, 1),
(481, 655, 7),
(481, 476, 14),
(481, 477, 21),
(481, 327, 28),
(481, 190, 35),
(481, 91, 42),
(481, 479, 49),
(481, 223, 56),
(481, 252, 63),
(481, 110, 70),
(481, 293, 77),
(482, 106, 1),
(482, 510, 1),
(482, 655, 7),
(482, 136, 14),
(482, 477, 21),
(482, 327, 28),
(482, 190, 35),
(482, 420, 42),
(482, 479, 49),
(482, 705, 56),
(482, 252, 63),
(482, 347, 70),
(482, 189, 77),
(483, 390, 1),
(483, 541, 1),
(483, 153, 8),
(483, 18, 16),
(483, 579, 24),
(483, 222, 32),
(483, 31, 48),
(483, 389, 64),
(483, 170, 72),
(483, 336, 80),
(483, 518, 88),
(484, 541, 1),
(484, 716, 1),
(484, 153, 8),
(484, 18, 16),
(484, 579, 24),
(484, 21, 32),
(484, 31, 48),
(484, 170, 72),
(484, 601, 80),
(485, 211, 1),
(485, 355, 1),
(485, 390, 6),
(485, 18, 12),
(485, 207, 18),
(485, 541, 24),
(485, 335, 30),
(485, 123, 36),
(485, 348, 42),
(485, 391, 48),
(485, 170, 54),
(485, 297, 60),
(485, 631, 66),
(485, 376, 72),
(486, 105, 1),
(486, 446, 6),
(486, 514, 12),
(486, 629, 18),
(486, 476, 24),
(486, 344, 30),
(486, 58, 42),
(486, 725, 48),
(486, 738, 54),
(486, 298, 60),
(486, 282, 66),
(486, 259, 72),
(486, 125, 78),
(488, 106, 1),
(488, 149, 1),
(488, 405, 6),
(488, 33, 12),
(488, 477, 18),
(488, 484, 24),
(488, 579, 30),
(488, 483, 36),
(488, 411, 42),
(488, 534, 48),
(488, 479, 54),
(488, 409, 60),
(488, 252, 66),
(488, 368, 72),
(494, 106, 1),
(494, 217, 1),
(494, 233, 1),
(494, 494, 1),
(494, 706, 1),
(494, 732, 7),
(494, 328, 14),
(494, 632, 21),
(494, 288, 28),
(494, 183, 35),
(494, 738, 42),
(494, 329, 49),
(494, 515, 56),
(494, 544, 63),
(494, 150, 70),
(494, 220, 77),
(494, 441, 84),
(494, 205, 91),
(506, 355, 1),
(506, 732, 4),
(506, 52, 8),
(506, 511, 12),
(506, 37, 17),
(506, 456, 20),
(506, 123, 24),
(506, 664, 28),
(506, 299, 32),
(506, 515, 36),
(506, 517, 40),
(506, 347, 44),
(506, 259, 48),
(507, 52, 1),
(507, 355, 1),
(507, 732, 1),
(507, 511, 12),
(507, 37, 19),
(507, 456, 24),
(507, 123, 30),
(507, 664, 36),
(507, 299, 42),
(507, 515, 48),
(507, 517, 54),
(507, 347, 60),
(507, 259, 66),
(508, 52, 1),
(508, 207, 1),
(508, 320, 1),
(508, 355, 1),
(508, 681, 1),
(508, 732, 1),
(508, 511, 12),
(508, 37, 19),
(508, 456, 24),
(508, 123, 30),
(508, 664, 38),
(508, 299, 46),
(508, 515, 54),
(508, 517, 62),
(508, 347, 70),
(508, 259, 78),
(509, 271, 1),
(509, 535, 4),
(509, 195, 5),
(509, 249, 12),
(509, 689, 16),
(509, 26, 21),
(509, 306, 24),
(509, 643, 28),
(509, 420, 32),
(509, 427, 36),
(509, 456, 40),
(510, 195, 1),
(510, 271, 1),
(510, 535, 1),
(510, 249, 12),
(510, 689, 16),
(510, 26, 23),
(510, 306, 28),
(510, 643, 34),
(510, 420, 40),
(510, 427, 46),
(510, 456, 52),
(517, 133, 1),
(517, 632, 1),
(517, 316, 4),
(517, 477, 8),
(517, 327, 12),
(517, 411, 16),
(517, 372, 20),
(517, 738, 24),
(517, 84, 28),
(517, 736, 32),
(517, 479, 36),
(517, 409, 40),
(517, 163, 44),
(517, 252, 48),
(517, 730, 52),
(518, 84, 1),
(518, 133, 1),
(518, 163, 1),
(518, 252, 1),
(518, 316, 1),
(518, 327, 1),
(518, 372, 1),
(518, 409, 1),
(518, 411, 1),
(518, 477, 1),
(518, 479, 1),
(518, 481, 1),
(518, 632, 1),
(518, 730, 1),
(518, 736, 1),
(518, 738, 1),
(519, 271, 1),
(519, 279, 1),
(519, 355, 4),
(519, 494, 8),
(519, 666, 12),
(519, 13, 16),
(519, 651, 20),
(519, 199, 24),
(519, 136, 28),
(519, 14, 32),
(519, 529, 36),
(519, 663, 40),
(519, 575, 44),
(520, 271, 1),
(520, 279, 1),
(520, 355, 1),
(520, 494, 1),
(520, 666, 12),
(520, 13, 16),
(520, 651, 20),
(520, 199, 26),
(520, 136, 34),
(520, 14, 38),
(520, 529, 44),
(520, 663, 50),
(520, 575, 56),
(521, 271, 1),
(521, 279, 1),
(521, 355, 1),
(521, 494, 1),
(521, 666, 12),
(521, 13, 16),
(521, 651, 20),
(521, 199, 26),
(521, 136, 36),
(521, 14, 42),
(521, 529, 50),
(521, 663, 58),
(521, 575, 66),
(524, 535, 1),
(524, 284, 4),
(524, 620, 8),
(524, 416, 12),
(524, 585, 16),
(524, 334, 20),
(524, 288, 24),
(524, 522, 28),
(524, 519, 32),
(524, 537, 36),
(524, 631, 40),
(524, 189, 44),
(525, 284, 1),
(525, 535, 1),
(525, 620, 1),
(525, 416, 12),
(525, 585, 16),
(525, 334, 20),
(525, 288, 24),
(525, 522, 30),
(525, 519, 36),
(525, 537, 42),
(525, 631, 48),
(525, 189, 54),
(526, 284, 1),
(526, 535, 1),
(526, 620, 1),
(526, 416, 12),
(526, 585, 16),
(526, 334, 20),
(526, 288, 24),
(526, 522, 30),
(526, 519, 36),
(526, 537, 42),
(526, 631, 48),
(526, 189, 54),
(527, 30, 1),
(527, 279, 1),
(527, 106, 5),
(527, 182, 10),
(527, 13, 15),
(527, 327, 20),
(527, 26, 25),
(527, 16, 30),
(527, 14, 35),
(527, 479, 40),
(527, 84, 45),
(527, 252, 50),
(527, 567, 55),
(528, 30, 1),
(528, 106, 1),
(528, 182, 1),
(528, 279, 1),
(528, 13, 15),
(528, 327, 20),
(528, 26, 25),
(528, 16, 30),
(528, 14, 35),
(528, 479, 40),
(528, 84, 45),
(528, 252, 50),
(528, 567, 55),
(529, 416, 1),
(529, 500, 1),
(529, 306, 8),
(529, 249, 12),
(529, 390, 16),
(529, 537, 20),
(529, 124, 24),
(529, 522, 28),
(529, 138, 32),
(529, 657, 36),
(529, 164, 40),
(529, 171, 44),
(529, 214, 48),
(530, 306, 1),
(530, 307, 1),
(530, 416, 1),
(530, 500, 1),
(530, 249, 12),
(530, 390, 16),
(530, 537, 20),
(530, 124, 24),
(530, 522, 28),
(530, 138, 34),
(530, 657, 40),
(530, 164, 46),
(530, 171, 52),
(530, 214, 58),
(531, 455, 1),
(531, 140, 4),
(531, 37, 9),
(531, 299, 12),
(531, 271, 16),
(531, 738, 20),
(531, 358, 24),
(531, 11, 28),
(531, 664, 32),
(531, 567, 36),
(531, 292, 44),
(531, 150, 48),
(531, 185, 52),
(531, 408, 56),
(531, 347, 60),
(532, 355, 1),
(532, 365, 4),
(532, 233, 12),
(532, 77, 16),
(532, 522, 20),
(532, 541, 28),
(532, 169, 32),
(532, 282, 36),
(532, 631, 40),
(532, 647, 44),
(532, 234, 48),
(533, 355, 1),
(533, 365, 1),
(533, 233, 12),
(533, 77, 16),
(533, 522, 20),
(533, 541, 30),
(533, 169, 36),
(533, 282, 42),
(533, 631, 48),
(533, 647, 54),
(533, 234, 60),
(534, 355, 1),
(534, 365, 1),
(534, 233, 12),
(534, 77, 16),
(534, 522, 20),
(534, 541, 30),
(534, 169, 36),
(534, 282, 42),
(534, 631, 48),
(534, 647, 54),
(534, 234, 60),
(535, 172, 1),
(535, 271, 1),
(535, 4, 4),
(535, 648, 8),
(535, 414, 12),
(535, 531, 16),
(535, 74, 20),
(535, 215, 24),
(535, 705, 28),
(535, 21, 32),
(535, 417, 40),
(535, 499, 44),
(536, 4, 1),
(536, 172, 1),
(536, 271, 1),
(536, 648, 1),
(536, 414, 12),
(536, 531, 16),
(536, 74, 20),
(536, 215, 24),
(536, 705, 30),
(536, 21, 37),
(536, 417, 48),
(536, 499, 54),
(537, 4, 1),
(537, 161, 1),
(537, 172, 1),
(537, 253, 1),
(537, 271, 1),
(537, 648, 1),
(537, 414, 12),
(537, 531, 16),
(537, 74, 20),
(537, 215, 24),
(537, 705, 30),
(537, 21, 39),
(537, 417, 54),
(537, 499, 62),
(538, 51, 1),
(538, 355, 1),
(538, 233, 5),
(538, 94, 10),
(538, 725, 15),
(538, 514, 20),
(538, 77, 25),
(538, 633, 30),
(538, 711, 35),
(538, 549, 40),
(538, 183, 45),
(538, 515, 50),
(538, 647, 55),
(539, 355, 1),
(539, 523, 1),
(539, 233, 5),
(539, 147, 10),
(539, 495, 15),
(539, 366, 20),
(539, 77, 25),
(539, 511, 30),
(539, 70, 35),
(539, 116, 40),
(539, 183, 45),
(539, 515, 50),
(539, 100, 55),
(543, 133, 1),
(543, 462, 1),
(543, 528, 4),
(543, 476, 8),
(543, 463, 12),
(543, 543, 16),
(543, 75, 20),
(543, 710, 24),
(543, 664, 28),
(543, 12, 32),
(543, 690, 36),
(543, 709, 40),
(543, 150, 44),
(544, 133, 1),
(544, 334, 1),
(544, 462, 1),
(544, 476, 1),
(544, 528, 1),
(544, 463, 12),
(544, 543, 16),
(544, 75, 20),
(544, 710, 26),
(544, 664, 32),
(544, 12, 38),
(544, 690, 44),
(544, 709, 50),
(544, 150, 56),
(545, 42, 1),
(545, 133, 1),
(545, 334, 1),
(545, 462, 1),
(545, 476, 1),
(545, 528, 1),
(545, 463, 12),
(545, 543, 16),
(545, 75, 20),
(545, 710, 26),
(545, 664, 34),
(545, 12, 42),
(545, 690, 50),
(545, 709, 58),
(545, 150, 66),
(546, 2, 1),
(546, 299, 1),
(546, 640, 6),
(546, 386, 12),
(546, 501, 15),
(546, 272, 18),
(546, 461, 21),
(546, 258, 24),
(546, 91, 27),
(546, 354, 30),
(546, 115, 33),
(546, 184, 36),
(546, 644, 39),
(546, 182, 42),
(546, 114, 45),
(546, 597, 48),
(547, 2, 1),
(547, 91, 1),
(547, 114, 1),
(547, 115, 1),
(547, 182, 1),
(547, 184, 1),
(547, 258, 1),
(547, 272, 1),
(547, 279, 1),
(547, 299, 1),
(547, 310, 1),
(547, 354, 1),
(547, 386, 1),
(547, 387, 1),
(547, 409, 1),
(547, 461, 1),
(547, 501, 1),
(547, 597, 1),
(547, 640, 1),
(547, 644, 1),
(547, 663, 1),
(548, 2, 1),
(548, 272, 1),
(548, 299, 3),
(548, 640, 6),
(548, 386, 9),
(548, 23, 12),
(548, 375, 15),
(548, 580, 18),
(548, 258, 21),
(548, 354, 24),
(548, 11, 27),
(548, 184, 30),
(548, 659, 33),
(548, 644, 36),
(548, 185, 39),
(548, 350, 42),
(549, 2, 1),
(549, 11, 1),
(549, 23, 1),
(549, 184, 1),
(549, 185, 1),
(549, 258, 1),
(549, 272, 1),
(549, 299, 1),
(549, 350, 1),
(549, 354, 1),
(549, 375, 1),
(549, 386, 1),
(549, 448, 1),
(549, 449, 1),
(549, 496, 1),
(549, 580, 1),
(549, 640, 1),
(549, 644, 1),
(549, 659, 1),
(549, 670, 1),
(551, 355, 1),
(551, 471, 1),
(551, 535, 3),
(551, 306, 6),
(551, 536, 9),
(551, 541, 12),
(551, 52, 15),
(551, 689, 18),
(551, 138, 21),
(551, 651, 24),
(551, 123, 27),
(551, 537, 30),
(551, 239, 33),
(551, 171, 36),
(551, 677, 39),
(552, 306, 1),
(552, 355, 1),
(552, 471, 1),
(552, 535, 1),
(552, 536, 9),
(552, 541, 12),
(552, 52, 15),
(552, 689, 18),
(552, 138, 21),
(552, 651, 24),
(552, 123, 27),
(552, 537, 32),
(552, 239, 35),
(552, 171, 42),
(552, 677, 47),
(553, 306, 1),
(553, 355, 1),
(553, 471, 1),
(553, 535, 1),
(553, 536, 9),
(553, 541, 12),
(553, 52, 15),
(553, 689, 18),
(553, 138, 21),
(553, 651, 24),
(553, 123, 27),
(553, 537, 32),
(553, 239, 35),
(553, 171, 44),
(553, 677, 51),
(553, 440, 58),
(556, 2, 1),
(556, 11, 1),
(556, 331, 1),
(556, 610, 1),
(556, 272, 4),
(556, 386, 8),
(556, 354, 12),
(556, 643, 16),
(556, 453, 20),
(556, 258, 24),
(556, 654, 28),
(556, 659, 32),
(556, 448, 36),
(556, 115, 40),
(556, 644, 44),
(556, 597, 48),
(556, 8, 52),
(556, 449, 56),
(556, 114, 60),
(557, 248, 1),
(557, 535, 1),
(557, 729, 4),
(557, 585, 8),
(557, 75, 12),
(557, 215, 16),
(557, 579, 20),
(557, 522, 24),
(557, 620, 28),
(557, 519, 32),
(557, 521, 40),
(557, 560, 44),
(557, 525, 48),
(558, 248, 1),
(558, 535, 1),
(558, 585, 1),
(558, 729, 1),
(558, 75, 12),
(558, 215, 16),
(558, 579, 20),
(558, 522, 24),
(558, 620, 28),
(558, 519, 32),
(558, 521, 44),
(558, 560, 50),
(558, 525, 56),
(559, 355, 1),
(559, 365, 1),
(559, 446, 4),
(559, 288, 8),
(559, 535, 12),
(559, 193, 16),
(559, 476, 20),
(559, 44, 24),
(559, 541, 28),
(559, 70, 32),
(559, 651, 36),
(559, 123, 40),
(559, 303, 44),
(559, 234, 48),
(559, 287, 52),
(560, 288, 1),
(560, 355, 1),
(560, 365, 1),
(560, 446, 1),
(560, 535, 12),
(560, 193, 16),
(560, 476, 20),
(560, 44, 24),
(560, 541, 28),
(560, 70, 32),
(560, 651, 36),
(560, 123, 42),
(560, 303, 48),
(560, 234, 54),
(560, 287, 60),
(561, 106, 1),
(561, 279, 1),
(561, 270, 5),
(561, 316, 10),
(561, 13, 15),
(561, 477, 20),
(561, 723, 25),
(561, 113, 30),
(561, 14, 35),
(561, 479, 40),
(561, 663, 45),
(561, 360, 50),
(561, 506, 50),
(561, 575, 55),
(561, 572, 60),
(563, 27, 1),
(563, 285, 1),
(563, 426, 1),
(563, 476, 1),
(563, 541, 1),
(563, 553, 1),
(563, 139, 12),
(563, 727, 16),
(563, 120, 20),
(563, 300, 24),
(563, 384, 28),
(563, 273, 32),
(563, 126, 38),
(563, 551, 44),
(563, 127, 50),
(563, 274, 56),
(563, 468, 56),
(563, 135, 62),
(564, 729, 1),
(564, 476, 3),
(564, 20, 6),
(564, 585, 9),
(564, 18, 12),
(564, 52, 15),
(564, 725, 18),
(564, 71, 21),
(564, 522, 24),
(564, 123, 27),
(564, 126, 30),
(564, 334, 33),
(564, 499, 39),
(564, 560, 45),
(565, 20, 1),
(565, 476, 1),
(565, 729, 1),
(565, 585, 9),
(565, 18, 12),
(565, 52, 15),
(565, 725, 18),
(565, 71, 21),
(565, 522, 24),
(565, 123, 27),
(565, 126, 30),
(565, 334, 33),
(565, 499, 41),
(565, 560, 51),
(566, 355, 1),
(566, 494, 1),
(566, 153, 9),
(566, 18, 12),
(566, 457, 15),
(566, 495, 18),
(566, 704, 21),
(566, 522, 24),
(566, 541, 27),
(566, 123, 30),
(566, 12, 33),
(566, 663, 36),
(566, 677, 42),
(566, 182, 45),
(567, 355, 1),
(567, 494, 1),
(567, 153, 9),
(567, 18, 12),
(567, 457, 15),
(567, 495, 18),
(567, 704, 21),
(567, 522, 24),
(567, 541, 27),
(567, 123, 30),
(567, 12, 33),
(567, 663, 36),
(567, 677, 46),
(567, 182, 51),
(568, 459, 1),
(568, 505, 3),
(568, 6, 6),
(568, 16, 9),
(568, 99, 12),
(568, 691, 15),
(568, 582, 18),
(568, 627, 21),
(568, 652, 21),
(568, 664, 24),
(568, 583, 27),
(568, 690, 30),
(568, 47, 33),
(568, 442, 37),
(568, 278, 39),
(568, 189, 42),
(569, 6, 1),
(569, 390, 1),
(569, 459, 1),
(569, 505, 1),
(569, 664, 1),
(569, 16, 9),
(569, 99, 12),
(569, 691, 15),
(569, 582, 18),
(569, 627, 21),
(569, 652, 21),
(569, 59, 24),
(569, 583, 27),
(569, 690, 30),
(569, 47, 33),
(569, 442, 39),
(569, 278, 43),
(569, 189, 48),
(570, 355, 1),
(570, 689, 4),
(570, 306, 8),
(570, 249, 12),
(570, 541, 16),
(570, 666, 20),
(570, 344, 24),
(570, 196, 28),
(570, 12, 32),
(570, 327, 36),
(570, 425, 40),
(570, 420, 44),
(570, 239, 48),
(571, 306, 1),
(571, 355, 1),
(571, 427, 1),
(571, 689, 1),
(571, 704, 1),
(571, 249, 12),
(571, 541, 16),
(571, 666, 20),
(571, 344, 24),
(571, 196, 28),
(571, 12, 34),
(571, 327, 40),
(571, 425, 46),
(571, 420, 52),
(571, 239, 58),
(572, 37, 1),
(572, 299, 4),
(572, 172, 8),
(572, 568, 12),
(572, 91, 16),
(572, 655, 20),
(572, 181, 24),
(572, 11, 28),
(572, 661, 32),
(572, 687, 36),
(572, 347, 48),
(573, 11, 1),
(573, 37, 1),
(573, 80, 1),
(573, 91, 1),
(573, 172, 1),
(573, 181, 1),
(573, 299, 1),
(573, 347, 1),
(573, 519, 1),
(573, 568, 1),
(573, 655, 1),
(573, 661, 1),
(573, 687, 1),
(574, 106, 1),
(574, 455, 4),
(574, 687, 8),
(574, 477, 12),
(574, 91, 16),
(574, 485, 20),
(574, 316, 24),
(574, 196, 28),
(574, 478, 33),
(574, 479, 36),
(574, 223, 40),
(574, 252, 44),
(574, 374, 48),
(575, 106, 1),
(575, 455, 1),
(575, 687, 1),
(575, 477, 12),
(575, 91, 16),
(575, 485, 20),
(575, 316, 24),
(575, 196, 28),
(575, 478, 35),
(575, 479, 40),
(575, 223, 46),
(575, 252, 52),
(575, 374, 58),
(576, 106, 1),
(576, 455, 1),
(576, 687, 1),
(576, 477, 12),
(576, 91, 16),
(576, 485, 20),
(576, 316, 24),
(576, 196, 28),
(576, 478, 35),
(576, 479, 40),
(576, 223, 48),
(576, 252, 56),
(576, 374, 64),
(577, 106, 1),
(577, 476, 1),
(577, 504, 4),
(577, 182, 8),
(577, 477, 12),
(577, 91, 16),
(577, 485, 20),
(577, 360, 24),
(577, 506, 24),
(577, 15, 28),
(577, 442, 33),
(577, 479, 36),
(577, 572, 40),
(577, 252, 44),
(577, 730, 48),
(578, 106, 1),
(578, 182, 1),
(578, 476, 1),
(578, 504, 1),
(578, 477, 12),
(578, 91, 16),
(578, 485, 20),
(578, 360, 24),
(578, 506, 24),
(578, 15, 28),
(578, 442, 35),
(578, 479, 40),
(578, 572, 46),
(578, 252, 52),
(578, 730, 58),
(579, 106, 1),
(579, 182, 1),
(579, 282, 1),
(579, 476, 1),
(579, 504, 1),
(579, 477, 12),
(579, 91, 16),
(579, 485, 20),
(579, 360, 24),
(579, 506, 24),
(579, 15, 28),
(579, 442, 35),
(579, 479, 40),
(579, 572, 48),
(579, 252, 56),
(579, 730, 64),
(582, 27, 1),
(582, 284, 1),
(582, 666, 4),
(582, 405, 8),
(582, 326, 12),
(582, 36, 16),
(582, 281, 20),
(582, 325, 24),
(582, 705, 28),
(582, 5, 32),
(582, 402, 36),
(582, 318, 40),
(582, 55, 44),
(582, 558, 48),
(583, 27, 1),
(583, 284, 1),
(583, 405, 1),
(583, 666, 1),
(583, 326, 12),
(583, 36, 16),
(583, 281, 20),
(583, 325, 24),
(583, 705, 28),
(583, 5, 32),
(583, 402, 38),
(583, 318, 44),
(583, 55, 50),
(583, 558, 56),
(584, 27, 1),
(584, 241, 1),
(584, 284, 1),
(584, 324, 1),
(584, 405, 1),
(584, 666, 1),
(584, 721, 1),
(584, 326, 12),
(584, 36, 16),
(584, 281, 20),
(584, 325, 24),
(584, 705, 28),
(584, 5, 32),
(584, 402, 38),
(584, 318, 44),
(584, 55, 52),
(584, 558, 60),
(587, 431, 1),
(587, 662, 1),
(587, 149, 5),
(587, 494, 10),
(587, 683, 15),
(587, 89, 20),
(587, 7, 25),
(587, 602, 30),
(587, 181, 35),
(587, 712, 40),
(587, 360, 45),
(587, 141, 50),
(587, 12, 55),
(588, 355, 1),
(588, 248, 4),
(588, 183, 8),
(588, 198, 12),
(588, 6, 16),
(588, 288, 20),
(588, 215, 24),
(588, 541, 28),
(588, 657, 36),
(588, 664, 40),
(588, 76, 44),
(588, 150, 48),
(589, 150, 1),
(589, 183, 1),
(589, 202, 1),
(589, 215, 1),
(589, 248, 1),
(589, 355, 1),
(589, 495, 1),
(589, 541, 1),
(589, 664, 1),
(589, 198, 12),
(589, 6, 16),
(589, 288, 20),
(589, 515, 24),
(589, 334, 28),
(589, 657, 36),
(589, 335, 40),
(589, 76, 44),
(589, 259, 48),
(589, 389, 52),
(590, 2, 1),
(590, 27, 1),
(590, 272, 4),
(590, 640, 8),
(590, 386, 12),
(590, 659, 16),
(590, 99, 20),
(590, 654, 24),
(590, 258, 28),
(590, 331, 32),
(590, 690, 36),
(590, 498, 40),
(590, 597, 44),
(590, 618, 48),
(591, 2, 1),
(591, 27, 1),
(591, 272, 1),
(591, 640, 1),
(591, 386, 12),
(591, 659, 16),
(591, 99, 20),
(591, 654, 24),
(591, 258, 28),
(591, 331, 32),
(591, 690, 36),
(591, 498, 42),
(591, 597, 48),
(591, 618, 54),
(592, 2, 1),
(592, 462, 4),
(592, 426, 8),
(592, 716, 12),
(592, 499, 16),
(592, 300, 20),
(592, 71, 24),
(592, 504, 28),
(592, 551, 32),
(592, 722, 36),
(592, 135, 44),
(592, 719, 48),
(593, 2, 1),
(593, 5, 1),
(593, 426, 1),
(593, 462, 1),
(593, 716, 12),
(593, 499, 16),
(593, 300, 20),
(593, 71, 24),
(593, 504, 28),
(593, 551, 32),
(593, 722, 36),
(593, 135, 48),
(593, 719, 54),
(595, 2, 1),
(595, 248, 1),
(595, 178, 4),
(595, 75, 8),
(595, 636, 12),
(595, 684, 16),
(595, 177, 20),
(595, 12, 24),
(595, 643, 28),
(595, 579, 32),
(595, 141, 37),
(595, 543, 40),
(595, 253, 44),
(595, 76, 48),
(596, 2, 1),
(596, 75, 1),
(596, 178, 1),
(596, 248, 1),
(596, 626, 1),
(596, 636, 12),
(596, 684, 16),
(596, 177, 20),
(596, 12, 24),
(596, 643, 28),
(596, 579, 32),
(596, 141, 39),
(596, 543, 44),
(596, 253, 50),
(596, 76, 56),
(597, 284, 1),
(597, 390, 5),
(597, 453, 10),
(597, 331, 15),
(597, 222, 20),
(597, 335, 25),
(597, 550, 30),
(597, 334, 35),
(597, 126, 41),
(597, 280, 45),
(597, 189, 50),
(598, 284, 1),
(598, 390, 1),
(598, 453, 1),
(598, 331, 15),
(598, 222, 20),
(598, 335, 25),
(598, 550, 30),
(598, 334, 35),
(598, 126, 43),
(598, 280, 49),
(598, 189, 56),
(599, 683, 1),
(599, 51, 4),
(599, 89, 8),
(599, 90, 12),
(599, 391, 16),
(599, 35, 20),
(599, 141, 24),
(599, 543, 28),
(599, 254, 32),
(599, 363, 36),
(599, 562, 40),
(599, 737, 44),
(599, 312, 48),
(600, 51, 1),
(600, 89, 1),
(600, 683, 1),
(600, 90, 12),
(600, 391, 16),
(600, 35, 20),
(600, 141, 24),
(600, 543, 28),
(600, 254, 32),
(600, 363, 36),
(600, 562, 42),
(600, 737, 48),
(600, 312, 54),
(601, 51, 1),
(601, 89, 1),
(601, 255, 1),
(601, 379, 1),
(601, 683, 1),
(601, 90, 12),
(601, 391, 16),
(601, 35, 20),
(601, 141, 24),
(601, 543, 28),
(601, 254, 32),
(601, 363, 36),
(601, 562, 42),
(601, 737, 48),
(601, 312, 56),
(601, 175, 64),
(605, 106, 1),
(605, 271, 1),
(605, 327, 6),
(605, 672, 12),
(605, 477, 18),
(605, 274, 24),
(605, 468, 24),
(605, 288, 30),
(605, 738, 36),
(605, 504, 43),
(605, 84, 48),
(605, 730, 54),
(605, 479, 60),
(606, 106, 1),
(606, 271, 1),
(606, 327, 1),
(606, 481, 1),
(606, 672, 1),
(606, 477, 18),
(606, 274, 24),
(606, 468, 24),
(606, 288, 30),
(606, 738, 36),
(606, 504, 45),
(606, 84, 52),
(606, 730, 60),
(606, 479, 68),
(607, 27, 1),
(607, 588, 1),
(607, 180, 4),
(607, 400, 8),
(607, 105, 12),
(607, 300, 16),
(607, 727, 20),
(607, 211, 24),
(607, 426, 28),
(607, 126, 32),
(607, 551, 36),
(607, 329, 40),
(607, 327, 44),
(607, 442, 48),
(607, 441, 52),
(607, 387, 56),
(608, 27, 1),
(608, 180, 1),
(608, 400, 1),
(608, 588, 1),
(608, 105, 12),
(608, 300, 16),
(608, 727, 20),
(608, 211, 24),
(608, 426, 28),
(608, 126, 32),
(608, 551, 36),
(608, 329, 40),
(608, 327, 46),
(608, 442, 52),
(608, 441, 58),
(608, 387, 64),
(609, 27, 1),
(609, 105, 1),
(609, 126, 1),
(609, 180, 1),
(609, 211, 1),
(609, 300, 1),
(609, 327, 1),
(609, 329, 1),
(609, 387, 1),
(609, 400, 1),
(609, 426, 1),
(609, 441, 1),
(609, 442, 1),
(609, 551, 1),
(609, 588, 1),
(609, 727, 1),
(610, 355, 1),
(610, 52, 3),
(610, 198, 6),
(610, 26, 9),
(610, 666, 12),
(610, 579, 15),
(610, 541, 21),
(610, 123, 24),
(610, 154, 27),
(610, 166, 30),
(610, 345, 33),
(610, 657, 39),
(610, 440, 42),
(610, 277, 45),
(610, 259, 48),
(611, 52, 1),
(611, 198, 1),
(611, 355, 1),
(611, 26, 9),
(611, 666, 12),
(611, 579, 15),
(611, 541, 21),
(611, 123, 24),
(611, 154, 27),
(611, 166, 30),
(611, 345, 33),
(611, 657, 41),
(611, 440, 46),
(611, 277, 51),
(611, 259, 56),
(612, 52, 1),
(612, 198, 1),
(612, 355, 1),
(612, 26, 9),
(612, 666, 12),
(612, 579, 15),
(612, 541, 21),
(612, 123, 24),
(612, 154, 27),
(612, 166, 30),
(612, 345, 33),
(612, 657, 41),
(612, 440, 46),
(612, 277, 53),
(612, 259, 60),
(613, 271, 1),
(613, 467, 1),
(613, 183, 3),
(613, 249, 6),
(613, 326, 9),
(613, 455, 12),
(613, 71, 15),
(613, 245, 18),
(613, 579, 21),
(613, 215, 24),
(613, 91, 27),
(613, 281, 30),
(613, 677, 33),
(613, 510, 36),
(613, 55, 39),
(613, 558, 42),
(614, 20, 1),
(614, 91, 1),
(614, 183, 1),
(614, 249, 1),
(614, 271, 1),
(614, 324, 1),
(614, 467, 1),
(614, 326, 9),
(614, 455, 12),
(614, 71, 15),
(614, 245, 18),
(614, 579, 21),
(614, 215, 24),
(614, 651, 27),
(614, 281, 30),
(614, 677, 33),
(614, 510, 36),
(614, 55, 41),
(614, 558, 46),
(614, 647, 51),
(615, 51, 1),
(615, 323, 1),
(615, 105, 4),
(615, 500, 8),
(615, 345, 12),
(615, 326, 16),
(615, 285, 20),
(615, 405, 20),
(615, 18, 24),
(615, 33, 28),
(615, 427, 32),
(615, 579, 32),
(615, 241, 36),
(615, 360, 40),
(615, 506, 40),
(615, 504, 44),
(615, 318, 48),
(615, 5, 52),
(615, 597, 56),
(615, 558, 60),
(616, 2, 1),
(616, 476, 1),
(616, 4, 4),
(616, 126, 8),
(616, 386, 12),
(616, 638, 16),
(616, 736, 20),
(616, 5, 24),
(616, 258, 28),
(616, 275, 32),
(616, 59, 36),
(616, 504, 40),
(616, 76, 44),
(616, 205, 48),
(617, 2, 1),
(617, 4, 1),
(617, 5, 1),
(617, 6, 1),
(617, 59, 1),
(617, 126, 1),
(617, 149, 1),
(617, 275, 1),
(617, 494, 1),
(617, 717, 1),
(617, 736, 1),
(617, 386, 12),
(617, 638, 16),
(617, 655, 20),
(617, 12, 24),
(617, 258, 28),
(617, 469, 32),
(617, 704, 36),
(617, 504, 40),
(617, 76, 44),
(617, 205, 48),
(617, 690, 52),
(619, 136, 1),
(619, 195, 5),
(619, 515, 10),
(619, 249, 15),
(619, 495, 20),
(619, 236, 25),
(619, 704, 30),
(619, 161, 35),
(619, 306, 40),
(619, 31, 45),
(619, 66, 51),
(619, 84, 55),
(619, 303, 60),
(620, 136, 1),
(620, 195, 1),
(620, 495, 1),
(620, 515, 1),
(620, 249, 15),
(620, 725, 20),
(620, 236, 25),
(620, 704, 30),
(620, 161, 35),
(620, 306, 40),
(620, 31, 45),
(620, 66, 53),
(620, 84, 59),
(620, 303, 66),
(621, 355, 1),
(621, 52, 5),
(621, 160, 10),
(621, 390, 15),
(621, 541, 20),
(621, 579, 25),
(621, 306, 35),
(621, 123, 40),
(621, 335, 45),
(621, 440, 50),
(621, 647, 55),
(622, 27, 1),
(622, 416, 1),
(622, 133, 4),
(622, 555, 12),
(622, 126, 16),
(622, 426, 20),
(622, 630, 24),
(622, 334, 28),
(622, 551, 36),
(622, 298, 40),
(622, 450, 44),
(622, 282, 48),
(622, 171, 52),
(622, 169, 56),
(623, 27, 1),
(623, 133, 1),
(623, 234, 1),
(623, 302, 1),
(623, 416, 1),
(623, 555, 12),
(623, 126, 16),
(623, 426, 20),
(623, 630, 24),
(623, 334, 28),
(623, 551, 36),
(623, 298, 40),
(623, 450, 46),
(623, 282, 52),
(623, 171, 58),
(623, 169, 64),
(624, 355, 1),
(624, 248, 5),
(624, 390, 10),
(624, 689, 15),
(624, 541, 20),
(624, 26, 25),
(624, 391, 30),
(624, 579, 35),
(624, 427, 40),
(624, 334, 45),
(624, 345, 50),
(624, 335, 55),
(624, 657, 60),
(624, 277, 65),
(625, 248, 1),
(625, 355, 1),
(625, 389, 1),
(625, 390, 1),
(625, 689, 15),
(625, 541, 20),
(625, 26, 25),
(625, 391, 30),
(625, 579, 35),
(625, 427, 40),
(625, 334, 45),
(625, 345, 50),
(625, 335, 57),
(625, 657, 64),
(625, 277, 71),
(626, 355, 1),
(626, 233, 5),
(626, 247, 10),
(626, 514, 15),
(626, 541, 20),
(626, 515, 30),
(626, 678, 35),
(626, 286, 40),
(626, 657, 45),
(626, 259, 55),
(627, 355, 1),
(627, 306, 6),
(627, 663, 18),
(627, 541, 24),
(627, 9, 30),
(627, 579, 36),
(627, 723, 42),
(627, 124, 48),
(627, 14, 55),
(627, 134, 60),
(627, 677, 66),
(627, 68, 72),
(628, 306, 1),
(628, 355, 1),
(628, 575, 1),
(628, 647, 1),
(628, 663, 18),
(628, 541, 24),
(628, 9, 30),
(628, 579, 36),
(628, 723, 42),
(628, 124, 48),
(628, 14, 57),
(628, 134, 64),
(628, 677, 72),
(628, 68, 80),
(629, 279, 1),
(629, 355, 1),
(629, 223, 6),
(629, 457, 12),
(629, 663, 18),
(629, 344, 24),
(629, 334, 30),
(629, 723, 36),
(629, 14, 42),
(629, 127, 48),
(629, 420, 54),
(629, 134, 60),
(629, 30, 66),
(629, 68, 72),
(630, 63, 1),
(630, 223, 1),
(630, 279, 1),
(630, 355, 1),
(630, 457, 1),
(630, 575, 1),
(630, 690, 1),
(630, 663, 18),
(630, 344, 24),
(630, 334, 30),
(630, 723, 36),
(630, 14, 42),
(630, 127, 48),
(630, 420, 57),
(630, 134, 64),
(630, 30, 72),
(630, 68, 80),
(631, 357, 1),
(631, 249, 5),
(631, 328, 10),
(631, 75, 15),
(631, 613, 20),
(631, 627, 20),
(631, 652, 20),
(631, 579, 25),
(631, 51, 30),
(631, 208, 35),
(631, 306, 40),
(631, 16, 45),
(631, 211, 50),
(631, 329, 55),
(631, 220, 60),
(632, 248, 1),
(632, 535, 1),
(632, 390, 8),
(632, 44, 12),
(632, 75, 16),
(632, 52, 20),
(632, 12, 24),
(632, 138, 28),
(632, 123, 36),
(632, 391, 40),
(632, 335, 44),
(632, 185, 48),
(632, 334, 52),
(632, 277, 56),
(633, 233, 1),
(633, 153, 4),
(633, 52, 8),
(633, 517, 12),
(633, 26, 16),
(633, 288, 20),
(633, 732, 24),
(633, 123, 32),
(633, 541, 36),
(633, 59, 44),
(633, 159, 52),
(633, 420, 56),
(633, 440, 60),
(634, 52, 1),
(634, 145, 1),
(634, 153, 1),
(634, 233, 1),
(634, 517, 12),
(634, 26, 16),
(634, 288, 20),
(634, 732, 24),
(634, 123, 32),
(634, 541, 36),
(634, 59, 44),
(634, 159, 54),
(634, 420, 60),
(634, 440, 66),
(635, 52, 1),
(635, 145, 1),
(635, 153, 1),
(635, 233, 1),
(635, 694, 1),
(635, 517, 12),
(635, 26, 16),
(635, 288, 20),
(635, 732, 24),
(635, 123, 32),
(635, 541, 36),
(635, 59, 44),
(635, 159, 54),
(635, 420, 60),
(635, 440, 68),
(635, 312, 76),
(636, 180, 1),
(636, 636, 1),
(636, 217, 6),
(636, 638, 12),
(636, 218, 18),
(636, 75, 24),
(636, 543, 30),
(636, 353, 36),
(636, 76, 42),
(636, 664, 48),
(636, 16, 54),
(636, 150, 60),
(636, 220, 66),
(637, 150, 1),
(637, 180, 1),
(637, 203, 1),
(637, 211, 1),
(637, 217, 1),
(637, 220, 1),
(637, 279, 1),
(637, 496, 1),
(637, 636, 1),
(637, 638, 1),
(637, 664, 1),
(637, 723, 1),
(637, 218, 18),
(637, 75, 24),
(637, 543, 30),
(637, 353, 36),
(637, 76, 42),
(637, 297, 48),
(637, 16, 54),
(637, 310, 62),
(637, 206, 70),
(637, 498, 78),
(638, 299, 1),
(638, 355, 1),
(638, 494, 1),
(638, 732, 1),
(638, 390, 7),
(638, 495, 14),
(638, 147, 21),
(638, 511, 28),
(638, 389, 35),
(638, 664, 42),
(638, 533, 49),
(638, 657, 56),
(638, 335, 63),
(638, 100, 70),
(639, 299, 1),
(639, 355, 1),
(639, 494, 1),
(639, 732, 1),
(639, 585, 7),
(639, 495, 14),
(639, 147, 21),
(639, 511, 28),
(639, 522, 35),
(639, 664, 42),
(639, 533, 49),
(639, 657, 56),
(639, 631, 63),
(639, 100, 70),
(640, 299, 1),
(640, 355, 1),
(640, 494, 1),
(640, 732, 1),
(640, 375, 7),
(640, 495, 14),
(640, 147, 21),
(640, 511, 28),
(640, 258, 35),
(640, 664, 42),
(640, 533, 49),
(640, 657, 56),
(640, 349, 63),
(640, 100, 70),
(643, 18, 1),
(643, 153, 1),
(643, 207, 1),
(643, 430, 1),
(643, 579, 8),
(643, 123, 16),
(643, 190, 24),
(643, 219, 40),
(643, 251, 48),
(643, 206, 64),
(643, 327, 72),
(643, 440, 80),
(643, 57, 88),
(644, 18, 1),
(644, 153, 1),
(644, 430, 1),
(644, 681, 1),
(644, 579, 8),
(644, 123, 16),
(644, 738, 24),
(644, 685, 40),
(644, 250, 48),
(644, 679, 64),
(644, 327, 72),
(644, 440, 80),
(644, 61, 88),
(649, 248, 1),
(649, 494, 1),
(649, 543, 7),
(649, 390, 14),
(649, 202, 21),
(649, 217, 28),
(649, 391, 35),
(649, 378, 49),
(649, 76, 56),
(649, 567, 63),
(649, 737, 70),
(649, 363, 77),
(649, 669, 84),
(649, 550, 91),
(659, 355, 1),
(659, 416, 1),
(659, 345, 6),
(659, 494, 9),
(659, 414, 12),
(659, 215, 15),
(659, 147, 18),
(659, 78, 21),
(659, 138, 24),
(659, 66, 27),
(659, 664, 30),
(659, 657, 33),
(659, 171, 36),
(659, 646, 39),
(660, 345, 1),
(660, 355, 1),
(660, 416, 1),
(660, 494, 9),
(660, 414, 12),
(660, 215, 15),
(660, 147, 18),
(660, 78, 23),
(660, 138, 28),
(660, 66, 33),
(660, 664, 38),
(660, 657, 43),
(660, 171, 48),
(660, 646, 53),
(660, 282, 58),
(661, 271, 1),
(661, 494, 5),
(661, 180, 10),
(661, 215, 15),
(661, 7, 20),
(661, 12, 25),
(661, 9, 30),
(661, 663, 35),
(661, 625, 40),
(661, 529, 45),
(661, 230, 50),
(662, 180, 1),
(662, 200, 1),
(662, 217, 1),
(662, 271, 1),
(662, 494, 1),
(662, 215, 15),
(662, 7, 22),
(662, 12, 29),
(662, 9, 36),
(662, 663, 43),
(662, 625, 50),
(662, 529, 57),
(662, 230, 64),
(663, 180, 1),
(663, 200, 1),
(663, 217, 1),
(663, 220, 1),
(663, 271, 1),
(663, 494, 1),
(663, 215, 15),
(663, 7, 22),
(663, 12, 29),
(663, 9, 38),
(663, 663, 47),
(663, 625, 56),
(663, 529, 65),
(663, 230, 74),
(663, 68, 83),
(674, 355, 1),
(674, 22, 4),
(674, 666, 8),
(674, 94, 12),
(674, 366, 16),
(674, 732, 20),
(674, 579, 24),
(674, 711, 28),
(674, 123, 33),
(674, 59, 36),
(674, 444, 40),
(674, 185, 44),
(675, 22, 1),
(675, 79, 1),
(675, 355, 1),
(675, 427, 1),
(675, 666, 1),
(675, 94, 12),
(675, 366, 16),
(675, 732, 20),
(675, 579, 24),
(675, 711, 28),
(675, 123, 35),
(675, 59, 40),
(675, 444, 46),
(675, 185, 52),
(675, 282, 58),
(677, 355, 1),
(677, 195, 3),
(677, 140, 6),
(677, 106, 9),
(677, 118, 18),
(677, 477, 21),
(677, 360, 30),
(677, 506, 30),
(677, 485, 33),
(679, 248, 1),
(679, 556, 4),
(679, 35, 8),
(679, 9, 12),
(679, 391, 16),
(679, 579, 20),
(679, 427, 24),
(679, 511, 28),
(679, 334, 32),
(679, 335, 36),
(679, 470, 40),
(679, 657, 44),
(679, 533, 48),
(680, 35, 1),
(680, 248, 1),
(680, 556, 1),
(680, 9, 12),
(680, 391, 16),
(680, 579, 20),
(680, 427, 24),
(680, 511, 28),
(680, 334, 32),
(680, 335, 38),
(680, 470, 44),
(680, 657, 50),
(680, 533, 56),
(682, 654, 1),
(682, 653, 3),
(682, 172, 6),
(682, 162, 9),
(682, 23, 12),
(682, 30, 18),
(682, 215, 21),
(682, 408, 24),
(682, 479, 27),
(682, 91, 30),
(682, 84, 33),
(682, 409, 36),
(682, 572, 39),
(683, 24, 1),
(683, 172, 1),
(683, 292, 1),
(683, 653, 1),
(683, 654, 1),
(683, 140, 9),
(683, 23, 12),
(683, 162, 15),
(683, 30, 18),
(683, 215, 21),
(683, 408, 24),
(683, 479, 27),
(683, 91, 30),
(683, 84, 33),
(683, 409, 36),
(683, 572, 39),
(683, 478, 42),
(684, 654, 1),
(684, 455, 3),
(684, 23, 9),
(684, 162, 12),
(684, 196, 15),
(684, 531, 18),
(684, 636, 21),
(684, 115, 24),
(684, 184, 27),
(684, 728, 30),
(684, 456, 33),
(684, 114, 36),
(684, 182, 39),
(685, 455, 1),
(685, 654, 1),
(685, 23, 9),
(685, 162, 12),
(685, 196, 15),
(685, 531, 18),
(685, 636, 21),
(685, 115, 24),
(685, 184, 27),
(685, 728, 30),
(685, 456, 33),
(685, 114, 36),
(685, 182, 39),
(685, 626, 42),
(686, 316, 3),
(686, 734, 6),
(686, 446, 9),
(686, 457, 12),
(686, 477, 15),
(686, 651, 18),
(686, 579, 21),
(686, 427, 24),
(686, 483, 27),
(686, 656, 31),
(686, 239, 33),
(686, 688, 36),
(686, 647, 39),
(687, 316, 1),
(687, 515, 1),
(687, 734, 1),
(687, 446, 9),
(687, 457, 12),
(687, 477, 15),
(687, 651, 18),
(687, 579, 21),
(687, 427, 24),
(687, 483, 27),
(687, 656, 33),
(687, 239, 37),
(687, 688, 42),
(687, 647, 47),
(688, 416, 1),
(688, 729, 4),
(688, 248, 12),
(688, 249, 16),
(688, 18, 20),
(688, 521, 24),
(688, 579, 28),
(688, 306, 32),
(688, 502, 36),
(688, 560, 40),
(688, 121, 44),
(689, 416, 1),
(689, 574, 1),
(689, 729, 1),
(689, 248, 12),
(689, 249, 16),
(689, 18, 20),
(689, 521, 24),
(689, 579, 28),
(689, 306, 32),
(689, 502, 36),
(689, 560, 42),
(689, 121, 48),
(689, 631, 54),
(690, 589, 1),
(690, 4, 5),
(690, 662, 15),
(690, 149, 20),
(690, 463, 25),
(690, 716, 30),
(690, 690, 35),
(690, 583, 50),
(691, 4, 1),
(691, 589, 1),
(691, 662, 15),
(691, 149, 20),
(691, 463, 25),
(691, 716, 30),
(691, 690, 35),
(691, 583, 52),
(691, 440, 66),
(692, 615, 1),
(692, 215, 10),
(692, 20, 15),
(692, 585, 20),
(692, 306, 25),
(692, 716, 30),
(692, 657, 35),
(692, 31, 40),
(692, 66, 45),
(692, 417, 50),
(692, 119, 55),
(693, 127, 1),
(693, 215, 1),
(693, 292, 1),
(693, 615, 1),
(693, 20, 15),
(693, 585, 20),
(693, 306, 25),
(693, 716, 30),
(693, 657, 35),
(693, 31, 42),
(693, 66, 49),
(693, 417, 56),
(693, 119, 63),
(694, 416, 1),
(694, 662, 1),
(694, 683, 8),
(694, 494, 12),
(694, 89, 16),
(694, 78, 20),
(694, 712, 24),
(694, 443, 28),
(694, 684, 32),
(694, 685, 36),
(694, 176, 40),
(694, 679, 44),
(695, 78, 1),
(695, 89, 1),
(695, 141, 1),
(695, 173, 1),
(695, 176, 1),
(695, 416, 1),
(695, 443, 1),
(695, 494, 1),
(695, 662, 1),
(695, 679, 1),
(695, 683, 1),
(695, 684, 1),
(695, 685, 1),
(695, 712, 1),
(696, 662, 1),
(696, 517, 4),
(696, 18, 8),
(696, 91, 12),
(696, 52, 16),
(696, 160, 20),
(696, 629, 24),
(696, 522, 28),
(696, 123, 32),
(696, 677, 40),
(696, 171, 44),
(696, 307, 48),
(697, 18, 1),
(697, 517, 1),
(697, 662, 1),
(697, 91, 12),
(697, 52, 16),
(697, 160, 20),
(697, 629, 24),
(697, 522, 28),
(697, 123, 32),
(697, 677, 42),
(697, 171, 48),
(697, 307, 54),
(697, 259, 60),
(697, 287, 66),
(698, 271, 1),
(698, 467, 1),
(698, 181, 4),
(698, 18, 8),
(698, 326, 12),
(698, 531, 16),
(698, 405, 20),
(698, 33, 24),
(698, 684, 28),
(698, 422, 32),
(698, 241, 36),
(698, 318, 40),
(698, 360, 44),
(698, 281, 48),
(698, 55, 52),
(698, 312, 56),
(699, 18, 1),
(699, 181, 1),
(699, 271, 1),
(699, 467, 1),
(699, 326, 12),
(699, 531, 16),
(699, 405, 20),
(699, 33, 24),
(699, 684, 28),
(699, 422, 32),
(699, 241, 36),
(699, 318, 42),
(699, 360, 48),
(699, 281, 54),
(699, 55, 60),
(699, 312, 66),
(700, 42, 1),
(700, 52, 1),
(700, 91, 1),
(700, 110, 1),
(700, 118, 1),
(700, 140, 1),
(700, 150, 1),
(700, 271, 1),
(700, 299, 1),
(700, 662, 1),
(700, 664, 1),
(700, 535, 5),
(700, 494, 10),
(700, 37, 15),
(700, 655, 20),
(700, 360, 25),
(700, 162, 30),
(700, 408, 35),
(700, 572, 40),
(700, 478, 45),
(700, 409, 50),
(700, 347, 55),
(701, 306, 1),
(701, 136, 8),
(701, 9, 12),
(701, 181, 16),
(701, 199, 20),
(701, 641, 24),
(701, 66, 28),
(701, 666, 32),
(701, 529, 36),
(701, 657, 40),
(701, 231, 44),
(701, 303, 48),
(701, 182, 52),
(701, 575, 56),
(702, 431, 1),
(702, 662, 1),
(702, 89, 10),
(702, 683, 15),
(702, 91, 20),
(702, 443, 25),
(702, 712, 30),
(702, 510, 35),
(702, 594, 35),
(702, 141, 40),
(702, 456, 45),
(702, 646, 50),
(702, 185, 55),
(702, 679, 60),
(703, 284, 1),
(703, 274, 5),
(703, 585, 10),
(703, 215, 15),
(703, 18, 20),
(703, 521, 25),
(703, 360, 30),
(703, 522, 35),
(703, 572, 40),
(703, 620, 50),
(703, 409, 55),
(703, 631, 60),
(704, 2, 1),
(704, 153, 10),
(704, 476, 15),
(704, 215, 20),
(704, 716, 25),
(704, 499, 30),
(704, 126, 41),
(704, 59, 45),
(704, 417, 50),
(705, 2, 1),
(705, 6, 1),
(705, 153, 1),
(705, 476, 15),
(705, 215, 20),
(705, 716, 25),
(705, 499, 30),
(705, 126, 43),
(705, 59, 49),
(705, 417, 56),
(706, 2, 1),
(706, 6, 1),
(706, 153, 1),
(706, 200, 1),
(706, 463, 1),
(706, 667, 1),
(706, 476, 15),
(706, 215, 20),
(706, 716, 25),
(706, 499, 30),
(706, 126, 43),
(706, 59, 49),
(706, 417, 58),
(707, 27, 1),
(707, 194, 1),
(707, 689, 12),
(707, 120, 16),
(707, 391, 20),
(707, 162, 24),
(707, 505, 28),
(707, 327, 32),
(707, 222, 36),
(707, 456, 40),
(707, 374, 44),
(707, 239, 48),
(707, 347, 52),
(708, 27, 1),
(708, 354, 8),
(708, 105, 12),
(708, 727, 16),
(708, 300, 20),
(708, 272, 24),
(708, 308, 28),
(708, 126, 32),
(708, 450, 36),
(708, 331, 40),
(708, 731, 44),
(708, 135, 48),
(708, 238, 52),
(709, 27, 1),
(709, 354, 1),
(709, 553, 1),
(709, 105, 12),
(709, 727, 16),
(709, 300, 20),
(709, 272, 24),
(709, 308, 28),
(709, 126, 32),
(709, 450, 36),
(709, 331, 40),
(709, 731, 44),
(709, 135, 48),
(709, 238, 52),
(712, 284, 1),
(712, 500, 1),
(712, 467, 6),
(712, 126, 9),
(712, 326, 12),
(712, 476, 15),
(712, 36, 18),
(712, 52, 21),
(712, 320, 24),
(712, 334, 27),
(712, 504, 30),
(712, 123, 33),
(712, 664, 36),
(712, 55, 39),
(712, 150, 42),
(713, 59, 1),
(713, 284, 1),
(713, 467, 1),
(713, 500, 1),
(713, 725, 1),
(713, 126, 9),
(713, 326, 12),
(713, 476, 15),
(713, 36, 18),
(713, 52, 21),
(713, 320, 24),
(713, 334, 27),
(713, 504, 30),
(713, 123, 33),
(713, 664, 36),
(713, 55, 41),
(713, 150, 46),
(713, 574, 51),
(714, 2, 1),
(714, 279, 4),
(714, 648, 8),
(714, 149, 12),
(714, 52, 20),
(714, 13, 24),
(714, 723, 28),
(714, 646, 32),
(714, 14, 36),
(714, 543, 40),
(714, 529, 44),
(714, 663, 49),
(714, 310, 52),
(715, 2, 1),
(715, 279, 1),
(715, 411, 1),
(715, 648, 1),
(715, 149, 12),
(715, 52, 20),
(715, 13, 24),
(715, 723, 28),
(715, 646, 32),
(715, 14, 36),
(715, 543, 40),
(715, 529, 44),
(715, 663, 51),
(715, 310, 56),
(715, 65, 62),
(716, 270, 1),
(716, 360, 5),
(716, 33, 10),
(716, 422, 15),
(716, 427, 20),
(716, 23, 25),
(716, 478, 30),
(716, 308, 35),
(716, 408, 40),
(716, 331, 45),
(716, 664, 50),
(716, 257, 55),
(716, 409, 60),
(716, 292, 65),
(716, 100, 75),
(716, 440, 80),
(716, 259, 85),
(717, 149, 1),
(717, 279, 1),
(717, 666, 5),
(717, 591, 10),
(717, 139, 15),
(717, 643, 20),
(717, 663, 25),
(717, 529, 30),
(717, 14, 35),
(717, 127, 40),
(717, 479, 45),
(717, 432, 50),
(717, 450, 55),
(717, 239, 60),
(717, 159, 65),
(717, 310, 70),
(717, 232, 75),
(717, 575, 80),
(717, 312, 85),
(719, 284, 1),
(719, 274, 7),
(719, 585, 14),
(719, 215, 21),
(719, 18, 28),
(719, 521, 35),
(719, 360, 42),
(719, 522, 49),
(719, 572, 56),
(719, 620, 70),
(719, 409, 77),
(719, 631, 84),
(719, 137, 91),
(721, 211, 1),
(721, 355, 6),
(721, 721, 12),
(721, 217, 18),
(721, 716, 24),
(721, 541, 30),
(721, 328, 36),
(721, 629, 42),
(721, 539, 48),
(721, 664, 54),
(721, 285, 60),
(721, 405, 60),
(721, 621, 72),
(721, 220, 78),
(721, 441, 84),
(721, 189, 90),
(722, 271, 1),
(722, 352, 3),
(722, 27, 6),
(722, 556, 12),
(722, 501, 15),
(722, 659, 18),
(722, 457, 21),
(722, 420, 24),
(722, 643, 27),
(722, 349, 30),
(722, 199, 33),
(722, 68, 36),
(723, 27, 1),
(723, 271, 1),
(723, 352, 1),
(723, 556, 12),
(723, 501, 15),
(723, 659, 20),
(723, 457, 25),
(723, 420, 30),
(723, 643, 35),
(723, 349, 40),
(723, 199, 45),
(723, 68, 50),
(724, 27, 1),
(724, 271, 1),
(724, 350, 1),
(724, 352, 1),
(724, 450, 1),
(724, 612, 1),
(724, 614, 1),
(724, 704, 1),
(724, 556, 12),
(724, 501, 15),
(724, 659, 20),
(724, 457, 25),
(724, 420, 30),
(724, 643, 37),
(724, 349, 44),
(724, 199, 51),
(724, 68, 58),
(725, 271, 1),
(725, 180, 3),
(725, 357, 6),
(725, 517, 9),
(725, 249, 12),
(725, 52, 15),
(725, 147, 18),
(725, 207, 21),
(725, 541, 24),
(725, 651, 27),
(725, 219, 30),
(725, 677, 33),
(725, 220, 36),
(726, 180, 1),
(726, 271, 1),
(726, 357, 1),
(726, 517, 9),
(726, 249, 12),
(726, 52, 15),
(726, 147, 20),
(726, 207, 25),
(726, 541, 30),
(726, 651, 35),
(726, 219, 40),
(726, 677, 45),
(726, 220, 50),
(727, 77, 1),
(727, 121, 1),
(727, 129, 1),
(727, 180, 1),
(727, 271, 1),
(727, 357, 1),
(727, 678, 1),
(727, 517, 9),
(727, 249, 12),
(727, 52, 15),
(727, 147, 20),
(727, 207, 25),
(727, 541, 30),
(727, 651, 32),
(727, 219, 44),
(727, 677, 51),
(727, 220, 58),
(728, 271, 1),
(728, 140, 6),
(728, 20, 9),
(728, 37, 12),
(728, 326, 15),
(728, 568, 18),
(728, 74, 21),
(728, 181, 24),
(728, 408, 27),
(728, 409, 33),
(729, 140, 1),
(729, 271, 1),
(729, 20, 9),
(729, 37, 12),
(729, 326, 15),
(729, 568, 20),
(729, 74, 25),
(729, 181, 30),
(729, 408, 35),
(729, 409, 45),
(730, 140, 1),
(730, 271, 1),
(730, 603, 1),
(730, 20, 9),
(730, 37, 12),
(730, 326, 15),
(730, 568, 20),
(730, 74, 25),
(730, 181, 30),
(730, 408, 37),
(730, 409, 51),
(736, 416, 1),
(736, 636, 5),
(736, 75, 10),
(736, 52, 15),
(736, 602, 21),
(736, 626, 25),
(736, 123, 35),
(736, 138, 40),
(737, 75, 1),
(737, 89, 1),
(737, 416, 1),
(737, 636, 1),
(737, 52, 15),
(737, 602, 23),
(737, 626, 29),
(737, 123, 43),
(737, 138, 50),
(737, 334, 57),
(737, 141, 64),
(738, 75, 1),
(738, 89, 1),
(738, 123, 1),
(738, 138, 1),
(738, 141, 1),
(738, 334, 1),
(738, 416, 1),
(738, 636, 1),
(738, 685, 1),
(738, 52, 15),
(738, 602, 23),
(738, 626, 29),
(738, 76, 36),
(738, 277, 43),
(738, 230, 50),
(738, 12, 57),
(738, 737, 64),
(742, 2, 1),
(742, 640, 6),
(742, 654, 12),
(742, 162, 18),
(742, 638, 24),
(742, 23, 30),
(742, 656, 36),
(742, 130, 42),
(742, 76, 48),
(742, 496, 54),
(743, 2, 1),
(743, 118, 1),
(743, 464, 1),
(743, 640, 1),
(743, 654, 1),
(743, 162, 18),
(743, 638, 24),
(743, 23, 32),
(743, 656, 40),
(743, 130, 48),
(743, 76, 56),
(743, 496, 64),
(744, 355, 1),
(744, 535, 4),
(744, 149, 8),
(744, 309, 16),
(744, 52, 20),
(744, 524, 24),
(744, 517, 28),
(744, 522, 32),
(744, 123, 36),
(744, 541, 40),
(744, 620, 44),
(744, 631, 48),
(747, 462, 1),
(747, 725, 5),
(747, 52, 10),
(747, 710, 15),
(747, 504, 20),
(747, 453, 25),
(747, 691, 30),
(747, 362, 35),
(747, 709, 40),
(747, 460, 45),
(747, 690, 50),
(748, 39, 1),
(748, 52, 1),
(748, 462, 1),
(748, 725, 1),
(748, 710, 15),
(748, 504, 20),
(748, 453, 25),
(748, 691, 30),
(748, 362, 35),
(748, 709, 42),
(748, 460, 49),
(748, 690, 56),
(749, 416, 1),
(749, 523, 1),
(749, 334, 4),
(749, 147, 8),
(749, 78, 12),
(749, 629, 16),
(749, 116, 24),
(749, 302, 28),
(749, 298, 32),
(749, 171, 36),
(749, 647, 44),
(750, 147, 1),
(750, 334, 1),
(750, 416, 1),
(750, 523, 1),
(750, 78, 12),
(750, 629, 16),
(750, 116, 24),
(750, 302, 28),
(750, 298, 34),
(750, 171, 40),
(750, 647, 52),
(751, 330, 1),
(751, 75, 4),
(751, 52, 8),
(751, 74, 12),
(751, 21, 16),
(751, 288, 20),
(751, 123, 24),
(751, 595, 28),
(751, 185, 32),
(751, 369, 36),
(751, 362, 40),
(751, 353, 44),
(751, 402, 48),
(752, 52, 1),
(752, 75, 1),
(752, 330, 1),
(752, 725, 1),
(752, 74, 12),
(752, 21, 16),
(752, 288, 20),
(752, 123, 26),
(752, 595, 32),
(752, 185, 38),
(752, 369, 44),
(752, 362, 50),
(752, 353, 56),
(752, 402, 62),
(753, 248, 1),
(753, 352, 1),
(753, 272, 5),
(753, 331, 10),
(753, 501, 15),
(753, 654, 20),
(753, 579, 25),
(753, 659, 35),
(753, 349, 40),
(753, 644, 45),
(753, 597, 50),
(754, 166, 1),
(754, 248, 1),
(754, 272, 1),
(754, 331, 1),
(754, 352, 1),
(754, 427, 1),
(754, 448, 1),
(754, 597, 1),
(754, 501, 15),
(754, 654, 20),
(754, 579, 25),
(754, 659, 37),
(754, 349, 44),
(754, 644, 51),
(754, 598, 63),
(755, 2, 1),
(755, 27, 1),
(755, 105, 4),
(755, 331, 8),
(755, 386, 12),
(755, 580, 16),
(755, 411, 20),
(755, 635, 25),
(755, 258, 28),
(755, 130, 32),
(755, 618, 36),
(755, 409, 40),
(755, 163, 44),
(756, 2, 1),
(756, 27, 1),
(756, 105, 1),
(756, 331, 1),
(756, 386, 12),
(756, 580, 16),
(756, 411, 20),
(756, 635, 27),
(756, 258, 32),
(756, 130, 38),
(756, 618, 44),
(756, 409, 50),
(756, 163, 56),
(757, 459, 1),
(757, 588, 5),
(757, 180, 10),
(757, 458, 15),
(757, 654, 20),
(757, 420, 25),
(757, 328, 30),
(757, 710, 35),
(757, 709, 45),
(757, 219, 50),
(757, 690, 55),
(757, 182, 60),
(758, 139, 1),
(758, 180, 1),
(758, 181, 1),
(758, 182, 1),
(758, 208, 1),
(758, 344, 1),
(758, 459, 1),
(758, 588, 1),
(758, 651, 1),
(758, 689, 1),
(758, 458, 15),
(758, 654, 20),
(758, 420, 25),
(758, 328, 30),
(758, 710, 37),
(758, 709, 51),
(758, 219, 58),
(758, 690, 65),
(759, 355, 1),
(759, 37, 4),
(759, 446, 8),
(759, 72, 12),
(759, 183, 16),
(759, 664, 24),
(759, 215, 28),
(759, 282, 32),
(759, 677, 36),
(759, 442, 40),
(759, 150, 44),
(759, 647, 48),
(760, 37, 1),
(760, 51, 1),
(760, 355, 1),
(760, 446, 1),
(760, 72, 12),
(760, 183, 16),
(760, 664, 24),
(760, 215, 30),
(760, 282, 36),
(760, 677, 42),
(760, 442, 48),
(760, 150, 54),
(760, 647, 60),
(761, 615, 1),
(761, 455, 4),
(761, 500, 8),
(761, 501, 12),
(761, 654, 16),
(761, 375, 20),
(761, 215, 24),
(761, 670, 28),
(761, 24, 32),
(761, 23, 36),
(762, 215, 1),
(762, 455, 1),
(762, 500, 1),
(762, 501, 1),
(762, 615, 1),
(762, 654, 16),
(762, 375, 22),
(762, 629, 28),
(762, 670, 34),
(762, 24, 40),
(762, 23, 46),
(762, 350, 52),
(763, 215, 1),
(763, 455, 1),
(763, 500, 1),
(763, 501, 1),
(763, 615, 1),
(763, 651, 1),
(763, 700, 1),
(763, 654, 16),
(763, 375, 22),
(763, 629, 28),
(763, 670, 34),
(763, 24, 40),
(763, 23, 46),
(763, 350, 52),
(763, 303, 58),
(764, 272, 1),
(764, 734, 1),
(764, 299, 6),
(764, 162, 9),
(764, 229, 12),
(764, 375, 15),
(764, 659, 18),
(764, 354, 21),
(764, 264, 24),
(764, 653, 27),
(764, 228, 30),
(764, 448, 33),
(764, 23, 36),
(764, 456, 39),
(764, 654, 42),
(764, 449, 45),
(764, 268, 48),
(765, 106, 1),
(765, 666, 1),
(765, 11, 5),
(765, 84, 10),
(765, 632, 15),
(765, 478, 20),
(765, 493, 25),
(765, 420, 30),
(765, 738, 35),
(765, 696, 40),
(765, 479, 45),
(765, 332, 50),
(765, 239, 55),
(765, 252, 60),
(766, 355, 1),
(766, 523, 5),
(766, 233, 10),
(766, 44, 15),
(766, 541, 20),
(766, 664, 25),
(766, 225, 30),
(766, 77, 35),
(766, 677, 40),
(766, 150, 45),
(766, 100, 50),
(766, 515, 55),
(766, 259, 60),
(767, 133, 1),
(767, 535, 1),
(767, 638, 1),
(768, 133, 1),
(768, 212, 1),
(768, 535, 1),
(768, 614, 1),
(768, 638, 1),
(768, 523, 4),
(768, 248, 8),
(768, 414, 12),
(768, 75, 16),
(768, 334, 20),
(768, 643, 24),
(768, 579, 28),
(768, 502, 32),
(768, 453, 36),
(768, 657, 40),
(768, 362, 44),
(769, 2, 1),
(769, 284, 1),
(769, 27, 5),
(769, 536, 10),
(769, 386, 15),
(769, 535, 20),
(769, 78, 25),
(769, 316, 30),
(769, 258, 35),
(769, 334, 40),
(769, 551, 45),
(769, 170, 50),
(769, 564, 55),
(769, 537, 60),
(770, 2, 1),
(770, 27, 1),
(770, 284, 1),
(770, 536, 1),
(770, 386, 15),
(770, 535, 20),
(770, 78, 25),
(770, 316, 30),
(770, 258, 35),
(770, 334, 40),
(770, 551, 47),
(770, 170, 54),
(770, 564, 61),
(770, 537, 68),
(771, 42, 1),
(771, 284, 1),
(771, 299, 5),
(771, 666, 10),
(771, 534, 15),
(771, 116, 20),
(771, 490, 25),
(771, 126, 30),
(771, 253, 35),
(771, 442, 40),
(771, 504, 45),
(771, 595, 50),
(771, 690, 55),
(771, 387, 60),
(773, 9, 1),
(773, 52, 1),
(773, 189, 1),
(773, 207, 1),
(773, 320, 1),
(773, 327, 1),
(773, 335, 1),
(773, 418, 1),
(773, 458, 1),
(773, 541, 1),
(773, 681, 1),
(773, 145, 15),
(773, 391, 20),
(773, 124, 25),
(773, 14, 30),
(773, 694, 35),
(773, 123, 45),
(773, 664, 50),
(773, 150, 55),
(773, 444, 60),
(776, 588, 1),
(776, 180, 4),
(776, 476, 8),
(776, 183, 12),
(776, 215, 16),
(776, 328, 20),
(776, 334, 24),
(776, 59, 32),
(776, 219, 36),
(776, 561, 40),
(776, 560, 44),
(776, 441, 48),
(776, 189, 52),
(777, 431, 1),
(777, 133, 5),
(777, 89, 10),
(777, 683, 15),
(777, 202, 20),
(777, 602, 25),
(777, 453, 30),
(777, 378, 35),
(777, 739, 40),
(777, 141, 45),
(777, 175, 50),
(777, 726, 55),
(777, 610, 60),
(778, 27, 1),
(778, 110, 1),
(778, 615, 1),
(778, 731, 1),
(778, 556, 6),
(778, 149, 12),
(778, 37, 18),
(778, 397, 24),
(778, 306, 30),
(778, 579, 36),
(778, 553, 42),
(778, 91, 48),
(778, 456, 54),
(778, 442, 60),
(780, 172, 1),
(780, 455, 1),
(780, 703, 5),
(780, 476, 10),
(780, 262, 15),
(780, 534, 20),
(780, 153, 25),
(780, 190, 30),
(780, 360, 40),
(780, 230, 45),
(780, 440, 55),
(781, 2, 1),
(781, 500, 1),
(781, 27, 4),
(781, 734, 8),
(781, 386, 12),
(781, 272, 16),
(781, 280, 20),
(781, 656, 24),
(781, 258, 28),
(781, 722, 32),
(781, 298, 36),
(781, 551, 44),
(781, 391, 48),
(781, 17, 52),
(781, 184, 56),
(781, 450, 60),
(789, 615, 1),
(789, 672, 1),
(790, 113, 1),
(790, 672, 1),
(791, 113, 1),
(791, 390, 1),
(791, 430, 1),
(791, 645, 1),
(791, 672, 1),
(791, 335, 7),
(791, 391, 14),
(791, 738, 21),
(791, 222, 28),
(791, 412, 35),
(791, 123, 42),
(791, 389, 49),
(791, 726, 56),
(791, 597, 63),
(791, 220, 70),
(791, 725, 77),
(791, 259, 84),
(792, 106, 1),
(792, 113, 1),
(792, 316, 1),
(792, 410, 1),
(792, 672, 1),
(792, 426, 7),
(792, 105, 14),
(792, 14, 21),
(792, 551, 28),
(792, 411, 35),
(792, 425, 42),
(792, 372, 49),
(792, 409, 56),
(792, 450, 63),
(792, 163, 70),
(792, 725, 77),
(792, 312, 84),
(793, 734, 1),
(793, 4, 5),
(793, 687, 10),
(793, 6, 15),
(793, 99, 20),
(793, 274, 25),
(793, 468, 25),
(793, 710, 30),
(793, 288, 35),
(793, 691, 40),
(793, 709, 45),
(793, 620, 55),
(793, 402, 60),
(793, 730, 65),
(793, 287, 70),
(794, 284, 1),
(794, 472, 1),
(794, 666, 5),
(794, 202, 10),
(794, 711, 15),
(794, 77, 20),
(794, 183, 25),
(794, 515, 30),
(794, 369, 40),
(794, 233, 45),
(794, 169, 50),
(794, 116, 55),
(794, 282, 60),
(794, 647, 65),
(794, 234, 70),
(795, 200, 1),
(795, 500, 1),
(795, 355, 5),
(795, 495, 10),
(795, 75, 15),
(795, 365, 20),
(795, 147, 25),
(795, 699, 30),
(795, 629, 35),
(795, 12, 40),
(795, 369, 45),
(795, 66, 50),
(795, 606, 55),
(795, 76, 60),
(795, 496, 65),
(795, 303, 70),
(796, 683, 1),
(796, 734, 1),
(796, 89, 5),
(796, 684, 10),
(796, 331, 15),
(796, 602, 20),
(796, 563, 25),
(796, 316, 30),
(796, 173, 35),
(796, 682, 40),
(796, 141, 45),
(796, 378, 50),
(796, 685, 55),
(796, 175, 60),
(796, 737, 70),
(797, 2, 1),
(797, 284, 5),
(797, 725, 10),
(797, 386, 15),
(797, 585, 20),
(797, 331, 25),
(797, 35, 30),
(797, 258, 35),
(797, 222, 40),
(797, 391, 45),
(797, 334, 50),
(797, 354, 55),
(797, 298, 60),
(797, 150, 65),
(797, 574, 70),
(798, 248, 1),
(798, 707, 1),
(798, 501, 5),
(798, 198, 10),
(798, 13, 20),
(798, 9, 25),
(798, 136, 30),
(798, 427, 35),
(798, 659, 40),
(798, 345, 45),
(798, 134, 50),
(798, 349, 55),
(798, 533, 60),
(798, 657, 65),
(798, 277, 70),
(799, 52, 1),
(799, 160, 1),
(799, 627, 5),
(799, 652, 5),
(799, 344, 10),
(799, 629, 15),
(799, 630, 20),
(799, 725, 25),
(799, 123, 30),
(799, 59, 35),
(799, 253, 40),
(799, 282, 45),
(799, 298, 50),
(799, 159, 55),
(799, 47, 60),
(799, 677, 65),
(799, 259, 70),
(800, 90, 1),
(800, 106, 1),
(800, 270, 1),
(800, 390, 1),
(800, 411, 1),
(800, 412, 1),
(800, 620, 8),
(800, 579, 16),
(800, 427, 24),
(800, 483, 32),
(800, 632, 40),
(800, 519, 48),
(800, 334, 56),
(800, 451, 72),
(800, 35, 80),
(800, 475, 88),
(801, 280, 1),
(801, 299, 1),
(801, 133, 6),
(801, 528, 12),
(801, 334, 18),
(801, 255, 24),
(801, 477, 30),
(801, 33, 36),
(801, 399, 42),
(801, 562, 48),
(801, 120, 54),
(801, 335, 60),
(801, 31, 66),
(801, 222, 72),
(801, 442, 78),
(801, 737, 84),
(801, 224, 90),
(802, 110, 1),
(802, 116, 1),
(802, 200, 1),
(802, 210, 1),
(802, 322, 1),
(802, 556, 1),
(802, 682, 1),
(802, 526, 9),
(802, 555, 18),
(802, 236, 27),
(802, 26, 36),
(802, 643, 45),
(802, 161, 54),
(802, 478, 63),
(802, 605, 72),
(802, 345, 81),
(802, 182, 90),
(802, 100, 99),
(803, 4, 1),
(803, 271, 1),
(803, 299, 1),
(803, 247, 7),
(803, 202, 14),
(803, 91, 21),
(803, 710, 28),
(803, 709, 35),
(803, 420, 42),
(803, 460, 49),
(803, 253, 56),
(803, 690, 63),
(804, 4, 1),
(804, 13, 1),
(804, 14, 1),
(804, 271, 1),
(804, 299, 1),
(804, 247, 7),
(804, 202, 14),
(804, 91, 21),
(804, 710, 28),
(804, 709, 35),
(804, 420, 42),
(804, 460, 49),
(804, 253, 56),
(804, 690, 63),
(804, 159, 70),
(805, 284, 1),
(805, 476, 10),
(805, 629, 15),
(805, 56, 20),
(805, 522, 25),
(805, 725, 30),
(805, 35, 35),
(805, 519, 40),
(805, 378, 45),
(805, 334, 50),
(805, 335, 55),
(805, 664, 60),
(805, 620, 65),
(805, 150, 70),
(806, 27, 1),
(806, 211, 1),
(806, 360, 5),
(806, 180, 10),
(806, 426, 15),
(806, 105, 20),
(806, 372, 25),
(806, 328, 30),
(806, 316, 35),
(806, 419, 40),
(806, 551, 45),
(806, 84, 50),
(806, 727, 55),
(806, 695, 60),
(806, 206, 65),
(806, 398, 70),
(807, 195, 1),
(807, 472, 1),
(807, 494, 1),
(807, 591, 1),
(807, 602, 1),
(807, 249, 8),
(807, 495, 16),
(807, 579, 24),
(807, 712, 32),
(807, 89, 40),
(807, 682, 48),
(807, 306, 56),
(807, 141, 64),
(807, 726, 72),
(807, 12, 80),
(807, 454, 88),
(807, 100, 96),
(808, 284, 1),
(808, 683, 1),
(808, 662, 8),
(808, 288, 16),
(808, 684, 24),
(808, 5, 32),
(808, 222, 40),
(809, 284, 1),
(809, 288, 1),
(809, 662, 1),
(809, 682, 1),
(809, 683, 1),
(809, 684, 24),
(809, 5, 32),
(809, 222, 40),
(809, 476, 56),
(809, 141, 64),
(809, 169, 72),
(809, 647, 80),
(809, 146, 88),
(809, 312, 96),
(810, 271, 1),
(810, 666, 8),
(810, 501, 12),
(810, 543, 17),
(810, 344, 20),
(810, 705, 28),
(810, 731, 32),
(810, 182, 36),
(811, 145, 1),
(811, 271, 1),
(811, 666, 1),
(811, 501, 12),
(811, 543, 19),
(811, 344, 24),
(811, 705, 36),
(811, 731, 42),
(811, 182, 48),
(812, 145, 1),
(812, 165, 1),
(812, 268, 1),
(812, 271, 1),
(812, 430, 1),
(812, 666, 1),
(812, 501, 12),
(812, 543, 19),
(812, 344, 24),
(812, 705, 38),
(812, 731, 46),
(812, 182, 54),
(812, 65, 62),
(813, 271, 1),
(813, 180, 6),
(813, 494, 8),
(813, 147, 12),
(813, 217, 17),
(813, 12, 20),
(813, 288, 24),
(813, 116, 28),
(813, 66, 32),
(813, 150, 36),
(814, 180, 1),
(814, 271, 1),
(814, 494, 1),
(814, 147, 12),
(814, 217, 19),
(814, 12, 24),
(814, 288, 30),
(814, 116, 36),
(814, 66, 42),
(814, 150, 48),
(815, 180, 1),
(815, 200, 1),
(815, 271, 1),
(815, 492, 1),
(815, 494, 1),
(815, 147, 12),
(815, 217, 19),
(815, 12, 24),
(815, 288, 30),
(815, 116, 38),
(815, 66, 46),
(815, 150, 54),
(815, 117, 62),
(816, 271, 1),
(816, 51, 8),
(816, 716, 12),
(816, 667, 17),
(816, 643, 20),
(816, 704, 24),
(816, 362, 28),
(816, 595, 32),
(816, 499, 36),
(817, 51, 1),
(817, 271, 1),
(817, 716, 12),
(817, 667, 19),
(817, 643, 24),
(817, 704, 30),
(817, 362, 36),
(817, 595, 42),
(817, 499, 48),
(818, 7, 1),
(818, 51, 1),
(818, 271, 1),
(818, 593, 1),
(818, 716, 12),
(818, 667, 19),
(818, 643, 24),
(818, 704, 30),
(818, 362, 38),
(818, 595, 46),
(818, 499, 54),
(819, 662, 1),
(819, 52, 5),
(819, 639, 10),
(819, 613, 15),
(819, 627, 15),
(819, 652, 15),
(819, 59, 20),
(819, 510, 25),
(819, 116, 30),
(819, 80, 35),
(819, 646, 40),
(819, 47, 45),
(820, 52, 1),
(820, 118, 1),
(820, 639, 1),
(820, 662, 1),
(820, 613, 15),
(820, 627, 15),
(820, 652, 15),
(820, 59, 20),
(820, 510, 27),
(820, 116, 34),
(820, 80, 41),
(820, 646, 48),
(820, 47, 55),
(821, 355, 1),
(821, 471, 4),
(821, 306, 8),
(821, 247, 12),
(821, 457, 16),
(821, 666, 20),
(821, 541, 24),
(821, 651, 32),
(821, 68, 36),
(822, 306, 1),
(822, 355, 1),
(822, 471, 1),
(822, 247, 12),
(822, 457, 16),
(822, 666, 22),
(822, 541, 28),
(822, 651, 40),
(822, 68, 46),
(823, 306, 1),
(823, 334, 1),
(823, 355, 1),
(823, 391, 1),
(823, 471, 1),
(823, 625, 1),
(823, 247, 12),
(823, 457, 16),
(823, 666, 22),
(823, 541, 28),
(823, 651, 42),
(823, 68, 50),
(824, 638, 1),
(825, 106, 1),
(825, 360, 1),
(825, 506, 1),
(825, 638, 1),
(826, 106, 1),
(826, 360, 1),
(826, 506, 1),
(826, 638, 1),
(826, 105, 4),
(826, 372, 8),
(826, 12, 12),
(826, 477, 16),
(826, 316, 20),
(826, 15, 24),
(826, 76, 28),
(826, 402, 32),
(826, 479, 36),
(826, 11, 40),
(826, 84, 44),
(826, 481, 48),
(827, 494, 1),
(827, 662, 1),
(827, 44, 4),
(827, 306, 8),
(827, 591, 12),
(827, 26, 16),
(827, 420, 20),
(827, 643, 24),
(827, 427, 28),
(827, 661, 32),
(827, 239, 36),
(828, 44, 1),
(828, 306, 1),
(828, 494, 1),
(828, 662, 1),
(828, 674, 1),
(828, 591, 12),
(828, 26, 16),
(828, 420, 22),
(828, 643, 28),
(828, 427, 34),
(828, 661, 40),
(828, 239, 46),
(828, 444, 52),
(829, 352, 1),
(829, 568, 1),
(829, 500, 4),
(829, 654, 8),
(829, 501, 12),
(829, 531, 16),
(829, 351, 21),
(829, 659, 24),
(829, 23, 32),
(829, 350, 36),
(830, 115, 1),
(830, 352, 1),
(830, 500, 1),
(830, 568, 1),
(830, 654, 1),
(830, 501, 12),
(830, 531, 16),
(830, 351, 23),
(830, 659, 28),
(830, 23, 40),
(830, 350, 46),
(830, 114, 52),
(831, 271, 1),
(831, 133, 4),
(831, 110, 8),
(831, 274, 12),
(831, 147, 16),
(831, 288, 21),
(831, 664, 25),
(831, 275, 28),
(831, 515, 32),
(831, 114, 36),
(831, 150, 40),
(832, 110, 1),
(832, 133, 1),
(832, 271, 1),
(832, 274, 12),
(832, 147, 16),
(832, 288, 21),
(832, 664, 27),
(832, 275, 32),
(832, 515, 38),
(832, 114, 44),
(832, 150, 50),
(832, 347, 56),
(833, 52, 7),
(833, 476, 14),
(833, 288, 21),
(833, 116, 28),
(833, 337, 35),
(833, 362, 42),
(833, 59, 49),
(834, 52, 1),
(834, 123, 1),
(834, 476, 1),
(834, 502, 1),
(834, 521, 1),
(834, 524, 1),
(834, 288, 21),
(834, 116, 30),
(834, 337, 39),
(834, 362, 48),
(834, 59, 57),
(834, 287, 66),
(835, 662, 1),
(835, 431, 5),
(835, 52, 10),
(835, 517, 15),
(835, 602, 20),
(835, 91, 26),
(835, 123, 30),
(835, 89, 35),
(835, 726, 40),
(835, 456, 45),
(836, 52, 1),
(836, 176, 1),
(836, 431, 1),
(836, 662, 1),
(836, 517, 15),
(836, 602, 20),
(836, 91, 28),
(836, 123, 34),
(836, 89, 41),
(836, 726, 48),
(836, 456, 55),
(836, 175, 62),
(837, 589, 1),
(837, 500, 5),
(837, 585, 10),
(837, 521, 15),
(837, 18, 20),
(837, 328, 25),
(837, 620, 30),
(837, 296, 35),
(837, 519, 40),
(838, 217, 1),
(838, 500, 1),
(838, 585, 1),
(838, 589, 1),
(838, 521, 15),
(838, 18, 20),
(838, 328, 27),
(838, 620, 35),
(838, 296, 41),
(838, 519, 48),
(838, 81, 55),
(839, 217, 1),
(839, 500, 1),
(839, 585, 1),
(839, 589, 1),
(839, 665, 1),
(839, 521, 15),
(839, 18, 20),
(839, 328, 27),
(839, 620, 37),
(839, 296, 45),
(839, 519, 54),
(839, 81, 63),
(840, 27, 1),
(840, 729, 1),
(841, 27, 1),
(841, 272, 1),
(841, 505, 1),
(841, 703, 1),
(841, 729, 1),
(841, 6, 4),
(841, 7, 8),
(841, 354, 12),
(841, 476, 16),
(841, 153, 20),
(841, 154, 24),
(841, 269, 32),
(841, 334, 36),
(841, 230, 40),
(841, 159, 44),
(842, 27, 1),
(842, 272, 1),
(842, 288, 1),
(842, 505, 1),
(842, 654, 1),
(842, 729, 1),
(842, 126, 4),
(842, 629, 8),
(842, 354, 12),
(842, 476, 16),
(842, 80, 20),
(842, 504, 24),
(842, 19, 28),
(842, 59, 32),
(842, 334, 36),
(842, 184, 44),
(843, 535, 1),
(843, 734, 1),
(843, 400, 5),
(843, 72, 10),
(843, 78, 15),
(843, 288, 20),
(843, 262, 25),
(843, 138, 30),
(843, 537, 35),
(843, 102, 45),
(843, 536, 50),
(844, 72, 1),
(844, 400, 1),
(844, 535, 1),
(844, 574, 1),
(844, 734, 1),
(844, 78, 15),
(844, 288, 20),
(844, 262, 25),
(844, 138, 30),
(844, 537, 35),
(844, 102, 49),
(844, 536, 51),
(845, 47, 1),
(845, 613, 1),
(845, 627, 1),
(845, 652, 1),
(845, 247, 14),
(845, 457, 21),
(845, 142, 28),
(845, 16, 42),
(845, 677, 49),
(846, 20, 1),
(846, 247, 6),
(846, 52, 12),
(846, 12, 18),
(846, 142, 24),
(846, 345, 30),
(846, 123, 36),
(846, 362, 42),
(846, 150, 48),
(847, 20, 1),
(847, 52, 1),
(847, 247, 1),
(847, 678, 1),
(847, 12, 18),
(847, 142, 24),
(847, 345, 32),
(847, 123, 40),
(847, 362, 48),
(847, 150, 56),
(848, 4, 1),
(848, 47, 1),
(848, 215, 1),
(848, 271, 1),
(848, 431, 1),
(848, 667, 1),
(850, 180, 1),
(850, 589, 1),
(850, 734, 5),
(850, 52, 10),
(850, 218, 15),
(850, 75, 20),
(850, 102, 25),
(850, 211, 35),
(850, 123, 40),
(850, 208, 45),
(850, 369, 50),
(850, 81, 55),
(851, 52, 1),
(851, 180, 1),
(851, 329, 1),
(851, 589, 1),
(851, 734, 1),
(851, 218, 15),
(851, 75, 20),
(851, 102, 25),
(851, 211, 39),
(851, 123, 46),
(851, 208, 53),
(851, 369, 60),
(851, 81, 67),
(852, 355, 1),
(852, 523, 1),
(852, 200, 5),
(852, 51, 10),
(852, 136, 15),
(852, 70, 20),
(852, 77, 25),
(852, 641, 30),
(852, 666, 35),
(852, 515, 40),
(852, 647, 45),
(853, 51, 1),
(853, 200, 1),
(853, 355, 1),
(853, 435, 1),
(853, 436, 1),
(853, 523, 1),
(853, 136, 15),
(853, 70, 20),
(853, 77, 25),
(853, 641, 30),
(853, 666, 35),
(853, 515, 40),
(853, 647, 45),
(853, 688, 50),
(854, 27, 1),
(854, 729, 1),
(854, 24, 6),
(854, 386, 12),
(854, 476, 18),
(854, 643, 24),
(854, 23, 30),
(854, 258, 36),
(854, 420, 42),
(854, 551, 48),
(854, 387, 54),
(854, 560, 60),
(855, 24, 1),
(855, 27, 1),
(855, 386, 1),
(855, 635, 1),
(855, 668, 1),
(855, 729, 1),
(855, 476, 18),
(855, 643, 24),
(855, 23, 30),
(855, 258, 36),
(855, 420, 42),
(855, 551, 48),
(855, 387, 54),
(855, 560, 60),
(855, 126, 66),
(856, 106, 1),
(856, 455, 1),
(856, 358, 5),
(856, 140, 10),
(856, 23, 15),
(856, 477, 20),
(856, 292, 25),
(856, 130, 30),
(856, 84, 35),
(856, 479, 40),
(856, 293, 45),
(857, 72, 1),
(857, 106, 1),
(857, 140, 1),
(857, 358, 1),
(857, 455, 1),
(857, 23, 15),
(857, 477, 20),
(857, 292, 25),
(857, 130, 30),
(857, 84, 37),
(857, 479, 44),
(857, 293, 51),
(858, 72, 1),
(858, 106, 1),
(858, 140, 1),
(858, 358, 1),
(858, 455, 1),
(858, 483, 1),
(858, 23, 15),
(858, 477, 20),
(858, 292, 25),
(858, 130, 30),
(858, 84, 37),
(858, 479, 46),
(858, 293, 55),
(858, 373, 64),
(859, 104, 1),
(859, 195, 1),
(859, 52, 4),
(859, 223, 8),
(859, 196, 12),
(859, 26, 16),
(859, 651, 20),
(859, 643, 24),
(859, 689, 28),
(859, 127, 33),
(859, 420, 36),
(859, 456, 40),
(859, 239, 44),
(860, 52, 1),
(860, 104, 1),
(860, 195, 1),
(860, 197, 1),
(860, 223, 1),
(860, 196, 12),
(860, 26, 16),
(860, 651, 20),
(860, 643, 24),
(860, 689, 28),
(860, 127, 35),
(860, 420, 40),
(860, 456, 46),
(860, 239, 52),
(861, 52, 1),
(861, 77, 1),
(861, 104, 1),
(861, 195, 1),
(861, 197, 1),
(861, 223, 1),
(861, 472, 1),
(861, 611, 1),
(861, 196, 12),
(861, 26, 16),
(861, 651, 20),
(861, 643, 24),
(861, 689, 28),
(861, 127, 35),
(861, 420, 40),
(861, 456, 48),
(861, 239, 56),
(861, 282, 64),
(862, 37, 1),
(862, 121, 1),
(862, 355, 1),
(862, 357, 1),
(862, 427, 1),
(862, 433, 1),
(862, 453, 1),
(862, 535, 1),
(862, 641, 1),
(862, 656, 1),
(862, 591, 9),
(862, 288, 12),
(862, 306, 15),
(862, 249, 18),
(862, 510, 23),
(862, 664, 28),
(862, 541, 35),
(862, 116, 42),
(862, 666, 49),
(862, 150, 56),
(863, 195, 1),
(863, 271, 1),
(863, 306, 1),
(863, 334, 1),
(863, 335, 1),
(863, 389, 1),
(863, 445, 12),
(863, 390, 16),
(863, 666, 20),
(863, 651, 24),
(863, 249, 31),
(863, 543, 36),
(863, 579, 42),
(863, 391, 48),
(863, 677, 54),
(864, 27, 1),
(864, 139, 1),
(864, 284, 1),
(864, 447, 1),
(864, 614, 15),
(864, 18, 20),
(864, 300, 25),
(864, 126, 30),
(864, 635, 35),
(864, 426, 45),
(864, 273, 50),
(864, 402, 55),
(865, 212, 1),
(865, 248, 1),
(865, 334, 1),
(865, 355, 1),
(865, 535, 1),
(865, 523, 15),
(865, 72, 20),
(865, 136, 25),
(865, 344, 30),
(865, 134, 35),
(865, 70, 40),
(865, 657, 45),
(865, 349, 55),
(865, 205, 60),
(865, 68, 65),
(865, 392, 70),
(867, 27, 1),
(867, 285, 1),
(867, 426, 1),
(867, 476, 1),
(867, 541, 1),
(867, 553, 1),
(867, 139, 12),
(867, 72, 16),
(867, 120, 20),
(867, 300, 24),
(867, 384, 28),
(867, 126, 38),
(867, 551, 44),
(867, 171, 50),
(867, 274, 56),
(867, 468, 56),
(867, 135, 62),
(868, 24, 1),
(868, 653, 5),
(868, 654, 10),
(868, 162, 15),
(868, 23, 20),
(868, 30, 25),
(868, 5, 30),
(868, 130, 35),
(868, 504, 40),
(868, 408, 45),
(868, 185, 50),
(869, 24, 1),
(869, 131, 1),
(869, 653, 1),
(869, 654, 1),
(869, 162, 15),
(869, 23, 20),
(869, 30, 25),
(869, 5, 30),
(869, 130, 35),
(869, 504, 40),
(869, 408, 45),
(869, 185, 50),
(870, 476, 1),
(870, 523, 5),
(870, 233, 10),
(870, 288, 15),
(870, 77, 20),
(870, 183, 25),
(870, 515, 30),
(870, 212, 35),
(870, 429, 40),
(870, 334, 45),
(870, 100, 50),
(870, 116, 60),
(871, 683, 1),
(871, 89, 10),
(871, 247, 15),
(871, 602, 20),
(871, 74, 25),
(871, 504, 30),
(871, 126, 35),
(871, 175, 40),
(871, 460, 45),
(871, 739, 50),
(871, 8, 55),
(871, 141, 60),
(872, 467, 1),
(872, 638, 1),
(873, 30, 1),
(873, 299, 1),
(873, 326, 1),
(873, 467, 1),
(873, 638, 1),
(873, 640, 4),
(873, 330, 8),
(873, 405, 12),
(873, 134, 16),
(873, 199, 21),
(873, 33, 24),
(873, 281, 28),
(873, 76, 32),
(873, 34, 36),
(873, 55, 40),
(873, 663, 44),
(873, 725, 48),
(873, 496, 52),
(874, 56, 1),
(874, 521, 6),
(874, 524, 12),
(874, 270, 18),
(874, 629, 24),
(874, 620, 30),
(874, 522, 36),
(874, 59, 42),
(874, 725, 48),
(874, 298, 54),
(874, 631, 60),
(878, 271, 1),
(878, 528, 5),
(878, 523, 10),
(878, 78, 15),
(878, 629, 20),
(878, 334, 25),
(878, 138, 30),
(878, 335, 40),
(878, 456, 45),
(878, 302, 50),
(878, 647, 55),
(879, 271, 1),
(879, 298, 1),
(879, 523, 1),
(879, 528, 1),
(879, 78, 15),
(879, 629, 20),
(879, 334, 25),
(879, 138, 30),
(879, 335, 44),
(879, 456, 51),
(879, 302, 58),
(879, 647, 65),
(880, 683, 1),
(880, 89, 7),
(880, 9, 14),
(880, 18, 21),
(880, 457, 28),
(880, 160, 35),
(880, 629, 42),
(880, 141, 56),
(880, 60, 63),
(880, 159, 77),
(881, 467, 1),
(881, 683, 1),
(881, 89, 7),
(881, 172, 14),
(881, 18, 21),
(881, 457, 28),
(881, 36, 35),
(881, 241, 42),
(881, 141, 56),
(881, 60, 63),
(881, 324, 70),
(881, 55, 77),
(882, 476, 7),
(882, 72, 14),
(882, 18, 21),
(882, 52, 28),
(882, 153, 35),
(882, 629, 42),
(882, 646, 49),
(882, 123, 56),
(882, 213, 63),
(882, 159, 77),
(883, 467, 1),
(883, 476, 7),
(883, 326, 14),
(883, 18, 21),
(883, 52, 28),
(883, 34, 35),
(883, 241, 42),
(883, 646, 49),
(883, 123, 56),
(883, 213, 63),
(883, 324, 70),
(883, 55, 77),
(884, 355, 1),
(884, 390, 1),
(884, 523, 6),
(884, 306, 12),
(884, 391, 18),
(884, 69, 24),
(884, 160, 30),
(884, 334, 36),
(884, 345, 42),
(884, 222, 54),
(884, 389, 60),
(884, 312, 66),
(885, 27, 1),
(885, 52, 1),
(885, 330, 1),
(885, 494, 1),
(886, 27, 1),
(886, 52, 1),
(886, 330, 1),
(886, 494, 1),
(886, 363, 6),
(886, 26, 12),
(886, 300, 18),
(886, 12, 24),
(886, 145, 30),
(886, 704, 36),
(886, 154, 42),
(886, 450, 48),
(886, 664, 54),
(886, 159, 61),
(886, 150, 66),
(886, 347, 72),
(887, 27, 1),
(887, 52, 1),
(887, 153, 1),
(887, 155, 1),
(887, 330, 1),
(887, 494, 1),
(887, 643, 1),
(887, 363, 6),
(887, 26, 12),
(887, 300, 18),
(887, 12, 24),
(887, 145, 30),
(887, 704, 36),
(887, 154, 42),
(887, 450, 48),
(887, 664, 54),
(887, 159, 63),
(887, 150, 70),
(887, 347, 78),
(890, 12, 1),
(890, 105, 1),
(890, 160, 1),
(890, 463, 1),
(890, 690, 8),
(890, 710, 16),
(890, 154, 24),
(890, 122, 32),
(890, 219, 48),
(890, 168, 56),
(890, 113, 64),
(890, 504, 72),
(890, 312, 80),
(890, 187, 88),
(891, 355, 1),
(891, 523, 1),
(891, 183, 4),
(891, 233, 8),
(891, 9, 12),
(891, 541, 16),
(891, 288, 20),
(891, 70, 24),
(891, 136, 28),
(891, 77, 32),
(891, 335, 36),
(891, 169, 40),
(891, 116, 44),
(891, 100, 48),
(891, 234, 52),
(893, 51, 1),
(893, 355, 6),
(893, 272, 18),
(893, 249, 24),
(893, 541, 30),
(893, 264, 36),
(893, 52, 42),
(893, 704, 48),
(893, 651, 54),
(893, 184, 60),
(893, 659, 66),
(893, 282, 72),
(893, 677, 78),
(893, 340, 90),
(894, 500, 1),
(894, 683, 1),
(894, 178, 6),
(894, 18, 12),
(894, 563, 18),
(894, 684, 24),
(894, 192, 30),
(894, 680, 36),
(894, 685, 42),
(894, 378, 48),
(894, 677, 54),
(894, 363, 60),
(894, 737, 66),
(894, 312, 72),
(894, 189, 78),
(895, 703, 1),
(895, 52, 6),
(895, 18, 12),
(895, 153, 18),
(895, 233, 24),
(895, 123, 30),
(895, 282, 42),
(895, 154, 48),
(895, 677, 54),
(895, 345, 60),
(895, 156, 66),
(895, 312, 72),
(895, 189, 78),
(896, 662, 1),
(896, 147, 6),
(896, 36, 12),
(896, 629, 18),
(896, 689, 24),
(896, 405, 30),
(896, 324, 36),
(896, 664, 42),
(896, 334, 48),
(896, 677, 54),
(896, 666, 60),
(896, 150, 66),
(896, 657, 72),
(897, 662, 1),
(897, 147, 6),
(897, 300, 12),
(897, 629, 18),
(897, 105, 24),
(897, 285, 30),
(897, 551, 36),
(897, 664, 42),
(897, 12, 48),
(897, 677, 54),
(897, 139, 60),
(897, 150, 66),
(897, 420, 72);